//##############################################################################
//                                                                            //
// D_INTERN.H                                                                 //
//                                                                            //
// Subsystem: Diffraktometrie/ Reflektometrie                                 //
//            allgemeine, intern genutzte Fenster                             //
// Benutzung durch andere Subsysteme erforderlich: NEIN                       //
//                                                                            //
//##############################################################################
//! Kommentierung und Aenderungen B. Buss, 2000/2001, HUB IfI

#include "internls\evrythng.h" // GermanVersion, SetInfo
#include "winresrc\rc_def.h"   // Ressourcen-IDs
#include <new.h>
#pragma hdrstop

#include "difrkmty\d_intern.h" // SCHNITTSTELLE fr diese Datei
#include "difrkmty\d_extern.h" // fr TPlotWindow

#include "datavisa\datavisa.h"
#include "internls\l_layer.h" //17.11.2002 fr extern lpDBase

//! neu: klier Allgemeine Einstellungen
#include "mespara\mespara.h"

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

//! Kurvendatenbasis
__declspec(dllimport) LPDataBase lpDBase;

//! neu: klier Allgemeine Einstellungen
extern TMeasurementParameter MeasurementParameter; // in M_MAIN.CPP
extern TMain Main; // in M_MAIN.CPP deklariertes Hauptprogramm

//#############################################################################
// globale Typen und Konstanten
//#############################################################################

const UINT _BEREICHDIGITS= 2;
const UINT _MINIDDIGITS= 2;
const UINT _MAXIDDIGITS= 2;
const UINT _MININTENSITYDIGITS= 2;
const UINT _MAXINTENSITYDIGITS= 2;

// Bezeichner korrespondieren mit den entsprechenden Enum-Typen
const char aOutputType[6][15] =
{
	"RL-Bitmap", "Raw Matrix", "Curve", "Number", "BarGraph", "Histogram"
};

const char aScaleType[3][15]= 
{
	"Logarithmic", "Linear", "User"
};

//#############################################################################
// sprachspezifische Konstanten
//#############################################################################

#ifdef GermanVersion
	static const char szMessageDlg[]= "Meldung";

	static const char szMsgLine300[]= "Farbbereich falsch!";
	static const char szMsgLine301[]= "Intensittsbereich falsch!";
	static const char szMsgLine302[]= "gewhlte Intensitt zu klein";
	static const char szMsgLine303[]= "MinIntensitt grer als MaxIntensitt";
	static const char szMsgLine304[]= "gewhlte Intensitt zu gro";
	static const char szMsgLine305[]= "Werte fuer Ordinateneinteilung 2 - 15";
	static const char szMsgLine306[]= "Werte fuer Abzisseneinteilung 2 - 15";
	static const char szMsgLine307[]= "Intensittsbereich [%.3f-->%.3f] ";
	static const char szMsgLine308[]= "Zeile %d mit %d Spalten";
	static const char szMsgLine309[]= "Daten in ein Bitmap wandeln...";
	static const char szMsgLine310[]= "Bereichsberschreitung !";
	static const char szMsgLine311[]= "User Skalierung - Farbwahl";
	static const char szMsgLine312[]= "Farbe %d";
	static const char szMsgLine313[]= "Int.bereiche";
	static const char szMsgLine314[]= "Intensitten";
	static const char szMsgLine315[]= "Bereich %d -> Farbe";
#else
	static const char szMessageDlg[]= "Message";

	static const char szMsgLine300[]= "Color-gamut falsely!";
	static const char szMsgLine301[]= "Intensity-area falsely!";
	static const char szMsgLine302[]= "selected intensity too small";
	static const char szMsgLine303[]= "Min intensity more largely than max intensity";
	static const char szMsgLine304[]= "selected intensity excessively";
	static const char szMsgLine305[]= "Values for y-axle organization 2 - 15";
	static const char szMsgLine306[]= "Values for x-axle organization 2 - 15";
	static const char szMsgLine307[]= "Intensity Range [%.3f-->%.3f] ";
	static const char szMsgLine308[]= "Row %d with %d Columns";
	static const char szMsgLine309[]= "Transform data to Bitmap...";
	static const char szMsgLine310[]= "Overflow !";
	static const char szMsgLine311[]= "User scaling - color choice";
	static const char szMsgLine312[]= "Color %d";
	static const char szMsgLine313[]= "Int.areas";
	static const char szMsgLine314[]= "Intensities";
	static const char szMsgLine315[]= "Area %d -> Color";
#endif

//##############################################################################
// TCurveFreeScalDlg
//##############################################################################

TCurveFreeScalDlg::TCurveFreeScalDlg(TPlotWindow *aPlotWindow) : TModalDlg( "USERSCAL", GetMainInstance() ), PlotWindow(0)
{
	PlotWindow= aPlotWindow;
};
//*****************************************************************************

int TCurveFreeScalDlg::GetFarbeId(UINT aBereich) {
	switch (aBereich) {
		case 0:
			return IDFarbe1;

		case 1:
			return IDFarbe2;

		case 2:
			return IDFarbe3;

		case 3:
			return IDFarbe4;

		case 4:
			return IDFarbe5;

		case 5:
			return IDFarbe6;

		case 6:
			return IDFarbe7;

		case 7:
			return IDFarbe8;

		default: // unbekannter Bereich
			return -1;
	}
}
//*****************************************************************************

int TCurveFreeScalDlg::GetBereichId(UINT aBereich) {
	switch (aBereich) {
		case 0:
			return IDBereich1;

		case 1:
			return IDBereich2;

		case 2:
			return IDBereich3;

		case 3:
			return IDBereich4;
			
		case 4:
			return IDBereich5;

		case 5:
			return IDBereich6;
				
		case 6:
			return IDBereich7;

		case 7:
			return IDBereich8;

		default: // unbekannter Bereich
			return -1;
	}
}
//*****************************************************************************

//! zum Initialisieren des Modaldialogs
BOOL TCurveFreeScalDlg::Dlg_OnInit(HWND, HWND hwndCtl, LPARAM lParam)
{
	char buf[MaxString];
	int i;

	//! die Funktion des neu erzeugten Fensters soll anders eingebaut werden...
	if (!PlotWindow->BSource->UserFarb)
		(new TCurveFreeScalColorWindow(GetMainInstance(), PlotWindow))->Show(); // registriert sich selbst als PlotWindow->BSource->UserFarb

	//Datum: 27.07.2002 TModalDlg::Dlg_OnInit(hwnd,hwndCtl,lParam);

	//! setze Intensitaeten und Farben im Dialog
	for (i= 0;i < 8;i++)
	{
		CtrlSetDouble(GetBereichId(i), PlotWindow->BSource->ber[i], _BEREICHDIGITS, _DECIMAL);
		CtrlSetLong(GetFarbeId(i), PlotWindow->BSource->farbe[i]);
	}
	//! setze Min und MaxIntensitaet im Dialog
	if (!GetDlgItemText(GetHandle(), IDBereichMax, (LPSTR)buf, 10))
	{
		CtrlSetDouble(IDBereichMin, PlotWindow->LowerBound, _MINIDDIGITS, _DECIMAL); 
		CtrlSetDouble(IDBereichMax, PlotWindow->UpperBound, _MAXIDDIGITS, _DECIMAL); 
	}
	CtrlSetLong(IDFarbeMin, 0 ); 
	CtrlSetLong(IDFarbeMax, ( PlotWindow->BSource ) ? PlotWindow->BSource->ColorTable.ColorMap.GetCount()-1 : 0); 

	return TRUE;
};
//*****************************************************************************

//! Ablaufsteuerung des Dialogs
void TCurveFreeScalDlg::Dlg_OnCommand(HWND, int id, HWND hwndCtl, UINT codeNotify)
{
	int i;

	switch (id)
	{			
		case cm_SetupParameters: //! im Falle von Button "Int. skalieren"
			PlotWindow->BSource->BereichDef();
			for (i= 0;i < 8;i++)
			{
				CtrlSetDouble(GetBereichId(i), PlotWindow->BSource->ber[i], _BEREICHDIGITS, _DECIMAL);
			}
			CanClose();
			PlotWindow->UpdateWnd();
			break;
			
		case IDOK: //! Return Taste bewirkt eine Ueberpruefung der Dialogeingaben
			CanClose();
			PlotWindow->UpdateWnd();
			break;
			
		case id_Standard: //! id_Standard wird abgefangen, aufgerufen durch den OK-Button
			if ( CanClose() )
			{
				LeaveDialog();
				EndDialog(GetHandle(), id);
			};
			PlotWindow->UpdateWnd();
			break;
			
		case IDCANCEL: //! im Falle Abbrechen Button
			LeaveDialog();
			EndDialog(GetHandle(), id);
			break;

		default:
			TModalDlg::Dlg_OnCommand(GetHandle(), id, hwndCtl, codeNotify);
	}
};
//*****************************************************************************

//! Ueberpruefung der internen Abhaengigkeiten im Dialog
BOOL TCurveFreeScalDlg::CanClose(void)
{
	float valueF;
	int valueI;
	BOOL bValid= TRUE;

	//! eingegebene Intensitaeten und Farben auf Zulaessigkeit ueberpruefen
	for (int i= 0;i < 8;i++)
	{
		valueF= CtrlGetDouble(GetBereichId(i), _BEREICHDIGITS, _DECIMAL, bValid);
		if (!bValid) return FALSE;
		else if (i == 0)
		{
			if (!(PlotWindow->LowerBound <= valueF))
			{
				CtrlSetDouble(GetBereichId(i), PlotWindow->BSource->ber[i], _BEREICHDIGITS, _DECIMAL);
				CtrlSetFocus(GetBereichId(i));
				MessageBox(szMsgLine301, szMessageDlg, MBINFO);
				return FALSE;
			}
			else
				PlotWindow->BSource->ber[i]= valueF;
		}
		else if (i == 7)
		{
			if (!(PlotWindow->UpperBound >= valueF) ||
					!(PlotWindow->BSource->ber[i - 1] <= valueF))
			{
				CtrlSetDouble(GetBereichId(i), PlotWindow->BSource->ber[i], _BEREICHDIGITS, _DECIMAL);
				CtrlSetFocus(GetBereichId(i));
				MessageBox(szMsgLine301, szMessageDlg, MBINFO);
				return FALSE;
			}
			else
				PlotWindow->BSource->ber[i]= valueF;
		}
		else if (!(PlotWindow->BSource->ber[i - 1] <= valueF))
		{
			CtrlSetDouble(GetBereichId(i), PlotWindow->BSource->ber[i], _BEREICHDIGITS, _DECIMAL);
			CtrlSetFocus(GetBereichId(i));
			MessageBox(szMsgLine301, szMessageDlg, MBINFO);
			return FALSE;
		}
		else
			PlotWindow->BSource->ber[i]= valueF;

		valueI= CtrlGetLong( GetFarbeId(i), bValid );
		if (!bValid) return FALSE;
		else if (i == 0)
		{
			if (!(0 <= valueI))
			{
				CtrlSetLong(GetFarbeId(i), PlotWindow->BSource->farbe[i]);
				CtrlSetFocus(GetFarbeId(i));
				MessageBox(szMsgLine300, szMessageDlg, MBINFO);
				return FALSE;
			}
			else
				PlotWindow->BSource->farbe[i]= valueI;
		}
		else if (i == 7)
		{
			if (!(255 >= valueI) ||
					!(PlotWindow->BSource->farbe[i - 1] <= valueI))
			{
				CtrlSetLong(GetFarbeId(i), PlotWindow->BSource->farbe[i]);
				CtrlSetFocus(GetFarbeId(i));
				MessageBox(szMsgLine300, szMessageDlg, MBINFO);
				return FALSE;
			}
			else
				PlotWindow->BSource->farbe[i]= valueI;
		}
		else if (!(PlotWindow->BSource->farbe[i - 1] <= valueI))
		{
			CtrlSetLong(GetFarbeId(i), PlotWindow->BSource->farbe[i]);
			CtrlSetFocus(GetFarbeId(i));
			MessageBox(szMsgLine300, szMessageDlg, MBINFO);
			return FALSE;
		}
		else
			PlotWindow->BSource->farbe[i]= valueI;
	}

	PlotWindow->EnablePaint();
	//! Farbverteilung neu berechnen
	PlotWindow->BSource->ColorDef();
	PlotWindow->BSource->UserFarb->UpdateWnd();
	return TRUE;
};
//*****************************************************************************

void TCurveFreeScalDlg::LeaveDialog(void)
{
	PlotWindow->EnablePaint();
};

//##############################################################################
// TCurveShowParamDlg
//##############################################################################

TCurveShowParamDlg::TCurveShowParamDlg(TPlotWindow *aPlotWindow) : TModalDlg( "DATASHOWPARAM", GetMainInstance() ), PlotWindow(0), hWndOutputT(0), hWndScaleT(0), hWndScrolldx(0), hWndScrolldy(0)
{
	PlotWindow= aPlotWindow;
	scrolldxpos= scrolldypos= 0;
	bSavedSecondaryCoor= FALSE;
};
//*****************************************************************************

BOOL TCurveShowParamDlg::Dlg_OnInit(HWND, HWND hwndCtl, LPARAM lParam)
//! initialisiert den Modaldialog fuer Visualising Options - Fehler 7,8,13
{
	BOOL id= 0;
	char buf[50];
	BOOL bValid= TRUE;

	hWndOutputT= Ctrl(id_ShowDataType);
	hWndScaleT= Ctrl(id_ScaleTypeY);
	hWndScrolldy= Ctrl(id_Bar);
	hWndScrolldx= Ctrl(id_Bar2);

	scrolldypos= PlotWindow->RLdy;
	scrolldxpos= PlotWindow->RLdx;

	SCROLLINFO scrInfo;
	scrInfo.cbSize= sizeof(SCROLLINFO);
	scrInfo.fMask= SIF_RANGE | SIF_POS;

	scrInfo.nMin= PlotWindow->scrolldyposmin;
	scrInfo.nMax= PlotWindow->scrolldyposmax;
	scrInfo.nPos= scrolldypos;
	SetScrollInfo(hWndScrolldy, SB_CTL, &scrInfo, TRUE);

	scrInfo.nMin= PlotWindow->scrolldxposmin;
	scrInfo.nMax= PlotWindow->scrolldxposmax;
	scrInfo.nPos= scrolldxpos;
	SetScrollInfo(hWndScrolldx, SB_CTL, &scrInfo, TRUE);

	//! Combobox fuer Darstellungsart
	if ( PlotWindow->WindowType != wtScan )
	{
		ComboBox_AddString(hWndOutputT, aOutputType[0]); // RL-Bitmap (nur AreaScan)
		ComboBox_AddString(hWndOutputT, aOutputType[1]); // Raw-Bitmap (nur AreaScan)
	}
	ComboBox_AddString(hWndOutputT, aOutputType[2]); // Kurve (immer)

	ComboBox_SelectString(hWndOutputT, 0, aOutputType[(PlotWindow->eOutputType - 1)]);
	ComboBox_AddString(hWndScaleT, aScaleType[0]);
	ComboBox_AddString(hWndScaleT, aScaleType[1]);
	ComboBox_AddString(hWndScaleT, aScaleType[2]);

	//! Intensitaetsskalierung User nur fuer Bitmaps gueltig
	switch ( PlotWindow->eOutputType ) {
		case otReciprokeLatticeBitmap:
		case otMatrixBitmap:
			ComboBox_SelectString(hWndScaleT, 0, aScaleType[(PlotWindow->CoorSys.zScal - 1)]);
			CtrlSetEnabled(cm_UserScal, TRUE);
			break;

		default:
			ComboBox_SelectString(hWndScaleT, 0, aScaleType[(PlotWindow->CoorSys.yScal - 1)]);
			ComboBox_DeleteString(hWndScaleT, 2);
			CtrlSetEnabled(cm_UserScal, FALSE);
	}

	// bei RL-Bitmap nur Winkeldarstellung
	bSavedSecondaryCoor= PlotWindow->bSecondaryCoor;
	if ( PlotWindow->eOutputType==otReciprokeLatticeBitmap ) PlotWindow->bSecondaryCoor= FALSE;

	//! betrifft Kanaele und Winkel
	CtrlSetChecked(id_X_Scala, !PlotWindow->bSecondaryCoor); //! Winkel
	CtrlSetChecked(id_Z_Scala, PlotWindow->bSecondaryCoor); //! Kanaele
	//! wenn kein PSD-Device als Detektor, dann Fkt. oder Energyspektrum aktiv: nicht waehlbar
	CtrlSetEnabled(id_X_Scala, PlotWindow->CanSwitchChannelAngle());
	CtrlSetEnabled(id_Z_Scala, PlotWindow->CanSwitchChannelAngle());

	//! falls Intensitaeten im Dialog nicht gesetzt, mache dies
	if ( !CtrlGetText(id_MaxIntensity, (LPSTR)buf, 10) )
	{
		CtrlSetDouble(id_MaxIntensity, PlotWindow->UpperBound, _MAXINTENSITYDIGITS, _DECIMAL);
		CtrlSetDouble(id_MinIntensity, PlotWindow->LowerBound, _MININTENSITYDIGITS, _DECIMAL);
	}

	//! falls dy nicht gueltig, setze dy
	if ( !CtrlGetText(id_dy1, buf, 1) ) {
		CtrlSetLong( id_dy1, PlotWindow->RLdy);
		CtrlSetFocus(id_dy1);
	}

	//! falls dx nicht gueltig, setze dx
	if ( !CtrlGetText(id_dx1, buf, 1) ) {
		CtrlSetLong(id_dx1, PlotWindow->RLdx);
		CtrlSetFocus(id_dx1);
	}

	//! falls tilesx leer, setze
	if ( !CtrlGetText(id_tilesx, buf, 1) ) {
		CtrlSetLong(id_tilesx, PlotWindow->tilesx);
		CtrlSetFocus(id_tilesx);
	}

	//! falls tilesy leer, setze
	if ( !CtrlGetText(id_tilesy, buf, 1) ) {
		CtrlSetLong(id_tilesy, PlotWindow->tilesy);
		CtrlSetFocus(id_tilesy);
	}

	//! groessere Punkte, xy Skalierung, y Punkte
	CtrlSetChecked(id_Dilatation, PlotWindow->bIncreasePP);
	CtrlSetChecked(id_XY_Scaling, PlotWindow->bXY_Scaling);

	//! Graustufen Checkbox setzen
	if (PlotWindow->BSource != NULL)
		CtrlSetChecked(id_Graustufen, PlotWindow->BSource->bGrayScalePalette);

	//! hier geaendert, da die Fkt nur fuer RL-Bitmap gueltig sind
	CtrlSetEnabled(id_XY_Scaling, PlotWindow->eOutputType==otReciprokeLatticeBitmap); //! <= MatrixBitmap
	
	BOOL bEnable= ( PlotWindow->eOutputType==otReciprokeLatticeBitmap || PlotWindow->eOutputType==otMatrixBitmap );
	CtrlSetEnabled(id_dy1, bEnable);
	CtrlSetEnabled(id_dx1, bEnable);
	CtrlSetEnabled(id_Bar, bEnable);
	CtrlSetEnabled(id_Bar2, bEnable);
	CtrlSetEnabled(id_Dilatation, bEnable);
	CtrlSetEnabled(id_Graustufen, bEnable);

	// gepunktete Kurven?
	CtrlSetChecked(id_Dotted, PlotWindow->m_Dotted); 
	CtrlSetEnabled(id_Dotted, PlotWindow->eOutputType==otCurve);

	// Filter verwenden?
	CtrlSetChecked( id_Filter, PlotWindow->m_HasFilter ); 
	CtrlSetEnabled( id_Filter, PlotWindow->eOutputType==otCurve );
	CtrlSetEnabled( id_FilterStrength, ( PlotWindow->eOutputType==otCurve && PlotWindow->m_HasFilter ) );
	CtrlSetDouble( id_FilterStrength, PlotWindow->m_FilterStrength, 1, _DECIMAL );
	return TRUE;
};
//*****************************************************************************

void TCurveShowParamDlg::Dlg_OnHScrollBar(HWND, HWND hwndctl, UINT code, int pos)
{
	//! Fehler 7,8
	//! dies nur, um laestige Warnungen auszuschalten...
	TModalDlg::Dlg_OnHScrollBar(GetHandle(), hwndctl, code, pos);

	SCROLLINFO scrInfo;
	scrInfo.cbSize= sizeof(SCROLLINFO);
	scrInfo.fMask= SIF_POS;

	if (hwndctl == hWndScrolldy)
	{
		switch (code)
		{
			case SB_LINEUP:
			case SB_PAGEUP:
				if (scrolldypos > PlotWindow->scrolldyposmin)
				{
					scrolldypos -= 50;
					PlotWindow->RLdy= scrolldypos;
					scrInfo.nPos= scrolldypos;
					SetScrollInfo(hWndScrolldy, SB_CTL, &scrInfo, TRUE);
					CtrlSetLong(id_dy1, PlotWindow->RLdy);
				}
				break;

			case SB_LINEDOWN:
			case SB_PAGEDOWN:
				if (scrolldypos < PlotWindow->scrolldyposmax)
				{
					scrolldypos += 50;
					PlotWindow->RLdy= scrolldypos;
					scrInfo.nPos= scrolldypos;
					SetScrollInfo(hWndScrolldy, SB_CTL, &scrInfo, TRUE);
					CtrlSetLong(id_dy1, PlotWindow->RLdy);
				}
				break;
		}
	}

	if (hwndctl == hWndScrolldx)
	{
		switch (code)
		{
			case SB_LINEUP:
			case SB_PAGEUP:
				if (scrolldxpos > PlotWindow->scrolldxposmin)
				{
					scrolldxpos -= 50;
					PlotWindow->RLdx= scrolldxpos;
					scrInfo.nPos= scrolldxpos;
					SetScrollInfo(hWndScrolldx,SB_CTL,&scrInfo,TRUE);
					CtrlSetLong(id_dx1, PlotWindow->RLdx);
				}
				break;

			case SB_LINEDOWN:
			case SB_PAGEDOWN:
				if (scrolldxpos < PlotWindow->scrolldxposmax)
				{
					scrolldxpos += 50;
					PlotWindow->RLdx= scrolldxpos;
					scrInfo.nPos= scrolldxpos;
					SetScrollInfo(hWndScrolldx,SB_CTL,&scrInfo,TRUE);
					CtrlSetLong(id_dx1, PlotWindow->RLdx);
				}
				break;
		}
	}
};
//*****************************************************************************

void TCurveShowParamDlg::Dlg_OnCommand(HWND, int id, HWND hwndCtl, UINT codeNotify)
{
	//! behandelt das Untermen Visualising Options und reagiert auf
	//! nderungen in Meneintrgen mit entsprechenden Reaktionen - Fehler 7,8,13
	switch (id)
	{			
		case cm_UserScal: { //! betrifft Button User Skalierung
			PlotWindow->UpdateWnd();
			TModalDlg *dlg= (TCurveFreeScalDlg *)new TCurveFreeScalDlg(PlotWindow);
			if ( dlg ) dlg->ExecuteDialog(GetHandle());
			_FREEOBJ(dlg);
			PlotWindow->UpdateWnd();
			break;
		}
			
		case cm_SetupParameters: //! betrifft Button "Neuzeichnen"
			CanClose();
			PlotWindow->UpdateWnd();
			break;
			
		case IDOK: //! IDOK wird abgefangen, da ein "Enter" auch ein IDOK liefert...aber hier Beenden des Dialogs unerwuenscht, aber Aktualisierung der Darstellung erfolgt
			CanClose();
			PlotWindow->UpdateWnd();
			break;
			
		case id_Standard: //! id_Standard wird abgefangen, aufgerufen durch den OK-Button
			CanClose();
			PlotWindow->UpdateWnd();
			LeaveDialog();
			EndDialog(GetHandle(), id);
			break;

		case IDCANCEL:
			LeaveDialog();
			EndDialog(GetHandle(), id);
			break;

		case id_Filter:
			CtrlSetEnabled(id_FilterStrength, CtrlIsChecked(id_Filter));
			break;
		/*case id_ScaleTypeY:
			if (codeNotify==CBN_SELCHANGE) {
				retval= ComboBox_GetCurSel(hWndScaleT);
				if (retval != CB_ERR) switch (retval+1) {
					case Logarithmic: 
					case Linear:
						CtrlSetEnabled(id_MaxIntensity,TRUE);
						CtrlSetEnabled(id_MinIntensity,TRUE);
						break;

					case User:
						CtrlSetEnabled(id_MaxIntensity,FALSE);
						CtrlSetEnabled(id_MinIntensity,FALSE); 
						break;
				}			
			}
			break*/

		case id_X_Scala:
			bSavedSecondaryCoor= FALSE;
			break;

		case id_Z_Scala:
			bSavedSecondaryCoor= TRUE;
			break;

		//! betrifft Combobox zur Auswahl der Darstellungsart
		//! hier geaendert, da die Fkt nur fuer RL-Bitmap gueltig sind
		//! nur fuer RL-Bitmap werden Menupunkte xy Skalierung, y-Punkte,
		//! groessere Punkte sichtbar
		case id_ShowDataType:
			if (codeNotify == CBN_SELCHANGE)
			{
				if (PlotWindow->WindowType == wtScan)
					break;
				int retvalT= ComboBox_GetCurSel(hWndOutputT);
				if (retvalT == CB_ERR)
					break;
				switch (retvalT + 1)
				{
					case otReciprokeLatticeBitmap:
						CtrlSetEnabled(id_Dotted, FALSE);
						CtrlSetEnabled(id_Filter, FALSE);
						CtrlSetEnabled(id_FilterStrength, FALSE);
						CtrlSetEnabled(id_Dilatation, TRUE);
						CtrlSetEnabled(id_XY_Scaling, TRUE);
						CtrlSetEnabled(id_Graustufen, TRUE);
						CtrlSetEnabled(id_dy1, TRUE);
						CtrlSetEnabled(id_Bar, TRUE);
						CtrlSetEnabled(id_dx1, TRUE);
						CtrlSetEnabled(id_Bar2, TRUE);
						if (ComboBox_FindString(hWndScaleT, 0, aScaleType[sUser - 1]) == CB_ERR)
							ComboBox_AddString(hWndScaleT, aScaleType[sUser - 1]);
						break;

					case otMatrixBitmap:
						CtrlSetEnabled(id_Dotted, FALSE);
						CtrlSetEnabled(id_Filter, FALSE);
						CtrlSetEnabled(id_FilterStrength, FALSE);
						CtrlSetEnabled(id_Dilatation, TRUE);
						CtrlSetEnabled(id_XY_Scaling, FALSE);
						CtrlSetEnabled(id_Graustufen, TRUE);
						CtrlSetEnabled(id_dy1, TRUE);
						CtrlSetEnabled(id_Bar, TRUE);
						CtrlSetEnabled(id_dx1, TRUE);
						CtrlSetEnabled(id_Bar2, TRUE);
						if (ComboBox_FindString(hWndScaleT, 0, aScaleType[sUser - 1]) == CB_ERR)
							ComboBox_AddString(hWndScaleT, aScaleType[sUser - 1]);
						break;

					case otCurve:
						CtrlSetEnabled(id_Dotted, TRUE);
						CtrlSetEnabled(id_Filter, TRUE);
						CtrlSetEnabled(id_FilterStrength, CtrlIsChecked(id_Filter));
						CtrlSetEnabled(id_Dilatation, FALSE);
						CtrlSetEnabled(id_XY_Scaling, FALSE);
						CtrlSetEnabled(id_Graustufen, FALSE);
						CtrlSetEnabled(id_dy1, FALSE);
						CtrlSetEnabled(id_Bar, FALSE);
						CtrlSetEnabled(id_dx1, FALSE);
						CtrlSetEnabled(id_Bar2, FALSE);
						int retval= ComboBox_GetCurSel(hWndScaleT);
						if ( (retval != CB_ERR) && (retval + 1 == sUser) )
						{
							PlotWindow->CoorSys.yScal= sLogarithmic;
							ComboBox_SelectString(hWndScaleT, 0, aScaleType[sLogarithmic - 1]);
							break;
						}
						if (ComboBox_FindString(hWndScaleT, 0, aScaleType[sUser - 1]) != CB_ERR)
							ComboBox_DeleteString(hWndScaleT, sUser - 1);
						break;
				} // switch (retval+1)
				if ( retvalT+1 == otReciprokeLatticeBitmap ) { // bei RL-Bitmap nur Winkeldarstellung
					bSavedSecondaryCoor= CtrlIsChecked(id_Z_Scala);
					CtrlSetChecked(id_X_Scala, TRUE); //! Winkel
					CtrlSetChecked(id_Z_Scala, FALSE); //! Kanaele
					CtrlSetEnabled(id_X_Scala, FALSE);
					CtrlSetEnabled(id_Z_Scala, FALSE);
				} else {
					//! betrifft Kanaele und Winkel
					CtrlSetChecked(id_X_Scala, !bSavedSecondaryCoor); //! Winkel
					CtrlSetChecked(id_Z_Scala, bSavedSecondaryCoor); //! Kanaele
					//! wenn kein PSD-Device als Detektor, dann Fkt. oder Energyspektrum aktiv: nicht waehlbar
					EOutputType temp= PlotWindow->eOutputType; 
					PlotWindow->eOutputType= otCurve; // fr CanSwitchChannelAngle
					CtrlSetEnabled(id_X_Scala, PlotWindow->CanSwitchChannelAngle());
					CtrlSetEnabled(id_Z_Scala, PlotWindow->CanSwitchChannelAngle());
					PlotWindow->eOutputType= temp;
				}
			} // codeNotify==CBN_SELCHANGE
			break;

		default:
			TModalDlg::Dlg_OnCommand(GetHandle(), id, hwndCtl, codeNotify);
	} // switch (id)
};
//*****************************************************************************

BOOL TCurveShowParamDlg::CanClose(void)
//! bereitet Daten zum Schliessen oder Neuzeichnen des Plotwindows auf
//! Fehler 7,8,9,10,13
{
	BOOL result= TRUE;
	float valueF;
	BOOL id= 0;
	BOOL bValid;

	//! waehle Ausgabetyp und setze Parameter entsprechend
	int retval= ComboBox_GetCurSel(hWndOutputT);
	if ( retval!=CB_ERR && PlotWindow->WindowType!=wtScan ) switch (1 + retval)
	{
		case otReciprokeLatticeBitmap:
			if (Main.AreaScanWindow != PlotWindow)
				break;

			CtrlSetEnabled(cm_UserScal, TRUE);
			PlotWindow->eOutputType= otReciprokeLatticeBitmap;
			PlotWindow->CoorSys.yScal= sLinear;
			retval= 1 + ComboBox_GetCurSel(hWndScaleT);
			if (retval == 1)
				PlotWindow->CoorSys.zScal= sLogarithmic;
			else if (retval == 2)
				PlotWindow->CoorSys.zScal= sLinear;
			else
				PlotWindow->CoorSys.yScal= sUser;
			break;

		case otMatrixBitmap:
			if (Main.AreaScanWindow != PlotWindow)
				break;

			CtrlSetEnabled(cm_UserScal, TRUE);
			PlotWindow->eOutputType= otMatrixBitmap;
			PlotWindow->CoorSys.yScal= sLinear;
			retval= 1 + ComboBox_GetCurSel(hWndScaleT);
			if (retval == 1)
				PlotWindow->CoorSys.zScal= sLogarithmic;
			else if (retval == 2)
				PlotWindow->CoorSys.zScal= sLinear;
			else
				PlotWindow->CoorSys.yScal= sUser;
			break;

		case otCurve:
			CtrlSetEnabled(cm_UserScal, FALSE);
			PlotWindow->eOutputType= otCurve;
			retval= 1 + ComboBox_GetCurSel(hWndScaleT);
			if (retval == 1)
				PlotWindow->CoorSys.yScal= sLogarithmic;
			else if (retval == 2)
				PlotWindow->CoorSys.yScal= sLinear;
			break;
	} // switch

	//! erzeuge neues TBitmapSourceObjekt wenn noetig
	if (PlotWindow->eOutputType==otReciprokeLatticeBitmap || PlotWindow->eOutputType==otMatrixBitmap)
	{
		if ( !PlotWindow->BSource ) new TBitmapSource(PlotWindow); // registriert sich selbst fr dieses Fenster
	}	

	PlotWindow->DisablePaint();

	//! bewirkt ob an der Abzisse Kanaele oder Winkel abgetragen...
	PlotWindow->bSecondaryCoor= CtrlIsChecked(id_Z_Scala);

	// bei RL-Bitmap nur Winkeldarstellung
	if ( PlotWindow->eOutputType==otReciprokeLatticeBitmap ) PlotWindow->bSecondaryCoor= FALSE;

	//! betrifft Kanaele und Winkel
	CtrlSetChecked(id_X_Scala, !PlotWindow->bSecondaryCoor); //! Winkel
	CtrlSetChecked(id_Z_Scala, PlotWindow->bSecondaryCoor); //! Kanaele
	//! wenn kein PSD-Device als Detektor, dann Fkt. oder Energyspektrum aktiv: nicht waehlbar
	CtrlSetEnabled(id_X_Scala, PlotWindow->CanSwitchChannelAngle());
	CtrlSetEnabled(id_Z_Scala, PlotWindow->CanSwitchChannelAngle());

	//! hier werden Felder id_tilesx, id_tilesy abgefragt
	valueF= CtrlGetLong(id_tilesx, bValid);
	if ( bValid && 2<=valueF && valueF<=15 ) PlotWindow->tilesx= valueF;
	else {
		CtrlSetLong(id_tilesx, PlotWindow->tilesx);		
		CtrlSetFocus(id_tilesx);
		result= FALSE;
		if ( bValid ) {
			MessageBox(szMsgLine306, szMessageDlg, MBINFO);
			return FALSE;
		} else MessageBeep(0);
	}

	valueF= CtrlGetLong(id_tilesy, bValid);
	if ( bValid && 2<=valueF && valueF<=15 ) PlotWindow->tilesy= valueF;
	else {
		CtrlSetLong(id_tilesy, PlotWindow->tilesy);
		CtrlSetFocus(id_tilesy);
		result= FALSE;
		if ( bValid ) {
			MessageBox(szMsgLine305, szMessageDlg, MBINFO);
			return FALSE;
		} else MessageBeep(0);			
	}

	//! hier jetzt Abfrage der Min und Max Werte fuer Intensitaeten
	//! es werden nur zulaessige Intensitaeten zugelassen
	//! die hier setzt bei keinen Werten im Fenster Werte entsprechend
	valueF= CtrlGetDouble(id_MaxIntensity, _MAXINTENSITYDIGITS, _DECIMAL, bValid);
	if ( bValid && valueF<=PlotWindow->MaxIntensitaet ) PlotWindow->UpperBound= valueF;
	else {
		CtrlSetDouble(id_MaxIntensity, PlotWindow->UpperBound, _MAXINTENSITYDIGITS, _DECIMAL);
		CtrlSetFocus(id_MaxIntensity);
		result= FALSE;
		if ( bValid ) {
			MessageBox(szMsgLine304, szMessageDlg, MBINFO);		
			return FALSE;
		} else MessageBeep(0);		
	}

	valueF= CtrlGetDouble(id_MinIntensity, _MININTENSITYDIGITS, _DECIMAL, bValid);
	if ( bValid && valueF>=PlotWindow->MinIntensitaet ) PlotWindow->LowerBound= valueF;
	else {
		CtrlSetDouble(id_MinIntensity, PlotWindow->LowerBound, _MININTENSITYDIGITS, _DECIMAL);
		CtrlSetFocus(id_MinIntensity);
		MessageBox(szMsgLine302, szMessageDlg, MBINFO);
		return FALSE;
	}
	if (PlotWindow->LowerBound >= PlotWindow->UpperBound)
	{
		PlotWindow->UpperBound= PlotWindow->MaxIntensitaet;	
		PlotWindow->LowerBound= PlotWindow->MinIntensitaet;
		CtrlSetDouble(id_MaxIntensity, PlotWindow->UpperBound, _MAXINTENSITYDIGITS, _DECIMAL);
		CtrlSetDouble(id_MinIntensity, PlotWindow->LowerBound, _MININTENSITYDIGITS, _DECIMAL);
		MessageBox(szMsgLine303, szMessageDlg, MBINFO);
		return FALSE;
	}

	//! pruefe CheckButtons "groessere Punkte", "x-y Skalierung"
	PlotWindow->bIncreasePP= CtrlIsChecked(id_Dilatation);
	PlotWindow->bXY_Scaling= CtrlIsChecked(id_XY_Scaling);

	if (PlotWindow->BSource != NULL)
		PlotWindow->BSource->bGrayScalePalette= CtrlIsChecked(id_Graustufen);

	//! waehle Intensittsskalierung und setze Parameter entsprechend
	retval= ComboBox_GetCurSel(hWndScaleT);
	if (retval != CB_ERR)
	{
		switch (retval + 1)
		{
			case sLogarithmic:
				if ( PlotWindow->eOutputType==otReciprokeLatticeBitmap || PlotWindow->eOutputType==otMatrixBitmap )
				{
					PlotWindow->CoorSys.zScal= sLogarithmic;
					PlotWindow->CoorSys.yScal= sLinear;
				}
				else
					PlotWindow->CoorSys.yScal= sLogarithmic;
				break;

			case sLinear:
				PlotWindow->CoorSys.yScal= sLinear;
				PlotWindow->CoorSys.zScal= sLinear;
				break;

			case sUser:
				if ( PlotWindow->eOutputType==otReciprokeLatticeBitmap || PlotWindow->eOutputType==otMatrixBitmap )
				{
					PlotWindow->CoorSys.zScal= sUser;
					PlotWindow->CoorSys.yScal= sLinear;
				}
				else
					PlotWindow->CoorSys.yScal= sUser;
				break;
		}
	}

	//! wenn irgendein Bitmap, muss aktualisiert werden...
	HCURSOR hOldCursor= SetDefaultCursor( IDC_WAIT );
	if ( PlotWindow->eOutputType==otReciprokeLatticeBitmap || PlotWindow->eOutputType==otMatrixBitmap )
	{
		//! zu Fehler 12
		PlotWindow->Screen.dy= stdy; 
		PlotWindow->Screen.dx= stdx;

		PlotWindow->BSource->FormatDBaseToBitmapSource();
	}
	SetCursor(hOldCursor); // restore cursor before waiting cursor

	// gepunktete Kurven?
	PlotWindow->m_Dotted= CtrlIsChecked(id_Dotted); 
	// Kurven-Filter an?
	PlotWindow->m_HasFilter= CtrlIsChecked(id_Filter); 
	// Wert trotzdem immer uebernehmen
	BOOL aValid;
	PlotWindow->m_FilterStrength= CtrlGetDouble(id_FilterStrength, 1, _DECIMAL, aValid); 
	PlotWindow->EnablePaint();

	return result;
};
//*****************************************************************************

void TCurveShowParamDlg::LeaveDialog(void)
{
	//! der Name sagt alles...
	//! wird im Falle von Dlg_OnCommand --> (IDOK), IDABORT und IDCANCEL aufgerufen
	//! in dlg_tpl.cpp, was zu tun fuer Nachricht IDOK selbst neu definiert
	/* if(PlotWindow->eOutputType <= MatrixBitmap)
	 {
	 CoorSys= &PlotWindow->CoorSys;
	 CoorSys->yScal= CoorSys->xScal= Linear;
	 }*/
	PlotWindow->EnablePaint();
};

//##############################################################################
// TBitmapSource
//##############################################################################

//! Konstruktor TBitmapSource
TBitmapSource::TBitmapSource(TPlotWindow *aPlotWindow) : ber(8, 0.0), farbe(8, 0), m_Daten(0), PlotWindow(0), hDIBInfo(0), hDIBData(0), hMemPal(0), hPalette(0), hOldPalette(0), hBitmap(0)
{
	char Ident[]= "AreaScan";
	//! int cnt=0,cnt1=0;
	//! Stellt die Funktionalitaet der Darstellung von Kurven und der Bewertung
	//! dieser Kurven bereit - Klasse TPlotWindow
	PlotWindow= aPlotWindow;
	PlotWindow->BSource= this;

	m_DatenRows= m_DatenCols= 0;
	m_DatenInited= false;

	UserFarb= NULL;
	//15.05.2004 PlotWindow->xBorder= 80; //! der Rand zur y-Achse im Bitmap (alter Wert 40)
	//15.05.2004 PlotWindow->yBorder= 40; //! der Rand zur x-Achse im Bitmap (alter Wert 26)

	/*30.06.2004 dies hier rausgenommen, da eOutputType zu Anfang immer RL-Bitmap und nicht wie vorgesehen dem Menueintrag im Modaldialog entspricht! - Fehler 11
	switch (PlotWindow->eOutputType)
	{
		case ReciprokeLatticeBitmap: 
		case MatrixBitmap:
			break;

		default:
			PlotWindow->eOutputType= ReciprokeLatticeBitmap;
	}*/
	BMCoorSys= &PlotWindow->AltCoorSys;
	*BMCoorSys= PlotWindow->CoorSys; // berschreibt PlotWindow->AltCoorSys mit PlotWindow->CoorSys
	// Kullmann, Reinecker: ATOS-Testfall MS.2 Fehlerbehebung	PlotWindow->bAltCoorSystem= TRUE;
	BMCoorSys->xScal= BMCoorSys->yScal= sLinear;
	BMCoorSys->zScal= sLogarithmic;	
	hDIBInfo= NULL;
	hDIBData= NULL;
	hMemPal= NULL;

	for (int i=0; i<RLAreaPkts; i++) {
		RLArea[i].x= RLArea[i].y= 0;
	}

	BereichDef(); // <ber> und <farbe> initialisieren
	ColorDef(); // <ColorTable> initialisieren

	//! wenn gewuenscht kann sw-Palette im ini-File angegeben werden
	bGrayScalePalette= GetPrivateProfileInt(Ident, "swPalette", 0, GetCFile());

	strcpy(Fileold, "");
};
//*****************************************************************************

//! setzt Variablenfelder farbe[] und ber[]
//! so dass ein linearer Verlauf abhaengig von Min-,MaxIntensitaet
void TBitmapSource::BereichDef(void)
{
	float bereich1, bereich2;
	bereich1= PlotWindow->UpperBound - PlotWindow->LowerBound;
	bereich1= bereich1 / 9;
	bereich2= ColorTable.ColorMap.GetCount() / 9;
	for (int i= 0; i<8; i++)
	{
		ber[i]= PlotWindow->LowerBound + (i + 1) * bereich1;
		farbe[i]= (i + 1) * bereich2;
	}
}
//*****************************************************************************

//! dies hier entspricht einer Angabe von Leveln im ini-File
//! um Intensitaetsabstufungen im User Falle zu generieren
//! ansonsten werden Defaultwerte gesetzt
//! dies aber nur im Zusammenhang mit Bitmaps sinnvoll
void TBitmapSource::ColorDef(void)
{
	//! schon mal vorinitialisiert, damit nix schief geht
	int i= 0, cnt;

	for (cnt= 0; cnt<ColorTable.ColorMap.GetCount(); cnt++)
		ColorTable.ColorMap.SetAt(cnt, 255);

	//! in ColorTable.ColorMap[0...GetCount()-1] wird jeder Farbe ein bestimmter
	//! Intensitaetswert zugewiesen

	float zaehl= 0, bereich1, bereich2;

	bereich1= ber[i] - PlotWindow->LowerBound;
	bereich2= farbe[i] - 0;
	bereich1= bereich1 / bereich2;
	for (cnt= 0; cnt<farbe[i]; cnt++)
	{
		ColorTable.ColorMap.SetAt(cnt, PlotWindow->LowerBound + zaehl * bereich1);
		zaehl++;
	}

	zaehl= 0;
	for (i= 0; i<7; i++)
	{
		bereich1= ber[i + 1] - ber[i];
		bereich2= farbe[i + 1] - farbe[i];
		bereich1= bereich1 / bereich2;
		for (cnt= farbe[i]; cnt<=farbe[i + 1]; cnt++)
		{
			ColorTable.ColorMap.SetAt(cnt, ber[i] + zaehl * bereich1);
			zaehl++;
		}
		zaehl= 0;
	}

	i= 7;
	bereich1= PlotWindow->UpperBound - ber[i];
	bereich2= 255 - farbe[i];
	bereich1= bereich1 / bereich2;
	for (cnt= farbe[i]; cnt<ColorTable.ColorMap.GetCount(); cnt++)
	{
		ColorTable.ColorMap.SetAt(cnt, ber[i] + zaehl * bereich1);
		zaehl++;
	}
}
//*****************************************************************************

//! Destruktor TBitmapSource
TBitmapSource::~TBitmapSource()
{
	if (hDIBData)
		HeapFree(GetProcessHeap(),0,hDIBData);
	hDIBData= 0;

	if (hDIBInfo)
		HeapFree(GetProcessHeap(),0,hDIBInfo);
	hDIBInfo= 0;

	if (hMemPal)
		HeapFree(GetProcessHeap(),0,hMemPal);
	hMemPal= 0;

	if (hBitmap) 
		DeleteObject(hBitmap);
	hBitmap= NULL;

	_FREEOBJ(UserFarb); // Dialog verstecken, falls sichtbar
	FreeDaten();
	// Kullmann, Reinecker: ATOS-Testfall MS.2 Fehlerbehebung	bAltCoorSystem= FALSE;
	// 15.05.2004 PlotWindow->xBorder= XBNorm;
	// 15.05.2004 PlotWindow->yBorder= YBNorm;
};
//*****************************************************************************

void TBitmapSource::CreateDaten(UINT aRows, UINT aCols) {
	// zuerst alte Daten freigeben
	FreeDaten();
	
	//! SCHRITT 1: ZEILEN.
	m_Daten= new TBMContens * [aRows];
	if ( !m_Daten )
	{
		MessageBox(GetFocus(), "Speicherreservierung der Zeilen fehlgeschlagen!", "CreateDaten", MBINFO );
		exit(-1);
	}
	//! SCHRITT 2: SPALTEN.
	for (int r= 0; r<aRows ;r++)
	{
		m_Daten[r]= new TBMContens[aCols];
		if ( !m_Daten[r] ) {
			MessageBox(GetFocus(), "Speicherreservierung einer Spalte fehlgeschlagen!", "CreateDaten", MBINFO );
			exit(-1);
		}
	}

	// m_DatenCols und m_DatenRows fuer SetOmega, SetTheta, SetIntens setzen 	
	m_DatenCols= aCols;
	m_DatenRows= aRows;

	//! IRGENDEINE INITIALISIERUNG
	for (r= 0; r<aRows; r++)
	{
		for (int c= 0; c<aCols; c++)
		{	
			SetOmega (r, c, r*r - c*c);
			SetTheta (r, c, r*r - c*c);
			SetIntens(r, c, r*r - c*c);
		}
		char buf[_MAXLENDOUBLE];
		sprintf(buf, "%d % vorinitialisiert", 100 * r / aRows);
		SetInfo(buf);
	}
	
	//! auf FALSE setzen, weil "Daten"feld neu initialisiert werden muss
	m_DatenInited= false;
}
//*****************************************************************************

bool TBitmapSource::CheckKoord(UINT &aRow, UINT &aCol) {
	bool result= true; // alles O.K.
	if ( aRow>=m_DatenRows ) {
		if ( m_DatenRows ) aRow= m_DatenRows-1;
		result= false;
		TraceErr("ZEILE!!! Die angegebene Zeile ueberschreitet das Maximum!.");
	}
	if ( aCol>=m_DatenCols ) {
		if ( m_DatenCols ) aCol= m_DatenCols-1;
		result= false;
		TraceErr("SPALTE!!! Die angegebene Spalte ueberschreitet das Maximum!.");
	}
	return result;
}
//*****************************************************************************

void TBitmapSource::FreeDaten() {
	if ( !m_Daten ) return; // fertig 

	for (int r= 0; r<m_DatenRows; r++)
		_FREELIST(m_Daten[r]); //! SCHRITT 1: SPALTEN LOESCHEN
	_FREELIST(m_Daten); //! Schritt 2: ZEILEN LOESCHEN

	m_DatenRows= 0;
	m_DatenCols= 0;
	m_DatenInited= false;	
}

//*****************************************************************************

float TBitmapSource::GetOmega(UINT aRow, UINT aCol) {
	if ( !IsDatenInited() ) {
		TraceErr("DATEN!!! Diese Bitmap ist uninitilisiert!.");
		if ( !m_DatenRows || !m_DatenCols ) return 0; // es kann kein "vorinitialisierter"-Wert zurckgegeben werden
	}
	CheckKoord(aRow, aCol); // ggf. auf das Ende gesetzt
	return m_Daten[aRow][aCol].omega;
}
float TBitmapSource::GetTheta(UINT aRow, UINT aCol) {
	if ( !IsDatenInited() ) {
		TraceErr("DATEN!!! Diese Bitmap ist uninitilisiert!.");
		if ( !m_DatenRows || !m_DatenCols ) return 0; // es kann kein "vorinitialisierter"-Wert zurckgegeben werden
	}
	CheckKoord(aRow, aCol); // ggf. auf das Ende gesetzt
	return m_Daten[aRow][aCol].theta;
}
float TBitmapSource::GetIntens(UINT aRow, UINT aCol) {
	if ( !IsDatenInited() ) {
		TraceErr("DATEN!!! Diese Bitmap ist uninitilisiert!.");
		if ( !m_DatenRows || !m_DatenCols ) return 0; // es kann kein "vorinitialisierter"-Wert zurckgegeben werden
	}
	CheckKoord(aRow, aCol); // ggf. auf das Ende gesetzt
	return m_Daten[aRow][aCol].intens;
}
//*****************************************************************************

bool TBitmapSource::SetOmega(UINT aRow, UINT aCol, float aValue) {
	//if ( !CheckKoord(aRow, aCol) ) return false; 
	m_Daten[aRow][aCol].omega= aValue;
	return true;
}
bool TBitmapSource::SetTheta(UINT aRow, UINT aCol, float aValue) {
	//if ( !CheckKoord(aRow, aCol) ) return false; 
	m_Daten[aRow][aCol].theta= aValue;
	return true;
}
bool TBitmapSource::SetIntens(UINT aRow, UINT aCol, float aValue) {
	//if ( !CheckKoord(aRow, aCol) ) return false; 
	m_Daten[aRow][aCol].intens= aValue;
	return true;
}
//*****************************************************************************

void TBitmapSource::New(void)
{
	if (hDIBData != NULL)
		HeapFree(GetProcessHeap(),0,hDIBData);
	hDIBData= NULL;

	if (hDIBInfo != NULL)
		HeapFree(GetProcessHeap(),0,hDIBInfo);
	hDIBInfo= NULL;
};
//*****************************************************************************

/* derzeit nicht verwendet 17.05.2004 
// DIB-Datei lesen
//! soll ein Bitmapfile einlesen, stuerzt aber ab, weil Screen nicht initialisiert
BOOL TBitmapSource::ProcessBitmapFile(HFILE hStream)
{
	BITMAPINFOHEADER bmInfoHeader;
	LPBITMAPINFO lpBMPInfo;
	int nColors;
	DWORD memsize;
	HPBYTE hpData;
	TScreen &Screen= PlotWindow->Screen;

	// File-Header lesen
	BITMAPFILEHEADER BMPFileHdr;
	_lread(hStream, &BMPFileHdr, sizeof(BMPFileHdr));
	if (BMPFileHdr.bfType != *(UINT*)"BM")
		return FALSE; // Ausstieg bei falschem Marker
	// BITMAPINFOHEADER Struktur einlesen
	_lread(hStream, &bmInfoHeader, sizeof(bmInfoHeader));
	if (bmInfoHeader.biSize != sizeof(BITMAPINFOHEADER))
		return FALSE; // Ausstieg bei falscher Groee
	// Wenn Anzahl benutzter Farben im Header stehen ...
	if (bmInfoHeader.biClrUsed == 0) { // aus Bittiefe erechnen
		if (bmInfoHeader.biBitCount != 24)
			nColors= 1 << bmInfoHeader.biBitCount;
		else
			nColors= 0;
		bmInfoHeader.biClrUsed= nColors;
	} else nColors= (int)bmInfoHeader.biClrUsed; // direkte Angabe verwenden
	// ggf. biSizeImage nachtragen
	GetImageSize();
	// Speicher fuer Bitmapinfo + Farbpalette anfordern
	memsize= sizeof(BITMAPINFO) + (nColors - 1) * sizeof(RGBQUAD);
	if (hDIBInfo)
		hDIBInfo= HeapReAlloc(GetProcessHeap(), 0, hDIBInfo, memsize);
	else
		hDIBInfo= (HGLOBAL)HeapAlloc(GetProcessHeap(), 0, memsize);
	if (!hDIBInfo)
		return FALSE;
	lpBMPInfo= (LPBITMAPINFO)hDIBInfo;
	// Header kopieren
	lpBMPInfo->bmiHeader= bmInfoHeader;
	// Farbtabelle lesen
	_lread(hStream, lpBMPInfo->bmiColors, sizeof(RGBQUAD)*nColors);
	// Speicher fuer die eigentliche Bitmap anfordern, einlesen
	if (hDIBData)
		hDIBData= HeapReAlloc(GetProcessHeap(),0, hDIBData, bmInfoHeader.biSizeImage);
	else
		hDIBData= (HGLOBAL)HeapAlloc(GetProcessHeap(),0,bmInfoHeader.biSizeImage);

	Screen.dx= (int)bmInfoHeader.biWidth; 
	Screen.dy= (int)bmInfoHeader.biHeight; 

	if (!hDIBData)
		return FALSE;
	hpData= (HPBYTE)hDIBData;
	_hread(hStream, hpData, bmInfoHeader.biSizeImage);
	PlotWindow->eOutputType= otMatrixBitmap;
	if (hBitmap)
		DeleteObject(hBitmap);
	hBitmap= NULL;
	return TRUE;
};
//***************************************************************************** */

//! berechnet Bytes pro Zeile*Hoehe des Bitmaps= Gesamtgroesse im Speicher
DWORD TBitmapSource::GetImageSize(void)
{
	DWORD nBits;
	LPBITMAPINFOHEADER lpBMPInfoHdr;
	LPBITMAPINFO lpBMPInfo;

	if (!hDIBInfo)
		return 1;
	lpBMPInfo= (LPBITMAPINFO)hDIBInfo;
	lpBMPInfoHdr= &lpBMPInfo->bmiHeader;
	nBits= ((lpBMPInfoHdr->biWidth * lpBMPInfoHdr->biBitCount + 31)
			 / 32) * 4; // Bytes pro Zeile, Aufrunden auf DWords
	nBits *= (DWORD)lpBMPInfoHdr->biHeight + 1; //! zur Sicherheit eine Zeile mehr...
	lpBMPInfoHdr->biSizeImage= nBits;
	return nBits;
};
//*****************************************************************************

//! // einigermaen gleichmaeigverteilte Standardpalette erzeugen
LOGPALETTE *TBitmapSource::CreateDefaultPalette(void)
{
	int i;
	int size= sizeof(LOGPALETTE) + ColorTable.ColorMap.GetCount() * sizeof(PALETTEENTRY);
	LOGPALETTE *pPal= (LOGPALETTE *)new char[size];
	memset(pPal, 0, size);
	pPal->palVersion= 0x300;
	pPal->palNumEntries= ColorTable.ColorMap.GetCount();
	PALETTEENTRY *pEntry= pPal->palPalEntry;
	if (bGrayScalePalette)
	{
		//! grayscale palette
		for (i= 0; i<ColorTable.ColorMap.GetCount(); i++)
		{
			pEntry->peRed=		255 - i;
			pEntry->peGreen=	255 - i;
			pEntry->peBlue=		255 - i;
			pEntry->peFlags=	0;
			pEntry++;
		}
	}
	//! ansonsten Farbverlauf mit 256 Farben
	else
	{
		// Farbe 0
		pEntry->peRed=		255;
		pEntry->peGreen=	255;
		pEntry->peBlue=		255;
		pEntry->peFlags=	0;
		pEntry++;

		for (i= 0;i <= 49;i++)
		{ // Farbe 1 .. 50
			pEntry->peRed=		255;
			pEntry->peGreen=	(255 - 5 * i);
			pEntry->peBlue=		0;
			pEntry->peFlags=	0;
			pEntry++;
		}
		
		for (i= 0;i <= 49;i++)
		{ // Farbe 51..100
			pEntry->peRed=		255;
			pEntry->peGreen=	0;
			pEntry->peBlue=		(5 * i);
			pEntry->peFlags=	0;
			pEntry++;
		}
		for (i= 0;i <= 49;i++)
		{ // Farbe 101..150
			pEntry->peRed=		(255 - 5 * i);
			pEntry->peGreen=	0;
			pEntry->peBlue=		255;
			pEntry->peFlags=	0;
			pEntry++;
		}
		for (i= 0;i <= 49;i++)
		{ // Farbe 151..200
			pEntry->peRed=		0;
			pEntry->peGreen=	(5 * i);
			pEntry->peBlue=		255;
			pEntry->peFlags=	0;
			pEntry++;
		}
		for (i= 0;i <= 49;i++)
		{ // Farbe 201..250
			pEntry->peRed=		0;
			pEntry->peGreen=	255;
			pEntry->peBlue=		(255 - 5 * i);
			pEntry->peFlags=	0;
			pEntry++;
		}
		for (i= 0;i <= 4;i++)
		{ // Farbe 251..254
			pEntry->peRed=		(160 - 10 * i * i);
			pEntry->peGreen=	(160 - 10 * i * i);
			pEntry->peBlue=		(160 - 10 * i * i);
			pEntry->peFlags=	0;
			pEntry++;
		}
	}
	return pPal;
};
//*****************************************************************************

//! generiert Palette aus DIB (Device independend Bitmap)
LOGPALETTE *TBitmapSource::CreatePaletteFromDIB(void)
{
	// Palette aus DIB erzeugen
	LOGPALETTE *pPalette;
	PALETTEENTRY *pEntry;
	RGBQUAD *pRGB;
	int cnt;
	short nColors;
	LPBITMAPINFO lpBMPInfo;

	lpBMPInfo= (LPBITMAPINFO)hDIBInfo;
	if (!lpBMPInfo)
		return NULL;
	nColors= (short)lpBMPInfo->bmiHeader.biClrUsed;
	if (nColors == 0)
	{
		return CreateDefaultPalette();
	}
	pPalette= (LOGPALETTE*)new char[sizeof(LOGPALETTE) + (nColors - 1) * sizeof(PALETTEENTRY)];
	if (pPalette)
	{
		pPalette->palVersion= 0x300;
		pPalette->palNumEntries= nColors;
		pRGB= lpBMPInfo->bmiColors;
		pEntry= pPalette->palPalEntry;
		for (cnt= 0;cnt < nColors;cnt++)
		{
			pEntry->peRed= pRGB->rgbRed;
			pEntry->peGreen= pRGB->rgbGreen;
			pEntry->peBlue= pRGB->rgbBlue;
			pEntry->peFlags= 0;
			pRGB++;
			pEntry++;
		}
	}
	return pPalette;
};
//*****************************************************************************

//! fuellt den Header eines Bitmaps mit Farbwerten der Palette
void TBitmapSource::FillBMInfoFromPalette(LOGPALETTE *pPal)
{
	PALETTEENTRY *pEntry;
	RGBQUAD *pRGB;
	int nColors, cnt;
	LPBITMAPINFO lpBMPInfo;

	lpBMPInfo= (LPBITMAPINFO)hDIBInfo;
	pRGB= lpBMPInfo->bmiColors;
	pEntry= pPal->palPalEntry;
	nColors= min((WORD)lpBMPInfo->bmiHeader.biClrUsed, (WORD)pPal->palNumEntries);
	for (cnt= 0; cnt < nColors; cnt++)
	{
		pRGB->rgbRed= pEntry->peRed;
		pRGB->rgbGreen= pEntry->peGreen;
		pRGB->rgbBlue= pEntry->peBlue;
		pRGB++;
		pEntry++;
	}
};
//*****************************************************************************

//! ruft CreatePaletteFromDIB(), ansonsten CreateDefaultPalette()
LOGPALETTE * TBitmapSource::GetPalette(void)
{
	LOGPALETTE *logPal;

	logPal= CreatePaletteFromDIB();
	if (!logPal)
		logPal= CreateDefaultPalette();
	return logPal;
};
//*****************************************************************************

//! function creates a device-dependent bitmap (DDB) from a device-independent
//! bitmap (DIB) and, optionally, sets the bitmap bits
HBITMAP TBitmapSource::CreateGDIObject(HDC hdc)
{
	HPALETTE hPal, hDefPal;
	HPBYTE hpData;
	LPBITMAPINFO lpBMPInfo;

	hPal= CreatePalette(GetPalette());
	hDefPal= SelectPalette(hdc, hPal, FALSE);
	hpData= (HPBYTE)hDIBData;
	lpBMPInfo= (LPBITMAPINFO)hDIBInfo;
	RealizePalette(hdc);
	hBitmap= CreateDIBitmap(hdc, &lpBMPInfo->bmiHeader, CBM_INIT, hpData, lpBMPInfo, DIB_RGB_COLORS);
	SelectPalette(hdc, hDefPal, FALSE);
	DeleteObject(hPal);
	return hBitmap;
};
//*****************************************************************************

//! gibt zu uebergebener Intensitaet entsprechende Intensitaetsfarbe zurueck
int TBitmapSource::GetColor(float intens)
{
	int ci;
	float fval;
	switch (BMCoorSys->zScal)
	{
		//! clogval= ColorTable.nColorRange / log10(BMCoorSys->zMax / BMCoorSys->zMin);
		//! clinval= (BMCoorSys->zMax - BMCoorSys->zMin);
		case sLogarithmic:
			if (intens < BMCoorSys->zMin)
				return 0;
			fval= log10(intens / BMCoorSys->zMin) * clogval;
			if (fval >= ColorTable.ColorMap.GetCount())
				return ColorTable.ColorMap.GetCount()-1; // last Color should be black always

			//! hab hier die zeile reingeschoben, zum runden - Fehler 2
			fval= floor(fval);
			return (int)fval;

		case sLinear:
			//! fval= (intens - BMCoorSys->zMin) / clinval; Fehler 4
			//! hier wurden falsche Intesitaetswerte berechnet, da ColorRange nicht beachtet
			fval= ((intens - BMCoorSys->zMin) / clinval) * (ColorTable.ColorMap.GetCount()-1);
			if (fval < 0.0)
				return 0;
			if (fval >= ColorTable.ColorMap.GetCount())
				return ColorTable.ColorMap.GetCount()-1; // last Color should be black always

			//! hab hier die zeile reingeschoben, zum runden - Fehler 2
			fval= floor(fval);
			return (int)fval;

		case sUser:
			for (ci= 0; ci<ColorTable.ColorMap.GetCount(); ci++)
			{
				if (ColorTable.ColorMap[ci] < intens)
					continue;
				return ci;
			}
			break;
	}
	return ColorTable.ColorMap.GetCount()-1; // last Color should be black always
};
//*****************************************************************************

//! Bitblock-Transfer von hMemDC (dem gegebenen Quell-DC)
//! zu diesem HDC (dem Ziel-DC) - entspricht der Darstellung eines Bitmaps
void TBitmapSource::DrawBitmap(HDC hdc, int ofsx, int ofsy, TScreen &Screen)
{	
	SetScreen(hdc, Screen);
	SetMapMode(hdc, MM_TEXT);
	// Bitmap-Handle holen
	if ( !hBitmap)
		hBitmap= CreateGDIObject(hdc);

	// Bitmap ausgeben
	HDC hMemDC= CreateCompatibleDC(hdc);
	HGDIOBJ OldBitmap= SelectObject(hMemDC, hBitmap);
	SetMapMode(hMemDC, MM_TEXT);
	BitBlt(hdc, Screen.x0 + ofsx, Screen.y0 + ofsy, Screen.dx, Screen.dy, hMemDC, 0, 0, SRCCOPY);

	// GDI aufraeumen
	SelectObject(hMemDC, OldBitmap);
	DeleteDC(hMemDC);
};
//*****************************************************************************

//! ruft bei RL_Bitmap DrawMeasurementArea()
//! berechnet Position der Anordnung der Farblegende
//! setzt Min,MaxIntensitaeten
//! ruft DrawColorTable()
void TBitmapSource::DrawBitmapFrame(HDC hdc, TScreen &Screen)
{
	SetScreen(hdc, Screen);

	// Frame zeichnen
	switch (PlotWindow->eOutputType)
	{
		case otReciprokeLatticeBitmap:
		case otMatrixBitmap:
			DrawMeasurementArea(hdc);
			break;
	}

	// Struktur CTable fuellen
	ColorTable.place.left= Screen.x0 + Screen.dx + 20;
	ColorTable.place.right= ColorTable.place.left + 30;
	ColorTable.place.bottom= Screen.y0 - 30;
	ColorTable.place.top= ColorTable.place.bottom + (ColorTable.ColorMap.GetCount()-1) * 2;
	ColorTable.zMin= BMCoorSys->zMin;
	ColorTable.zMax= BMCoorSys->zMax;
	strcpy(ColorTable.zUnit, "Intensity");
	DrawColorTable(hdc, ColorTable);
};
//*****************************************************************************

//! setzt Screen-Variablen, entsprechend der Bildschirmgroesse
//! setzt Units, Orientation, Scaling
void TBitmapSource::SetScreen(HDC hdc, TScreen& screen)
//! hier wird der Screen innerhalb des Koordinatensystems gemeint
{
	SIZE tagS;
	POINT tagP;
	RECT rect;
	int dx, dy;

	TScreen &Screen= PlotWindow->Screen;
	// Bestimmen der Ausdehnung in Pixeln des Zeichen-Fensters
	GetClientRect(PlotWindow->GetHandle(), (LPRECT)&rect);
	// Daten-Bereich festlegen
	//! wenn nicht initialisiert, setzt Standardwerte
	if ( !Screen.dx || !Screen.dy )
	{
		Screen.dx= stdx;
		Screen.dy= stdy;
		MessageBox(GetFocus(), "Screen (1)", "Message", MBINFO);
	}

	dx= (rect.right - rect.left);
	dy= (rect.bottom - rect.top);
	screen.x0= 0;
	screen.x1= dx;
	screen.y0= 0;
	screen.y1= dy;

	//! Functions to specify the units, orientation, and scaling that you want
	SetMapMode(hdc, MM_ANISOTROPIC);
	SetWindowExtEx(hdc, dx + PlotWindow->xBorder, dy + PlotWindow->yBorder, &tagS);
	SetViewportExtEx(hdc, dx + PlotWindow->xBorder, -(dy + PlotWindow->yBorder), &tagS);
	SetWindowOrgEx(hdc, 0, 0, &tagP);
	SetViewportOrgEx(hdc, PlotWindow->xBorder, dy - PlotWindow->yBorder, &tagP);
};
//*****************************************************************************

//! berechnet zu den Intensitten entsprechende Farbwerte und zeichnet die Farb-Legende
void TBitmapSource::DrawColorTable(HDC hdc, TColorTable &ct)
{
	int cnt, fs= 14;
	int xl, yt, xr, yb, red, green, blue;
	float intens, sf;
	char buf[30];
	LOGPALETTE *pPal;
	LOGFONT lf;
	PALETTEENTRY *pPE;
	HBRUSH hBrush, hOldBrush;
	HPEN hPen, hOldPen;
	HFONT hFont, hOldFont;
	POINT aPoints[5];
	SIZE tagS;

	//! ruft CreatePaletteFromDIB oder im Fehlerfall CreateDefaultPalette
	pPal= GetPalette();

	pPE= pPal->palPalEntry;

	switch (BMCoorSys->zScal)
	{
		case sLinear:
			sf= (BMCoorSys->zMax - BMCoorSys->zMin) / (float)(ct.ColorMap.GetCount()-1);
			break;

		case sLogarithmic:
			sf= (float)(ct.ColorMap.GetCount()-1) / log10(BMCoorSys->zMax / BMCoorSys->zMin);
			break;
	}

	// Font selektieren
	memset(&lf, 0, sizeof(LOGFONT));
	lf.lfHeight= fs;
	lf.lfWidth= 0;
	lf.lfWeight= 200;
	lf.lfUnderline= FALSE;
	strcpy(lf.lfFaceName, "Times New Roman");
	hFont= CreateFontIndirect(&lf);
	hOldFont= (HFONT)SelectObject(hdc, hFont);
	xl= ct.place.left;
	xr= ct.place.right;

	//! durchlaeuft die for-Schleife fuer alle Farben und
	//! traegt die Intensitaeten in das Rechteck ein

	for (cnt= 0; cnt<ct.ColorMap.GetCount();cnt++)
	{
		red= pPE[cnt].peRed;
		green= pPE[cnt].peGreen;
		blue= pPE[cnt].peBlue;
		hBrush= CreateSolidBrush(RGB(red, green, blue));
		hPen= CreatePen(PS_SOLID, 1, RGB(red, green, blue));

		if (!cnt)
		{
			hOldBrush= (HBRUSH)SelectObject(hdc, hBrush);
			hOldPen= (HPEN)SelectObject(hdc, hPen);
		}

		SelectObject(hdc, hBrush);
		SelectObject(hdc, hPen);

		switch (BMCoorSys->zScal)
		{
			//! berechene Intensitaetsverteilung je nachdem ob linear oder logarithmisch skalierter Verlauf
			case sLinear:
				intens= BMCoorSys->zMin + (float)cnt * sf;
				break;

			case sLogarithmic:
				intens= pow((float)10, (float)cnt / sf) * BMCoorSys->zMin;
				break;
				
			case sUser: //! hier User Intensitaetsverteilung hinzugefuegt
				intens= ct.ColorMap[cnt];
				break;
		}

		if (intens < 10.0)
			sprintf(buf, "I= %.3f", intens);
		else
			if (intens < 100.0)
				sprintf(buf, "I= %.2f", intens);
			else
				if (intens < 1000.0)
					sprintf(buf, "I= %.1f", intens);
				else
					sprintf(buf, "I > %.0f", intens);

		//! hier angepasst, um Farbkreis als Intensitaetsskala auszugeben
		if ( PlotWindow->RLdy < 400 )
		{
			yb= ct.place.bottom + cnt;
			yt= yb + 1;
		}
		else
		{
			yb= ct.place.bottom + cnt * 2;
			//! yt= (++yb) + bs;
			yt= yb + 2;
		}

		//! the rectangle is outlined by using the current pen and filled
		//! by using the current brush
		//! zeichne einzelne Intensitaetsstufen
		Rectangle(hdc, xl, yt, xr, yb);

		//! schreibe Intensitaeten mit vorher bestimmten Nachkommastellen aus
		if ( (PlotWindow->RLdy < 400 && !(cnt % 18)) || (PlotWindow->RLdy >= 400 && !(cnt % 9)) )
		{
			SetTextAlign(hdc, TA_BOTTOM);
			GetTextExtentPoint(hdc, buf, strlen(buf), &tagS);
			TextOut(hdc, xr + 8, (yb + yt) / 2 - tagS.cy / 2, (LPSTR)buf, strlen(buf));
			SelectObject(hdc, hOldPen);
			DeleteObject(hPen);
			//! zeichne kleine Orientierungslinie an Intensitaetsskala
			hPen= CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
			aPoints[0].y= aPoints[1].y= (yb + yt) / 2;
			aPoints[0].x= xr + 5;
			aPoints[1].x= xr;
			Polyline(hdc, aPoints, 2);
			SetTextAlign(hdc, TA_TOP);
		}

		//! zum Schluss noch den Rand um die Intensitaetsskala zeichnen
		if (cnt == ct.ColorMap.GetCount()-1) // letzte Farbe= schwarz
		{
			SelectObject(hdc, hOldPen);
			DeleteObject(hPen);
			hPen= CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
			aPoints[0].x= aPoints[1].x= aPoints[4].x= xl;
			aPoints[0].y= aPoints[3].y= aPoints[4].y= ct.place.bottom;
			aPoints[1].y= aPoints[2].y= yt;
			aPoints[2].x= aPoints[3].x= xr;
			Polyline(hdc, aPoints, sizeof(aPoints) / sizeof(POINT));
		}
		SelectObject(hdc, hOldBrush);
		DeleteObject(hBrush);
		SelectObject(hdc, hOldPen);
		DeleteObject(hPen);
	} //! while

	SelectObject(hdc, hOldFont);
	DeleteObject(hFont);
};
//*****************************************************************************

//! generiere MatrixBitmap
void TBitmapSource::GenerateAngleSpaceBitmap(void)
{
	char Msg[MaxString];
	TCurve *Scan= lpDBase->GetCurve(0);
	// TCurve* ScanRep= lpDBase->GetScanReport();
	UINT nScanNumber= lpDBase->GetCNumber();
	// UINT nPointNumber= Scan->GetPNumber();
	//! definiert in comhead.h typedef struct {float x, y;int Ord;} TKSystem[4];
	TKSystem KS_AR;
	HPBYTE hpData;
	DWORD addr;
	int cnt, cx, cy, ival;
	float fIntens, dd;
	float imin= PlotWindow->MaxIntensitaet;
	float imax= PlotWindow->MinIntensitaet;
	TScreen &Screen= PlotWindow->Screen;

	if (PlotWindow->eOutputType != otMatrixBitmap)
		return;
	//****************************************************************************
	//**** Bitmap formatieren ****************************************************
	// get pointer to data area
	hpData= (HPBYTE)hDIBData;
	if (!hpData)
	{
		MessageBox(GetFocus(), "Cannot create memory object (2)", "Message", MBINFO);
		return;
	}
	// inquire intensity range
	//! ermittle Werte fuer Statuszeile - Intensity Range
	//! durchlaufe alle Scans und ermittle min und max...
	if (1 < nScanNumber)
	{
		int cy= nScanNumber;
		while (cy--)
		{
			Scan= lpDBase->GetCurve(cy);
			imin= min(Scan->GetMin(P_Y), imin);
			imax= max(Scan->GetMax(P_Y), imax);
		}
	}
	else
		//! hier fehlte vorher die Klammerung..., so dass imax sonst immer 1000
		//! Fehler3
	{
		imin= 0.1f;
		imax= 1000.0;
	}
	sprintf(Msg, szMsgLine307, imin, imax);

	// compute cacheval for colormap
	switch (BMCoorSys->zScal)
	{
		case sLogarithmic:
			clogval= (float)(ColorTable.ColorMap.GetCount()-1) / log10(BMCoorSys->zMax / BMCoorSys->zMin);
			break;

		case sLinear:
		case sUser:
			clinval= (BMCoorSys->zMax - BMCoorSys->zMin);
			break;
	}
	// Inquire measurement area
	PlotWindow->SetMeasurementArea(KS_AR);
	// sort ranges

	//! Suche nach kleinstem KS_AR[*].y
	for (cnt= 1, ival= 0;cnt < 4;cnt++)
		if (KS_AR[cnt].y < KS_AR[ival].y)
			ival= cnt;
	BMCoorSys->yMin= KS_AR[ival].y;

	//! Suche nach groesstem KS_AR[*].y
	for (cnt= 1, ival= 0;cnt < 4;cnt++)
		if (KS_AR[cnt].y > KS_AR[ival].y)
			ival= cnt;
		BMCoorSys->yMax= KS_AR[ival].y;

	//! Suche nach kleinstem KS_AR[*].x
	for (cnt= 1, ival= 0;cnt < 4;cnt++)
		if (KS_AR[cnt].x < KS_AR[ival].x)
			ival= cnt;
	BMCoorSys->xMin= KS_AR[ival].x;

	//! Suche nach groesstem KS_AR[*].x
	for (cnt= 1, ival= 0;cnt < 4;cnt++)
		if (KS_AR[cnt].x > KS_AR[ival].x)
			ival= cnt;
	BMCoorSys->xMax= KS_AR[ival].x;

	// compute scaling factors
	BMCoorSys->xSF= (BMCoorSys->xMax - BMCoorSys->xMin) / Screen.dx; 
	BMCoorSys->ySF= (BMCoorSys->yMax - BMCoorSys->yMin) / Screen.dy; 

	//! ab hier Berechnung des MatrixBitmap umgestellt, berechnet sich jetzt aehnlich
	//! wie ein RL-Bitmap

	addr= cy= 0;
	TCurve* ScanRep= lpDBase->GetScanReport();

	//** draw points in bitmap source
	// 07.05.2004 ScanRep->FastOpen();

	float fOmega, fThetaPsd, fTheta;
	int rmx, rmy;
	BYTE nColor;
	BOOL bOutsideData= FALSE;

	UINT nPointNumber= Scan->GetPNumber();
	DWORD MaxAddr= GetImageSize()-1;

	//!	 MaxAddr -= Screen.dx + 1;
	//! durchlaufe alle Zeilen


	for (cy= 0;cy < nScanNumber;cy++)
	{
		Scan= lpDBase->GetCurve(cy);
		Scan->SetPP();
		// 07.05.2004 Scan->FastOpen();
		ScanRep->SetPP(cy);

		//! FastPGet(x,y,z) holt Werte der Kurve und setzt ActualIdx++ (m_curve.cpp)
		ScanRep->PGet(fOmega, dd, dd); // 07.05.2004 FastP...
		fTheta= PlotWindow->GetThetaOffset(cy);
		nPointNumber= Scan->GetPNumber();
		if (!(cy % 30))
		{
			sprintf(Msg, szMsgLine308, cy, nPointNumber);
			SetInfo(Msg);
		}
		//! durchlaufe alle Spalten
		for (cx= 0;cx < nPointNumber;cx++)
		{
			//! FastPGet(x,y,z) holt Werte der Kurve und setzt ActualIdx++ (m_curve.cpp)
			Scan->PGet(fThetaPsd, fIntens, dd); // 07.05.2004 FastP...
			//! hier mit PlotWindow->CoorSys.xMin gerechnet, da Theta und der ThetaOffset
			//! nicht in BMCoorSyseinheiten umgerechnet wurden und sich somit
			//! auf ein altes Koordinatensystem beziehen
			//! berechne Koordinaten des Pixels
			if (!PlotWindow->VisualDB.bPsd)
				fTheta= 0;
			rmx= (fThetaPsd + fTheta - BMCoorSys->xMin) / BMCoorSys->xSF;
			rmy= (fOmega - BMCoorSys->yMin) / BMCoorSys->ySF;

			//! manchmal wird rmx>Screen.dx - Rundungsfehler!
			//! manchmal wird rmy>Screen.dy - Rundungsfehler!
			if (rmx > Screen.dx)
				rmx= Screen.dx;
			if (rmy > Screen.dy)
				rmy= Screen.dy;

			//! berechne Adresse des Pixels im Bitmap
			addr= rmx + (DWORD)rmy * Screen.dx;
			//! hole Farbe des Pixels fuer aktuelle Intensitaet
			nColor= (short)GetColor(fIntens);

			if (nColor == 0)
				continue;

			if (addr > MaxAddr)
			{
				sprintf(Msg, "rmx %d rmy %d dx %d dy %d Omega %f Theta %f", rmx, rmy, Screen.dx, Screen.dy, fOmega, fTheta + fThetaPsd);
				MessageBox(GetFocus(), Msg, "Fehler/Error", MBSTOP);
				bOutsideData= TRUE;
				continue;
			}
			hpData[addr]= nColor;
			//! falls "Groessere Punkte" gewaehlt, wird Punkt kuenstlich vergroessert
			if ( !PlotWindow->bIncreasePP )
				continue;
			if ( ((addr + 1) > MaxAddr) || ((addr + Screen.dx) > MaxAddr) ||
				 ((addr - 1) > MaxAddr) || ((addr - Screen.dx) > MaxAddr) )
				continue;
			hpData[addr - 1]= nColor;
			hpData[addr + 1]= nColor;
			hpData[addr - Screen.dx]= nColor;
			hpData[addr + Screen.dx]= nColor;
		}
		// 07.05.2004 Scan->FastClose();
	}
	sprintf(Msg, szMsgLine307, imin, imax);
	if (bOutsideData) strcat(Msg, szMsgLine310);

	// 07.05.2004 ScanRep->FastClose();
	SetInfo(Msg);
};
//*****************************************************************************

//! falls RL-Bitmapdarstellung, berechnet und zeichnet
//! das untersuchte Messgebiet im den reziproken Raum
void TBitmapSource::DrawMeasurementArea(HDC hdc)
{
	int dx, dy, cnt, ival;
	float dARx, dARy, mf;
	float fOmega, fTheta, offset;
	//! definiert in comhead.h typedef struct {float x, y;int Ord;} TKSystem[4];
	TKSystem KS_AR, KS_RL;
	TCoorSystem coorsys;
	HPEN hOldPen, hPenDot;
	POINT egde[5];
	float factor= M_PI / (0.5 * MeasurementParameter.GetWaveLength());
	TScreen &Screen= PlotWindow->Screen;

	//! zeichnen 2 Hilfslinien, um Measurementarea abzugrenzen
	if ( PlotWindow->eOutputType==otMatrixBitmap )
	{
		hPenDot= CreatePen(PS_DOT, 1, RGB(255, 0, 0));
		hOldPen= (HPEN)SelectObject(hdc, hPenDot);
		offset= PlotWindow->VisualDB.dThetaMinLast - PlotWindow->AltCoorSys.xMin;
		offset= offset / BMCoorSys->xSF;
		egde[0].x= Screen.x0;
		egde[0].y= Screen.y0;
		egde[1].x= Screen.x0 + offset;
		egde[1].y= Screen.y0 + Screen.dy;
		Polyline(hdc, egde, 2);
		egde[0].x= Screen.x0 + Screen.dx - offset;
		egde[0].y= Screen.y0;
		egde[1].x= Screen.x0 + Screen.dx;
		egde[1].y= Screen.y0 + Screen.dy;
		Polyline(hdc, egde, 2);
		SelectObject(hdc, hOldPen);
		DeleteObject(hPenDot);
	}
	else
	{
		PlotWindow->SetMeasurementArea(KS_AR);
		if ( !hBitmap )
		{
			//! ::RLdy ist die y-Punkte Ausdehnung im Visualising Options Menu
			Screen.dy= PlotWindow->RLdy= max((WORD)0, min((WORD)700, PlotWindow->RLdy)); 
			//! ::RLdx ist die x-Punkte Ausdehnung
			Screen.dx= ( (PlotWindow->RLdx+3) / 4) * 4;

			PlotWindow->SetRanges();
			BMCoorSys->zMax= PlotWindow->UpperBound;
			BMCoorSys->zMin= PlotWindow->LowerBound;
			switch (BMCoorSys->zScal)
			{
				case sLogarithmic:
					clogval= (float)(ColorTable.ColorMap.GetCount()-1) / log10(BMCoorSys->zMax / BMCoorSys->zMin);
					break;

				case sLinear:
				case sUser:
					clinval= (BMCoorSys->zMax - BMCoorSys->zMin);
					break;
			}
			// compute new Coordinate system ranges
			for (cnt= 0;cnt < 4;cnt++)
			{
				KS_RL[cnt].x= ArToRLx (KS_AR[cnt].y, KS_AR[cnt].x);
				KS_RL[cnt].y= ArToRLy (KS_AR[cnt].y, KS_AR[cnt].x);
				KS_RL[cnt].Ord= -1;
			}
			// sort ranges
			for (cnt= 1, ival= 0;cnt < 4;cnt++)
				if (KS_RL[cnt].y < KS_RL[ival].y)
					ival= cnt;

			BMCoorSys->yMin= KS_RL[ival].y;

			for (cnt= 1, ival= 0;cnt < 4;cnt++)
				if (KS_RL[cnt].y > KS_RL[ival].y)
					ival= cnt;

			BMCoorSys->yMax= KS_RL[ival].y;

			for (cnt= 1, ival= 0;cnt < 4;cnt++)
				if (KS_RL[cnt].x < KS_RL[ival].x)
					ival= cnt;

			BMCoorSys->xMin= KS_RL[ival].x;

			for (cnt= 1, ival= 0;cnt < 4;cnt++)
				if (KS_RL[cnt].x > KS_RL[ival].x)
					ival= cnt;

			BMCoorSys->xMax= KS_RL[ival].x;
			// compute scaling factors
			BMCoorSys->xSF= (BMCoorSys->xMax - BMCoorSys->xMin) / Screen.dx; 
			BMCoorSys->ySF= (BMCoorSys->yMax - BMCoorSys->yMin) / Screen.dy; 
			//** fix scale relation
			if (!PlotWindow->bXY_Scaling)
			{
				if (BMCoorSys->xSF < BMCoorSys->ySF)
					BMCoorSys->xSF= BMCoorSys->ySF;
				else
					BMCoorSys->ySF= BMCoorSys->xSF;
			}
			//! falls Aenderung von Werten, muss neu berechnet werden
			BMCoorSys->xMax= BMCoorSys->xMin + Screen.dx * BMCoorSys->xSF;			
			BMCoorSys->yMax= BMCoorSys->yMin + Screen.dy * BMCoorSys->ySF;

			//** center bitmap
			mf= (BMCoorSys->xMax - BMCoorSys->xMin) / BMCoorSys->xSF;
			mf= (Screen.dx - mf) / 2 * BMCoorSys->xSF;
			BMCoorSys->xMin -= mf;
			BMCoorSys->xMax -= mf;
			mf= (BMCoorSys->yMax - BMCoorSys->yMin) / BMCoorSys->ySF;
			mf= (Screen.dy - mf) / 2 * BMCoorSys->ySF;
			BMCoorSys->yMin -= mf;
			BMCoorSys->yMax -= mf;
			factor= M_PI / (0.5 * MeasurementParameter.GetWaveLength());
			BMCoorSys->xSF *= factor;
			BMCoorSys->ySF *= factor;
			BMCoorSys->xMin *= factor;
			BMCoorSys->xMax *= factor;
			BMCoorSys->yMin *= factor;
			BMCoorSys->yMax *= factor;
		}
		// access the first coordinate structure to get angle koordinate system
		coorsys= *BMCoorSys;
		factor= (0.5 * MeasurementParameter.GetWaveLength()) / M_PI;
		coorsys.xSF *= factor;
		coorsys.ySF *= factor;
		coorsys.xMin *= factor;
		coorsys.xMax *= factor;
		coorsys.yMin *= factor;
		coorsys.yMax *= factor;
		// compute frame
		for (int pp= 0;pp < 4;pp++)
		{
			dARx= KS_AR[(pp + 1) % 4].x - KS_AR[pp].x;
			dARy= KS_AR[(pp + 1) % 4].y - KS_AR[pp].y;
			switch (pp)
			{
				case 0:
					dx= dy= 1;
					break;

				case 1:
					dx= 1;
					dy= -1;
					break;

				case 2:
					dx= dy= -1;
					break;

				case 3:
					dx= -1;
					dy= 1;
					break;
			}
			for (cnt= pp * 10;cnt < (pp + 1) * 10; cnt++)
			{
				fOmega= KS_AR[pp].y + (cnt % 10) * (dARy / 10.0);
				fTheta= KS_AR[pp].x + (cnt % 10) * (dARx / 10.0);
				RLArea[cnt].x= (ArToRLx (fOmega, fTheta) - coorsys.xMin) / coorsys.xSF;
				RLArea[cnt].y= (ArToRLy (fOmega, fTheta) - coorsys.yMin) / coorsys.ySF;
				RLArea[cnt].x += dx;
				RLArea[cnt].y += dy;
			}
		}
		RLArea[RLAreaPkts-1]= RLArea[0];
		hPenDot= CreatePen(PS_DOT, 1, RGB(255, 0, 0));
		hOldPen= (HPEN)SelectObject(hdc, hPenDot);
		Polyline(hdc, RLArea, 41);
		SelectObject(hdc, hOldPen);
		DeleteObject(hPenDot);
	}
};
//*****************************************************************************

//! generiere RL-Bitmap
void TBitmapSource::GenerateRLBitmap(void)
{
	int cnt, cx, cy, rlx, rly, ival;
	//! erste Kurve holen
	TCurve* Scan= lpDBase->GetCurve(0);
	//! ScanReport holen
	TCurve* ScanRep= lpDBase->GetScanReport();
	//! Anzahl der Scans holen
	UINT nScanNumber= lpDBase->GetCNumber();
	//! Anzahl der Punkte einer Kurve holen
	UINT nPointNumber= Scan->GetPNumber();
	HPBYTE hpData;
	DWORD addr, MaxAddr= GetImageSize()-1;
	char Msg[MaxString];
	float fOmega, fThetaPsd, fTheta, fIntens, dd, mf;
	TKSystem KS_RL, KS_AR;
	double fome, fthe, factor;
	BYTE nColor;
	BOOL bOutsideData= FALSE;
	TScreen &Screen= PlotWindow->Screen;

	//! nur bei richtigem Darstellungstyp weitermachen
	if (PlotWindow->eOutputType != otReciprokeLatticeBitmap)
		return;

	//****************************************************************************
	//**** Bitmap formatieren ****************************************************
	//! Speicher fuer Bitmap reservieren
	// get pointer to data area
	hpData= (HPBYTE)hDIBData;
	if (!hpData)
	{
		
		MessageBox(GetFocus(), "Cannot create memory object (2)", "Message", MBINFO);
		return;
	}
	// inquire intensity range
	float imin= PlotWindow->MaxIntensitaet;
	float imax= PlotWindow->MinIntensitaet;
	
	if ( 1 < nScanNumber )
	{
		int cy= nScanNumber;
		while (cy--)
		{
	
			Scan= lpDBase->GetCurve(cy);
			imin= min(Scan->GetMin(P_Y), imin);
			imax= max(Scan->GetMax(P_Y), imax);
		}
	}
	else
		imin= imax= 0.0;

	sprintf(Msg, szMsgLine307, imin, imax);

	// compute cacheval for colormap
	switch (BMCoorSys->zScal)
	{
		case sLogarithmic:
			clogval= (float)(ColorTable.ColorMap.GetCount()-1) / log10(BMCoorSys->zMax / BMCoorSys->zMin);
			break;

		case sLinear:
		case sUser:
			clinval= (BMCoorSys->zMax - BMCoorSys->zMin);
			break;
	}
	// transformate data
	// KS_AR,ArToRLx (x,y) : "x" means "theta" and "y" means "omega"
	// compute new Coordinate system ranges
	PlotWindow->SetMeasurementArea(KS_AR);

	for (cnt= 0;cnt < 4;cnt++)
	{
		KS_RL[cnt].x= ArToRLx (KS_AR[cnt].y, KS_AR[cnt].x);
		KS_RL[cnt].y= ArToRLy (KS_AR[cnt].y, KS_AR[cnt].x);
		KS_RL[cnt].Ord= -1;
	}
	
	// sort ranges
	//! Suche nach kleinstem KS_RL[*].y
	for (cnt= 1, ival= 0;cnt < 4;cnt++)
		if (KS_RL[cnt].y < KS_RL[ival].y)
			ival= cnt;
	BMCoorSys->yMin= KS_RL[ival].y;

	
	//! Suche nach groesstem KS_RL[*].y
	for (cnt= 1, ival= 0;cnt < 4;cnt++)
		if (KS_RL[cnt].y > KS_RL[ival].y)
			ival= cnt;
	BMCoorSys->yMax= KS_RL[ival].y;

	
	//! Suche nach kleinstem KS_RL[*].x
	for (cnt= 1, ival= 0;cnt < 4;cnt++)
		if (KS_RL[cnt].x < KS_RL[ival].x)
			ival= cnt;
	BMCoorSys->xMin= KS_RL[ival].x;


	//! Suche nach groesstem KS_RL[*].x
	for (cnt= 1, ival= 0;cnt < 4;cnt++)
		if (KS_RL[cnt].x > KS_RL[ival].x)
			ival= cnt;
	BMCoorSys->xMax= KS_RL[ival].x;

	
	//** compute scaling factors
	BMCoorSys->xSF= (BMCoorSys->xMax - BMCoorSys->xMin) / Screen.dx; 
	BMCoorSys->ySF= (BMCoorSys->yMax - BMCoorSys->yMin) / Screen.dy; 
	if (!PlotWindow->bXY_Scaling)
	{
		//** fix scale relation
		if (BMCoorSys->xSF < BMCoorSys->ySF)
			BMCoorSys->xSF= BMCoorSys->ySF;
		else
			BMCoorSys->ySF= BMCoorSys->xSF;
	}
	//! falls Aenderung von Werten, muss neu berechnet werden
	BMCoorSys->xMax= BMCoorSys->xMin + Screen.dx * BMCoorSys->xSF;
	BMCoorSys->yMax= BMCoorSys->yMin + Screen.dy * BMCoorSys->ySF;

	//** center bitmap
	mf= (BMCoorSys->xMax - BMCoorSys->xMin) / BMCoorSys->xSF;
	mf= (Screen.dx - mf) / 2 * BMCoorSys->xSF;
	BMCoorSys->xMin -= mf;
	BMCoorSys->xMax -= mf;
	mf= (BMCoorSys->yMax - BMCoorSys->yMin) / BMCoorSys->ySF;
	mf= (Screen.dy - mf) / 2 * BMCoorSys->ySF;
	BMCoorSys->yMin -= mf;
	BMCoorSys->yMax -= mf;

	//** draw points in bitmap source
	// 07.05.2004 ScanRep->FastOpen();
	//!	 MaxAddr -= Screen.dx + 1;
	
	//! hole den Filename der aktuellen Daten
	strcpy(Msg, PlotWindow->GetFileName());
	//! Vergleich alter Filename - neuer Filename
	int filevgl= strcmp(Fileold, Msg);
	//! generiere neues "Daten"feld, wenn ...
	if ( !IsDatenInited() || m_DatenRows!=Screen.dy+1 || m_DatenCols!=Screen.dx+1 || filevgl )
	{
		CreateDaten(Screen.dy+1, Screen.dx+1);
		//! alten Filenamen speichern
		strcpy(Fileold, PlotWindow->GetFileName());
	}
	//! durchlaufe alle Zeilen
	for (cy= 0;cy < nScanNumber;cy++)
	{
		Scan= lpDBase->GetCurve(cy);
		Scan->SetPP();
		// 07.05.2004 Scan->FastOpen();
		ScanRep->SetPP(cy);

		//! FastPGet(x,y,z) holt Werte der Kurve und setzt ActualIdx++ (m_curve.cpp)
		ScanRep->PGet(fOmega, dd, dd); // 07.05.2004 FastP...
		//! diese Unterscheidung, da 0-dim. andere Datenbasisspeicherung als
		//! 1-dim Areascans (ThetaOffset mitgespeichert/nichtgespeichert)
		if (PlotWindow->VisualDB.bPsd)
			fTheta= PlotWindow->GetThetaOffset(cy);
		else
			fTheta= 0;

		nPointNumber= Scan->GetPNumber();
		if (!(cy % 30))
		{
			sprintf(Msg, szMsgLine308, cy, nPointNumber);
			SetInfo(Msg);
		}
		//! durchlaufe alle Spalten
		for (cx= 0; cx < nPointNumber; cx++)
		{

			//! FastPGet(x,y,z) holt Werte der Kurve und setzt ActualIdx++ (m_curve.cpp)
			Scan->PGet(fThetaPsd, fIntens, dd); // 07.05.2004 FastP...
			//! Farbe des Pixels fuer die aktuelle Intensitaet holen
			nColor= (short)GetColor(fIntens);
			//! nach RAD transformieren, weil COS/SIN nur dort definiert

			fthe= DegToRad(fTheta + fThetaPsd);
			fome= DegToRad(fOmega);

			if ( nColor == 0 && IsDatenInited() )
				continue;

			//! in den reziproken Raum transformieren
			rlx= (ArToRLx (fome, fthe) - BMCoorSys->xMin) / BMCoorSys->xSF;
			rly= (ArToRLy (fome, fthe) - BMCoorSys->yMin) / BMCoorSys->ySF;

			//! manchmal wird rlx>Screen.dx - Rundungsfehler!
			//! manchmal wird rly>Screen.dy - Rundungsfehler!
			if (rlx > Screen.dx)
				rlx= Screen.dx;
			if (rly > Screen.dy)
				rly= Screen.dy;

			//! Adresse des Pixels im Bitmap berechnen
			addr= rlx + (DWORD)rly * Screen.dx;
			//! falls Adresse ausserhalb des Bitmaps liegt

			if (addr > MaxAddr)
			{
				bOutsideData= TRUE;
				continue;
			}
			//! beim ersten Durchlauf "datenarray" aktualisieren
			if ( !IsDatenInited() )
			{
				if (rlx > Screen.dx || rly > Screen.dy || rlx < 0 || rly < 0)
				{
					bOutsideData= TRUE;
					continue;
				}
				//! "Daten"feld neu initialisieren
				SetOmega(rly, rlx, fOmega);
				SetTheta(rly, rlx, fThetaPsd);
			}

			hpData[addr]= nColor;
			if ( !PlotWindow->bIncreasePP )
				continue;
			if ( ((addr + 1) > MaxAddr) || ((addr + Screen.dx) > MaxAddr) ||
				 ((addr - 1) > MaxAddr) || ((addr - Screen.dx) > MaxAddr) )
				continue;
			hpData[addr - 1]= nColor;
			hpData[addr + 1]= nColor;
			hpData[addr - Screen.dx]= nColor;
			hpData[addr + Screen.dx]= nColor;
		}
		// 07.05.2004 Scan->FastClose();
	}
	// nach erstmaligen Durchlauf der Schleifen ist "datenarray" initialisiert
	m_DatenInited= TRUE;

	sprintf(Msg, szMsgLine307, imin, imax);
	if (bOutsideData) strcat(Msg, szMsgLine310);

	// 07.05.2004 ScanRep->FastClose();
	factor= M_PI / (0.5 * MeasurementParameter.GetWaveLength());
	BMCoorSys->xSF *= factor;
	BMCoorSys->ySF *= factor;
	BMCoorSys->xMin *= factor;
	BMCoorSys->xMax *= factor;
	BMCoorSys->yMin *= factor;
	BMCoorSys->yMax *= factor;
	SetInfo(Msg);
};
//*****************************************************************************

//! generiert den Header fuer ein Bitmap, setzt Koordinatensystem und Screen
void TBitmapSource::FormatDBaseToBitmapSource(void)
{
	//! char Ident[]= "AreaScan";
	LPBITMAPINFOHEADER lpBMPInfoHdr;
	LPBITMAPINFO lpBMPInfo;
	LOGPALETTE *palette;
	DWORD dwSize;
	TCurve* Scan= lpDBase->GetCurve(0);
	//! TCurve* ScanRep= lpDBase->GetScanReport();
	UINT nScanNumber= lpDBase->GetCNumber();
	UINT nPointNumber= Scan->GetPNumber();
	TScreen &Screen= PlotWindow->Screen;
	//! wenn Bitmap existiert -> loeschen
	if ( hBitmap )
		DeleteObject(hBitmap);
	hBitmap= NULL;
	//! wenn mehr als 2 Scankurven oder mehr als 2 Punkte in der Kurve
	if ((2 > nScanNumber) || (2 > nPointNumber))
	{
		//! Screen-Anpassung in Fkt. CanClose() eingebaut - Fehler 12
		//! Screen.dx= (Screen.x1 - Screen.x0) * 0.8;
		//! Screen.dy= (Screen.y1 - Screen.y0) * 0.9;
		PlotWindow->SetRanges();
		PlotWindow->AltCoorSys= PlotWindow->CoorSys;
		// compute scaling factors
		BMCoorSys->xSF= (BMCoorSys->xMax - BMCoorSys->xMin) / Screen.dx;
		BMCoorSys->ySF= (BMCoorSys->yMax - BMCoorSys->yMin) / Screen.dy;
		return;
	}

	// inquire measurement Ranges
	PlotWindow->SetRanges();
	PlotWindow->AltCoorSys= PlotWindow->CoorSys;
	BMCoorSys->xScal= BMCoorSys->yScal= sLinear;
	if (BMCoorSys->xMin <= 0.0)
		BMCoorSys->xMin= 0.0001;
	if (BMCoorSys->yMin <= 0.0)
		BMCoorSys->yMin= 0.0001;

	//******** create header for device independend bitmap ***********************
	dwSize= sizeof(BITMAPINFO) + ColorTable.ColorMap.GetCount() * sizeof(RGBQUAD);
	if (hDIBInfo)
		//! the GlobalReAlloc function changes the size or attributes
		//! of a specified global memory object
		hDIBInfo= HeapReAlloc(GetProcessHeap(),0, hDIBInfo, dwSize);
	else
		hDIBInfo= (HGLOBAL)HeapAlloc(GetProcessHeap(),0,dwSize);
	if (!hDIBInfo)
	{
		MessageBox(GetFocus(), "Cannot create memory object (1)", "Message", MBINFO);
		return;
	}
	lpBMPInfo= (LPBITMAPINFO)hDIBInfo;
	lpBMPInfoHdr= &lpBMPInfo->bmiHeader;
	lpBMPInfoHdr->biSize= sizeof(BITMAPINFOHEADER);
	lpBMPInfoHdr->biPlanes= 1;
	lpBMPInfoHdr->biBitCount= 8;
	lpBMPInfoHdr->biSizeImage= 0; // Because BI_RGB
	lpBMPInfoHdr->biCompression= BI_RGB;
	lpBMPInfoHdr->biXPelsPerMeter= lpBMPInfoHdr->biYPelsPerMeter= 0;
	lpBMPInfoHdr->biClrUsed= ColorTable.ColorMap.GetCount();
	lpBMPInfoHdr->biClrImportant= 0;
	// Palette bereitstellen
	palette= CreateDefaultPalette();
	FillBMInfoFromPalette(palette);
	//************ compute bitmap size ****************
	switch (PlotWindow->eOutputType)
	{
		case otReciprokeLatticeBitmap:
			//! ::RLdy ist die y-Punkte Ausdehnung im Visualising Options Menu
			Screen.dy= PlotWindow->RLdy= max((WORD)0, min((WORD)800, PlotWindow->RLdy)); 
			//! ::RLdx ist die x-Punkte Ausdehnung
			Screen.dx= ( (PlotWindow->RLdx+3) / 4) * 4;
			lpBMPInfoHdr->biWidth= Screen.dx;
			lpBMPInfoHdr->biHeight= Screen.dy;
			break;

		case otMatrixBitmap:
			//! Groesse x-Achse gleich der Anzahl der Kurvenpunkte
			//! ::RLdy ist die y-Punkte Ausdehnung im Visualising Options Menu
			Screen.dy= PlotWindow->RLdy= max((WORD)0, min((WORD)800, PlotWindow->RLdy)); 
			//! ::RLdx ist die x-Punkte Ausdehnung
			Screen.dx= ( (PlotWindow->RLdx+3) / 4) * 4;
			lpBMPInfoHdr->biWidth= Screen.dx;
			lpBMPInfoHdr->biHeight= Screen.dy;
			break;

		default:
			MessageBox(GetFocus(), "Unknown OutputType", "Message", MBINFO);
	}
	// allocate memory for bitmap bits
	if (hDIBData)
		HeapFree(GetProcessHeap(),0,hDIBData);

	hDIBData= (HGLOBAL)HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,GetImageSize());
	SetInfo(szMsgLine309);
	switch (PlotWindow->eOutputType)
	{
		case otReciprokeLatticeBitmap:
			GenerateRLBitmap();
			break;

		case otMatrixBitmap:
			GenerateAngleSpaceBitmap();
			break;
	}
};
//*****************************************************************************

//! Zwischenablageoperation, wenn Typ CF_DIB
HGLOBAL TBitmapSource::RenderDIB(void)
{
	HGLOBAL hMem;
	long szInfo;
	HPBYTE hpNewData;
	HPBYTE hpData;
	LPBITMAPINFO lpBMPInfo;

	lpBMPInfo= (LPBITMAPINFO)hDIBInfo;
	if (hDIBData && lpBMPInfo)
	{
		szInfo= sizeof(BITMAPINFO)
				 + (lpBMPInfo->bmiHeader.biClrUsed - 1) * sizeof(RGBQUAD);
		
		hMem= (HGLOBAL)HeapAlloc(GetProcessHeap(),0,szInfo + HeapSize(GetProcessHeap(),0,hDIBData));
		if (hMem)
		{
			hpNewData= (HPBYTE)hMem;
			memcpy(hpNewData, lpBMPInfo, (int)szInfo);
			hpData= (HPBYTE)hDIBData;
			// move bitmap bits
			memcpy(hpNewData + szInfo, hpData, HeapSize(GetProcessHeap(),0,hDIBData));
		}
		return hMem;
	}
	else
		return NULL;
};

//##############################################################################
// TCurveFreeScalColorWindow
//##############################################################################

//! Konstruktor
TCurveFreeScalColorWindow::TCurveFreeScalColorWindow(HINSTANCE aInstance, TPlotWindow *aPlotWindow) : TMDIWindow(aInstance)
{
	PlotWindow= aPlotWindow;
	PlotWindow->BSource->UserFarb= this;
}
//*****************************************************************************

//! Destruktor
TCurveFreeScalColorWindow::~TCurveFreeScalColorWindow()
{
	char buf[MaxString];
	RECT rc, rcm;

	GetWindowRect(GetFrameHandle(), &rcm );
	GetWindowRect(GetHandle(), &rc);
	sprintf(buf, "%d", rc.left - rcm.left - 4);
	WritePrivateProfileString("UserScal", "xo", buf, GetCFile());
	sprintf(buf, "%d", rc.top - rcm.top - 42 );
	WritePrivateProfileString("UserScal", "yo", buf, GetCFile());
	PlotWindow->BSource->UserFarb= NULL;
}
//*****************************************************************************

//! Titel setzen
BOOL TCurveFreeScalColorWindow::SetTitle()
{
	strcpy( m_Title, szMsgLine311 );
	return TMDIWindow::SetTitle();
};
//*****************************************************************************

//! neues Fenster bauen
void TCurveFreeScalColorWindow::OnCreate()
{
	RECT rc;

	//! lese ini-File fuer Fensterposition
	rc.left= GetPrivateProfileInt("UserScal", "xo", 0, GetCFile());
	rc.top= GetPrivateProfileInt("UserScal", "yo", 0, GetCFile());
	SetWindowPos(GetHandle(), HWND_TOP, rc.left, rc.top, 375, 325, SWP_NOZORDER);
	SetTitle();
}
//*****************************************************************************

//! wenn Fensterinhalt neu gezeichnet werden muss
void TCurveFreeScalColorWindow::DoPaint(HDC hdc, PAINTSTRUCT *)
{
	DrawColorTable(hdc);
}
//*****************************************************************************

//! zeichnet den Inhalt des Fensters
void TCurveFreeScalColorWindow::DrawColorTable(HDC hdc)
{
	int cnt, i, red, green, blue;
	int yrand= 20, xlrand= 50, xrrand= 80, fs= 14;
	LOGPALETTE *pPal;
	PALETTEENTRY *pPE;
	char buf[30];
	HBRUSH hBrush, hBrushOld;
	HPEN hPen, hPenOld;
	POINT aPoints[5];
	HPALETTE hPal, hDefPal;
	HFONT hFont, hOldFont;
	LOGFONT lf;
	SIZE tagS;
	TBitmapSource* BitmapSource= PlotWindow->BSource;

	//! Font selektieren
	memset(&lf, 0, sizeof(LOGFONT));
	lf.lfHeight= fs;
	lf.lfWidth= 0;
	lf.lfWeight= 200;
	lf.lfUnderline= FALSE;
	strcpy(lf.lfFaceName, "Times New Roman");
	hFont= CreateFontIndirect(&lf);
	hOldFont= (HFONT)SelectObject(hdc, hFont);

	//! Palette aufbauen
	pPal= BitmapSource->GetPalette();
	hPal= CreatePalette(pPal);
	hDefPal= SelectPalette(hdc, hPal, FALSE);
	RealizePalette(hdc);

	pPE= pPal->palPalEntry;

	//! male Farbverlauf
	for (cnt= BitmapSource->ColorTable.ColorMap.GetCount()-1; cnt >=0; cnt--)
	{
		red= pPE[cnt].peRed;
		green= pPE[cnt].peGreen;
		blue= pPE[cnt].peBlue;
		hBrush= CreateSolidBrush(RGB(red, green, blue));
		if (cnt == BitmapSource->ColorTable.ColorMap.GetCount()-1)
			hBrushOld= (HBRUSH)SelectObject(hdc, hBrush);
		hPen= CreatePen(PS_SOLID, 1, RGB(red, green, blue));
		if (cnt == BitmapSource->ColorTable.ColorMap.GetCount()-1)
			hPenOld= (HPEN)SelectObject(hdc, hPen);

		SelectObject(hdc, hBrush);
		SelectObject(hdc, hPen);

		//! male Markierungen rechts am Farbverlauf
		aPoints[0].y= aPoints[1].y= BitmapSource->ColorTable.ColorMap.GetCount()-1 - cnt + yrand;
		aPoints[0].x= xlrand;
		aPoints[1].x= xrrand;

		Polyline(hdc, aPoints, 2);
		SetTextAlign(hdc, TA_TOP);
		SelectObject(hdc, hBrushOld);
		DeleteObject(hBrush);
		SelectObject(hdc, hPenOld);
		DeleteObject(hPen);

		//! male Markierungen fuer "reine Farben"
		int t= BitmapSource->ColorTable.ColorMap.GetCount()-1 - cnt;
		if ( t == 0 || t == 51 || t == 101 || t == 151 || t == 201 || t == 255 )
		{
			SetTextAlign(hdc, TA_LEFT);

			sprintf(buf, szMsgLine312, t);
			GetTextExtentPoint(hdc, buf, strlen(buf), &tagS);
			TextOut(hdc, xrrand + 10, cnt + yrand - (lf.lfHeight / 2), (LPSTR)buf, strlen(buf));

			hPen= CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
			hPenOld= (HPEN)SelectObject(hdc, hPen);
			aPoints[0].x= xrrand;
			aPoints[0].y= aPoints[1].y= cnt + yrand;
			aPoints[1].x= xrrand + 5;
			Polyline(hdc, aPoints, 2);
			SelectObject(hdc, hPenOld);
			DeleteObject(hPen);
		}
	}
	//! schreibe links und rechts oben Text aus...
	SetTextAlign(hdc, TA_LEFT);

	sprintf(buf, szMsgLine313);
	GetTextExtentPoint(hdc, buf, strlen(buf), &tagS);
	TextOut(hdc, xlrand - 40, yrand - 17, (LPSTR)buf, strlen(buf));

	sprintf(buf, szMsgLine314);
	GetTextExtentPoint(hdc, buf, strlen(buf), &tagS);
	TextOut(hdc, xrrand + 200, yrand - 17, (LPSTR)buf, strlen(buf));

	hPen= CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
	hPenOld= (HPEN)SelectObject(hdc, hPen);

	//! male und schreibe Farben und Intensitaeten
	for (i= 0;i < 8;i++)
	{
		int y= BitmapSource->ColorTable.ColorMap.GetCount()-1 - BitmapSource->farbe[i] + yrand;
		aPoints[0].x= xlrand;
		aPoints[0].y= aPoints[1].y= y;
		aPoints[1].x= xlrand - 5;
		Polyline(hdc, aPoints, 2);
		SetTextAlign(hdc, TA_LEFT);
		sprintf(buf, "%d", i + 1);
		GetTextExtentPoint(hdc, buf, strlen(buf), &tagS);
		y-= (lf.lfHeight / 2);
		if (i % 2)
			TextOut(hdc, xlrand - 15, y, (LPSTR)buf, strlen(buf));
		else
			TextOut(hdc, xlrand - 25, y, (LPSTR)buf, strlen(buf));

		red= pPE[BitmapSource->farbe[i]].peRed;
		green= pPE[BitmapSource->farbe[i]].peGreen;
		blue= pPE[BitmapSource->farbe[i]].peBlue;
		hBrush= CreateSolidBrush(RGB(red, green, blue));
		hBrushOld= (HBRUSH)SelectObject(hdc, hBrush);

		SelectObject(hdc, hBrush);
		SelectObject(hdc, hPen);

		int x= xrrand + 180;
		y= BitmapSource->ColorTable.ColorMap.GetCount()-1 + yrand - i*32 - 20;
		Rectangle(hdc, x, y, 
			           x+20, y+20);

		SelectObject(hdc, hBrushOld);
		DeleteObject(hBrush);

		SetTextAlign(hdc, TA_LEFT);

		y=- (lf.lfHeight / 2) - 10;
		sprintf(buf, szMsgLine315, i + 1);
		GetTextExtentPoint(hdc, buf, strlen(buf), &tagS);
		TextOut(hdc, xrrand + 90, y, (LPSTR)buf, strlen(buf));
		sprintf(buf, "%.2f", BitmapSource->ber[i]);
		GetTextExtentPoint(hdc, buf, strlen(buf), &tagS);
		TextOut(hdc, xrrand + 210, y, (LPSTR)buf, strlen(buf));
	}
	//! zeichne Rand um Farbskala
	aPoints[0].x= aPoints[1].x= aPoints[4].x= xlrand;
	aPoints[0].y= aPoints[3].y= aPoints[4].y= yrand;
	aPoints[1].y= aPoints[2].y= BitmapSource->ColorTable.ColorMap.GetCount()-1 + yrand + 1;
	aPoints[2].x= aPoints[3].x= xrrand;

	Polyline(hdc, aPoints, sizeof(aPoints) / sizeof(POINT));

	SelectObject(hdc, hPenOld);
	DeleteObject(hPen);
	SelectObject(hdc, hOldFont);
	DeleteObject(hFont);

	SelectPalette(hdc, hDefPal, FALSE);
	DeleteObject(hPal);
};