#ifndef __HWGUIDS_H_
#define __HWGUIDS_H_

#include <objbase.h>
#include <initguid.h>

/////////////////////////////////////////////////////////////////
// Treiber GUIDs

// C812 {E175F924-5E59-4bf9-8C6A-330D038F44F7}
#ifndef GUID_C812
#ifdef MOTORS_TESTDRIVER
DEFINE_GUID(GUID_C812, 0x38aee6f2, 0xce4a, 0x486b, 0xb1, 0x12, 0xe0, 0xa8, 0xdd, 0x7b, 0x24, 0xc5);
#else
DEFINE_GUID(GUID_C812, 0xe175f924, 0x5e59, 0x4bf9, 0x8c, 0x6a, 0x33, 0xd, 0x3, 0x8f, 0x44, 0xf7);
#endif
#endif

// C832 {B719EE70-4284-487f-9A36-08FFB44C4849}
#ifndef GUID_C812
#ifdef MOTORS_TESTDRIVER
DEFINE_GUID(GUID_C832, 0x2d510007, 0xbe9c, 0x4d21, 0x8e, 0x9f, 0x6b, 0xf8, 0x41, 0xce, 0x1d, 0x75);
#else
DEFINE_GUID(GUID_C832, 0xb719ee70, 0x4284, 0x487f, 0x9a, 0x36, 0x8, 0xff, 0xb4, 0x4c, 0x48, 0x49);
#endif
#endif

// Radicon {}
#ifndef GUID_RADICON
#ifdef DETECTORS_TESTDRIVER
DEFINE_GUID(GUID_RADICON, 0x50329159, 0xde2c, 0x40a9, 0xa8, 0xa3, 0x1c, 0x74, 0xe6, 0xe3, 0x4a, 0x6);
#else
DEFINE_GUID(GUID_RADICON, 0x136145c7, 0x20a6, 0x4288, 0xb2, 0xdb, 0xb5, 0xa2, 0x8d, 0x31, 0x5d, 0xa3);
#endif
#endif

// TAm9513 {}
#ifndef GUID_TAM9513
#ifdef DETECTORS_TESTDRIVER
//{A1E5CEA1-55E5-4e35-B73D-55AAAB2E6259}
DEFINE_GUID(GUID_TAM9513, 0xa1e5cea1, 0x55e5, 0x4e35, 0xb7, 0x3d, 0x55, 0xaa, 0xab, 0x2e, 0x62, 0x59);
#else
//{AFC2B720-2B05-4529-9938-B0EE5A066D98}
DEFINE_GUID(GUID_TAM9513, 0xafc2b720, 0x2b05, 0x4529, 0x99, 0x38, 0xb0, 0xee, 0x5a, 0x6, 0x6d, 0x98);
#endif
#endif

// Braun-PSD 
#ifndef GUID_BRAUNPSD
#ifdef DETECTORS_TESTDRIVER
//{BA45A11F-D348-4d64-8CA1-0EC7E5A5A2FC}
DEFINE_GUID(GUID_BRAUNPSD, 0xba45a11f, 0xd348, 0x4d64, 0x8c, 0xa1, 0xe, 0xc7, 0xe5, 0xa5, 0xa2, 0xfc);
#else
//{B0338401-574B-478a-AB1D-DC209872758E}
DEFINE_GUID(GUID_BRAUNPSD, 0xb0338401, 0x574b, 0x478a, 0xab, 0x1d, 0xdc, 0x20, 0x98, 0x72, 0x75, 0x8e);
#endif
#endif

// Stoe-PSD {}
#ifndef GUID_STOEPSD
#ifdef DETECTORS_TESTDRIVER
DEFINE_GUID(GUID_STOEPSD, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0);
#else
DEFINE_GUID(GUID_STOEPSD, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0);
#endif
#endif

#endif
