// (C) 1993,1994 by Heiko Damerow MPG AG "Roentgenbeugung"

#ifndef _EVRYTHNG_H
#define _EVRYTHNG_H

#ifndef RC_INVOKED
 #include "utils\u_utils.h"
#endif

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

// Welche Sprache? Ist das Symbol definiert: Deutsch; sonst Englisch.
// Jeder der dieses Symbol benutzen mchte MUSS EVRYTHNG.H inkludieren!!!
#define GermanVersion				1

#define    MaxString           512

#define	M_PI	3.14159265358979323846

// Voreinstellungen
enum EScrollBarSide {sbsLeft= 55, sbsRight= 56};

#define   LenAdditionalInfo    40

/* benutzt im Motor- und Detektorsubsystem; knnte meistens durch BOOL ersetzt werden */
#define  R_Failure         202
#define  R_OK              999
#define  R_SoftOverflow    216

/* Benutzt in counters.cpp, testdev.cpp */
#define DetectorTimerIdStart   100

/* Benutzt in Motor- und Detektorsubsystem, alte Topographie, alte Manuelle Justage */
#define   TimerIdInformation 399

/* HPBYTE, HPFLOAT: Benutzt in m_data.cpp, m_device.cpp */
/* HPSTR: benutzt in m_arscan.cpp (Allerdings Verdacht auf toten Code) */
/* HPWORD: NICHT BENUTZT */
#if defined(__FLAT__)
typedef char* HPSTR;
typedef BYTE* HPBYTE;
typedef float* HPFLOAT;
typedef WORD* HPWORD;
#else

typedef char _huge * HPSTR;
typedef BYTE _huge * HPBYTE;
typedef float _huge * HPFLOAT;
typedef WORD _huge * HPWORD;
#endif

enum EUnitType
{
	utGrad= 1, utMinuten, utSekunden, utMillimeter, utMikrometer, utChannel, utNone
};

// Skalierung fr x, y, z-Achse von Step- und AreaScan und der Analogdarstellung des CounterWindows
enum EScale
{
	sLogarithmic= 1, sLinear, sUser
};

// parsen eines Einheitenbezeichners
EUnitType _CURVECLASS WINAPI UnitEnum( LPSTR );
// rechnet <fValParam> entsprechend <aUnit> um und gibt dieses zurck
float _CURVECLASS WINAPI CalcValueInUnit(EUnitType aUnit, float fValParam);
// rechnet <fValParam> entsprechend <aUnit> zurck und gibt dieses zurck
float _CURVECLASS WINAPI CalcValueFromUnit(EUnitType aUnit, float fValParam); // macht die Berechnung von CalcValueInUnit rckgngig und umgekehrt

class TMDIWindow; // forward

//#############################################################################
// IMainEvents
//#############################################################################

class IMainEvents { // Beobachter-Interface fr Ereignisse von TMain
protected:
	 IMainEvents() {};
	 IMainEvents( const IMainEvents& ) {}; // kein Copy-Konstruktor
	 IMainEvents& operator= ( const IMainEvents& ) {}; // kein Zuweisungsoperator

// um ber die folgenden Ereignisse benachrichtigt zu werden, muss IMainEvents eingeerbt werden und sich bei Main angemeldet werden
public:  
     // das Hauptprogramm wird beendet
     virtual void OnLeave ()= 0; // falls sich das Objekt hier freigibt: ZUVOR abmelden (siehe TTopography::OnLeave)
};

//#############################################################################
// TMain
//#############################################################################

class TMain
{
public:
	TMain( void );
	virtual  ~TMain( void );

	BOOL Init( HINSTANCE hInstance, int cmdShow );
	void InitHardware();

	BOOL HasNewManJustage ( void )
	{
		return m_NewManJustage;
	};

//Scan-Fenster und deren Handle's
public:
	TMDIWindow* ScanWindow;
	TMDIWindow* AreaScanWindow;
	//Datum 16.05.2003: TMDIWindow*      AdjustmentWindow;
	//Datum 16.05.2003: TMDIWindow*      CCDLineScanWindow;
	//Datum 16.05.2003: TMDIWindow*      AreaScanCCDWindow;
	HWND hScanWindow;
	HWND hAreaScanWindow;
	//Datum 16.05.2003: HWND             hCCDLineScanWindow;
	//Datum 16.05.2003: HWND             hAreaScanCCDWindow;
	//Datum 16.05.2003: HWND             hActualWindow;

// ANFANG: neu Kullmann+Reinecker (31.01.2004) anderen Klassen gestatten auf Ereignisse zur reagieren
public: 
	bool AddToEventList(IMainEvents *);
	bool RemoveFromEventList(IMainEvents *);
private:
	TIndList m_EventHandler;
// ENDE: neu Kullmann+Reinecker (31.01.2004)

private:
	// Init
	HMENU CreateMenuBar( void );  

	// Ereignisse
	LRESULT OnCommand(HWND hWindow, WPARAM wParam, LPARAM lParam); // alle WM_Command
	void OnSize(HWND);
	void OnPaint(HWND);
	void OnMenuInit( void );
	void OnMenuSelect(HWND, WPARAM, LPARAM);

	void SetWatchIndicator( long );
	void SetParameters( void );
	//21.04.2004 void TellMessage( int );

	// Fensterposition laden/ speichern
	void LoadPos( void );
	void SavePos( void );

	//Statuszeile
	void CreateStatusBar( HINSTANCE, HWND );
	void BlastStatusLine( HWND, int );
	void DrawStatus( HWND, ATOM, int );

	//27.04.2004 BOOL GetDataDlg( LPSTR, int* );

//ATTRIBUT(E)
private:
	BOOL m_NewManJustage;

	// Welche Programmfunktionen fr den Anwender sichtbar machen?
	BOOL AreaScanExtention, ScanExtention, MacroExtention, TopographyExtention;

	HMENU hTheMenu;	
	static HACCEL hAccellerator;
	HWND hwndStatusBar; // Statuszeile
	// 16.06.2004 HBITMAP bmpStatusLine;

	//24.04.2004 int CurrentID;
	//24.04.2004 HMENU CurrentPopup;
	char StatusInfo[2*MaxString];
	char AdditionalInfo[LenAdditionalInfo];

// neu fr Hintegrundbilder
public:
	HWND hwndClient; // Clientbereich (wo die MDI-Fenster rein kommen)
	WNDPROC DefMdiClientProc;
	static LRESULT CALLBACK EventHandlerMdiClient(HWND, UINT, WPARAM, LPARAM); // fr Clientbereich (wo die MDI-Fenster rein kommen)

//STATIC
public:
	static LRESULT CALLBACK EventHandler( HWND, UINT, WPARAM, LPARAM );
	static int MessageLoop( void );
};

//#############################################################################
// TMDIWindow
//#############################################################################

enum EPaintType {ptEntire= 0, ptPaintPoint, ptFlush};

class TMDIWindow : public TBasicMDIWindow
{
public:
	TMDIWindow ( HINSTANCE );  // Fenster erzeugen (nicht anzeigen)
	virtual ~TMDIWindow ( void ); // Fenster ausblenden und freigeben

	LRESULT Show ( void ); // Fenster anzeigen; zurck gibt's das Fensterhandle oder NULL

// berschreiben von Methoden aus der Basisklasse; waren vorher alle, bis auf OnCommand, direkt in OnEvent implementiert
protected:
	virtual HICON GetIcon ( void ) const;

	virtual HCURSOR GetCursor( void )
	{
		return LoadCursor( NULL, IDC_ARROW );
	};
	virtual LPCSTR ClassName( void )
	{
		return "Nutzerfenster";
	};
	virtual LPCSTR GetCharacteristic( void )
	{
		return "Fenster";
	};

	virtual void OnRButtonDown ( WPARAM wParam, LPARAM lParam );
	virtual void OnTimer ( WPARAM, LPARAM ); 
	virtual void OnNotCreated ( void ); 
	virtual void OnMenuSelect ( WPARAM, LPARAM );
	virtual LRESULT OnCommand ( WPARAM, LPARAM );

public:
	virtual BOOL CanOpen ( void ); //Anzahl der Fenster beschrnken
	virtual BOOL CanClose( void ); //vor dem Schlieen, Messung abbrechen

// zum Ausgrauen der Hauptmenpunkte 
public:
	virtual BOOL CanNew() // Datei -> Neu
	{ return FALSE; }
	virtual BOOL CanOpenFile() // Datei -> Nachladen
	{ return FALSE; }
	virtual BOOL CanSave() // Datei -> Sichern
	{ return FALSE; }
	virtual BOOL IsScanning(BOOL &PsdContinious) // Ausfhren -> Makro abbrechen
	{ PsdContinious= FALSE; return FALSE; }
	virtual BOOL IsInterrupted() // Ausfhren -> Makro abbrechen
	{ return bInterrupted; }

// neu Zeichnen
public:	
	virtual void UpdateWnd( EPaintType= ptEntire );
protected:
	bool bUserPaint;
	BOOL WholeWnd( void );

// Virtuelle Funktionen zum Abwickeln von Ablaeufen
protected:	
	// Hauptmen Bearbeiten -> Kopieren
	virtual void DoCopy( void ) {};

	//! Ablaufsteuerung
	virtual void SteeringReady( LPARAM ) {}; // Ende
	virtual void SteeringReset( LPARAM ) {}; // Abbruch	
	//Datum 05.06.2004 virtual void DistanceSetRequest( LPARAM ) {};
	virtual void Interrupt(); //! unterbricht Scanvorgang
	virtual void TimerRequest( WPARAM ) {}; // Timer

	//! erhaelt Messpunkt, stellt ihn dar, speichert ihn ggf.
	virtual void CounterSetRequest( LPARAM ) {};

protected:
	BOOL bInterrupted;
	HMENU hHoleMenu, // als Dummy fr LoadMenu, wenn es benutzt wird, soll TheMenu ein Untermen dessen sein
		  TheMenu;   // DAS Kontextmen, das beim Klick auf die rechte Maustaste angezeigt wird

protected:
	BOOL bPaintPoint;
	static int s_WindowCount;  // Fenster-Zaehler
};

//#############################################################################
// TFileWindow
//#############################################################################

// Klasse die das Laden, Speichern von Dateien und die Verwaltung des Dateinamens sowie den Gespeichert-Status verwaltet

enum EAskType {atDefault, atNewName, atNoAsk};

// MDI-Fenster mit Datei neu/ laden/ speichern Untersttzung
class TFileWindow : public TMDIWindow {
public:
	TFileWindow( HINSTANCE ); // Fenster erzeugen (nicht anzeigen)

// berschriebenes aus der (Fenster-)Basisklasse
protected:
	virtual LRESULT OnCommand ( WPARAM, LPARAM ); 
	virtual BOOL CanClose( void ); //*** Daten schon gespeichert?

	virtual BOOL CanNew() // Datei -> Neu
	{ return TRUE; }
	virtual BOOL CanOpenFile() // Datei -> Nachladen
	{ return TRUE; }
	virtual BOOL CanSave() // Datei -> Sichern
	{ return TRUE; }

// Hauptmen Datei ->
public:
	virtual BOOL New( void ); // Neu
	virtual BOOL LoadOldData(); // Nachladen
	virtual BOOL SaveFile( EAskType=atDefault ); // Sichern
	virtual BOOL SaveFileAs( void ); // Sichern als...

	virtual BOOL UpdateFile( void )
	{
		return FALSE;
	};

// Zugriff auf Dateiname, Status der letzten Speicherung
public:
	LPSTR GetFileName( void )
	{
		return FileName;
	};

	BOOL SetFileName( LPSTR );

	void FileChange( void ) {
		bFileChanged= TRUE;
	};

	BOOL IsModified( void ) {
		return bFileChanged;
	};

//ATTRIBUT(E)
public:
	char szDataPath[MaxString]; // benutzt durch die Dialogfenster zum Laden/ Speichern

protected:
	BOOL bOldDataLoaded;
	BOOL bIsNewFile;
	BOOL bFileChanged;
	char FileName[2*MaxString];
	char szFilter[MaxString];
	char szExtension[4];
};

#endif //ifndef _EVRYTHNG_H
