//******************************************************************************
//Datei     : mespara.h
//Projekt   : XCTL
//Subsystem : Allgemeine Einstellungen
//Autor     : Jens Klier <klier@informatik.hu-berlin.de>
//            Institut fuer Informatik,
//            Humboldt-Universitaet Berlin
//Inhalt    : Interface der Klasse TMeasurementParameter
//******************************************************************************
//!neu klier Allgemeine Einstellungen

#define MaxString 512

struct THKL
{
	int h, k, l;
};

class TMeasurementParameter
{
public:
	TMeasurementParameter();
	void Load( LPCSTR IniFile );
	void Save( LPCSTR IniFile );
	LPCSTR GetComment( void );
	void SetComment( LPCSTR sCom );
	LPSTR GetReflection( LPSTR sRef );
	LPSTR GetReflection( THKL& thklRef, LPSTR sRef );
	BOOL SetReflection( LPCSTR sRef );
	LPSTR GetOrientation( LPSTR SOri );
	LPSTR GetOrientation( THKL& thklOri, LPSTR sOri );
	BOOL SetOrientation( LPCSTR sOri );
	LPCSTR GetUser( void );
	void SetUser( LPCSTR sUse );
	LPCSTR GetTarget( void );
	void SetTarget( LPCSTR sTar );
	LPCSTR GetTargetBulk( void );
	void SetTargetBulk( LPCSTR sTaB );
	LPSTR GetWaveLength( LPSTR WaL );
	float GetWaveLength( void );
	BOOL SetWaveLength( LPCSTR sWaL );
	LPSTR GetVoltage( LPSTR sVol );
	int GetVoltage( void );
	BOOL SetVoltage( LPCSTR sVol );
	BOOL SetVoltage( const int& iVol );
	LPSTR GetCurrent( LPSTR sCur );
	int GetCurrent( void );
	BOOL SetCurrent( LPCSTR sCur );
	BOOL SetCurrent( const int& iVol );

private:
	void GetHKL( THKL& thklHKL, LPSTR sHKL );
	BOOL SetHKL( THKL& thklHKL, LPCSTR sHKL );

	char sUser[MaxString];
	char sComment[2*MaxString];
	char sTarget[MaxString];
	char sTargetBulk[MaxString];

	THKL thklReflection;
	THKL thklOrientation;
	float fWaveLength;
	int iVoltage;
	int iCurrent;
	char szApplication[MaxString];
};

// LastLine


