// File m_mothw.h
// (C) 1993,1994 by Heiko Damerow MPG AG "Roentgenbeugung"
#ifndef __M_MOTHW_H
#define __M_MOTHW_H

#include "utils\u_utils.h"
#include "motrstrg\motorcontroller.h"

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

union tpos
{
	char byte[ 4 ];
	long pos;
};

class TDC_Drive : public TMotor
{
public:
	TDC_Drive( void );
	// Funktionen, die untergeordnete Pendants aufrufen
	BOOL GetPosition( BOOL );
	long GetFailure( void );
	BOOL MoveByPosition( long );
	BOOL MoveToPosition( long );
	virtual BOOL SetMoment( float )
	{
		return TRUE;
	};
	virtual float GetMoment( void )
	{
		return 1.0;
	};
	BOOL SetSpeed( double );
	double GetSpeed( void );
	virtual int SaveSettings( BOOL );
	BOOL PushSettings( void );
	BOOL PopSettings( void );
	virtual BOOL SetVelocity( DWORD )
	{
		return TRUE;
	};
	virtual BOOL SetAcceleration( DWORD )
	{
		return TRUE;
	};
	virtual DWORD GetVelocity( void )
	{
		return 1;
	};
	virtual DWORD GetAcceleration( void )
	{
		return 1;
	};
protected:
	virtual int Initialize( void );
	virtual BOOL ActivateDrive( void )
	{
		return FALSE;
	};
	virtual BOOL Reset( void )
	{
		return FALSE;
	};
	virtual BOOL ActivateFilterParameters( void )
	{
		return FALSE;
	};
	WORD wDeathBand;
	WORD wDynamicFailure;
	WORD wDeccelerationPoint;
	WORD wMaxTorque;
	// Spezifische Funktionen
	virtual BOOL CheckBoardOk( void )
	{
		return FALSE;
	};
	virtual BOOL IsMoveFinish( void )
	{
		return FALSE;
	};
	virtual BOOL IsLimitHit( void )
	{
		return FALSE;
	};
	virtual BOOL _GetPosition( long * )
	{
		return FALSE;
	};
	virtual BOOL _GetFailure( long * )
	{
		return FALSE;
	};
	virtual BOOL MoveRelative( long )
	{
		return FALSE;
	};
	virtual BOOL MoveAbsolute( long )
	{
		return FALSE;
	};
private:
	int nMaxError;
};

class TC_812 : public TDC_Drive
{
	friend class TOptimizeDC_812Dlg;

public:
	TC_812( void );

	virtual int ExecuteCmd( char* )
	{
		return R_OK;
	};
	void OptimizingDlg( void );

protected:
	int SaveSettings( BOOL );
	virtual int Reset( void );
	virtual BOOL CheckBoardOk( void )
	{
		return TRUE;
	};
	virtual BOOL SetHome( void );
	virtual BOOL _GetPosition( long* );
	virtual BOOL _GetFailure( long* );
	BOOL ActivateDrive( void );
	BOOL ActivateFilterParameters( void );
	BOOL SetMoment( float );
	float GetMoment( void );
	virtual BOOL IsMoveFinish( void );
	BOOL SetLine( int, BOOL );
	BOOL IsLimitHit( void );
	BOOL IsIndexArrived( void );
	BOOL StartToIndex( long& );
	BOOL StopDrive( BOOL ); // Kullmann, Reinecker (08.08.02) Parameter gendert int -> BOOL
	BOOL MoveRelative( long );
	BOOL MoveAbsolute( long );
	WORD GetStatus( void );
	int nWaitTicks;
	WORD wTorque;
	WORD wStaticGain;
	WORD wDynamicGain;
	int nOnBoardId;

private:
	BOOL SetLimit( DWORD );
	BOOL SetVelocity( DWORD );
	DWORD GetVelocity( void );
	BOOL SetStaticGain( WORD );
	WORD GetStaticGain( void );
	BOOL SetDynamicGain( WORD );
	WORD GetDynamicGain( void );
	BOOL SetTorque( WORD );
	WORD GetTorque( void );
	BOOL SetAcceleration( DWORD );
	DWORD GetAcceleration( void );
};


class TC_812ISA : public TC_812
{
public:
	TC_812ISA( void );

protected:
	int ExecuteCmd( char* );
	BOOL CheckBoardOk( void );
	BOOL SetHome( void );
	void StartCheckScan( void );
	// the following functions can used the direct access
	BOOL IsMoveFinish( void );
	BOOL _GetPosition( long* );
	BOOL _GetFailure( long* );

private:
	int PutChar( const char );
	char GetChar( void );
	DWORD dwBaseAddr;

	TC_812Controller* Hardware;
};

class TC_832 : public TDC_Drive
{
	friend class TOptimizeDC_832Dlg;

public:
	TC_832( void );

	BOOL StopLimitWatch( void );
	BOOL StartLimitWatch( void );
	void ( *lpfnLimitWatch ) ( UINT, UINT, DWORD, DWORD, DWORD );
	void OptimizingDlg( void );

protected:
	int SaveSettings( BOOL );
	BOOL ActivateFilterParameters( void );
	BOOL CheckBoardOk( void );
	BOOL ActivateDrive( void );
	void StartCheckScan( void );
	int Reset( void );
	WORD wKI;    //  IntegralGain
	WORD wKL;    //  IntegralLimit
	WORD wKP;    //  StaticGain
	WORD wKD;    //  DynamicGain

private:
	long Drive628( BYTE, WORD, long );
	int ExecuteCmd( LPSTR );
	BOOL IsMoveFinish( void );
	BOOL IsLimitHit( void );
	BOOL IsIndexArrived( void );
	BOOL StartToIndex( long & );
	BOOL StopDrive( BOOL ); // Kullmann, Reinecker (08.08.02) Parameter gendert int -> BOOL
	BOOL SetLimit( DWORD );
	BOOL SetVelocity( DWORD );
	DWORD GetVelocity( void );
	BOOL SetHome( void );
	BOOL SetAcceleration( DWORD );
	DWORD GetAcceleration( void );
	WORD GetStatus( void );
	BOOL _GetPosition( long * );
	BOOL _GetFailure( long * );
	BOOL MoveRelative( long );
	BOOL MoveAbsolute( long );
	
	WORD wBaseAddr;
	int nOnBoardId;
	BYTE cConfig;
	WORD wSample;
	
	TC_832Controller* Hardware;
	DWORD ControllerIndex;
	UINT nEvent;
	const WORD CmdRegister;
	const WORD DataRegister;

	WORD baddr;
	WORD raddr;
};

class TPosControlDlg : public TModalDlg
{
public:
	TPosControlDlg( );

	// ANFANG Kullmann+Reinecker (12.03.2004)
	typedef enum EPosType {eMin, ePos, eMax};
	int ScrollbarCalculate( TMotor *act, EPosType aType );  //Neu : Kullmann, Reinecker (14.11.02) const beim Parameter entfernt, sonst const-member-functions im Motor ntig	
	/*int GetBarRange( TMotor * ); 
	int GetBarPos( TMotor * );   */
	// ENDE Kullmann+Reinecker (12.03.2004)

	BOOL HScrollBar( WPARAM, LPARAM );
	BOOL Dlg_OnInit( HWND, HWND, LPARAM );
	void Dlg_OnCommand( HWND, int, HWND, UINT );
	void Dlg_OnTimer( HWND, UINT );
	void LeaveDialog( void );

private:
	long NewPosition;
	HWND BarHandle;
	HWND hMotorList;
	BOOL bMoveActive;
	LPMotor Motor;
};

class TMotorParamDlg : public TModalDlg
{
public:
	TMotorParamDlg( void );

	BOOL Dlg_OnInit( HWND, HWND, LPARAM );
	void Dlg_OnCommand( HWND, int, HWND, UINT );
	BOOL CanClose( void );

private:
	LPMotor Motor;
	BOOL Flag;
	float SpeedScale;
	HWND hMotorList;
};

class TCalibrateDlg : public TModalDlg
{
public:
	TCalibrateDlg( int );
	virtual  ~TCalibrateDlg( void );

private:
	BOOL Dlg_OnInit( HWND, HWND, LPARAM );
	void Dlg_OnCommand( HWND, int, HWND, UINT );
	void Dlg_OnTimer( HWND, UINT );
	BOOL CanClose( void );
	void LeaveDialog( void );
	HWND hMotorList;
	LPMotor Motor;
	BOOL nTask; // Kullmann, Reinecker (08.08.02) Parameter gendert int -> BOOL
	long* lOldPos;
	BOOL* bIndexPosReached;
	BOOL* bZeroPosReached;
	BOOL* bTargetPosReached;
	BOOL bValidCalibrationData;
	BOOL bZeroShouldSet;
	BOOL bAllMotors;
	BOOL bHoldPosition;
};

class TOptimizeDC_832Dlg : public TModalDlg
{
public:
	TOptimizeDC_832Dlg( void );

private:
	BOOL CanClose( void );
	void Dlg_OnCommand( HWND, int, HWND, UINT );
	BOOL Dlg_OnInit( HWND, HWND, LPARAM );
	void LeaveDialog( void );
	TC_832* Drive;
	DWORD old_vel, old_accel;
	WORD old_kd, old_kp, old_ki, old_kl;
	WORD old_poswidth;
	BOOL bCancel;
};

class TOptimizeDC_812Dlg : public TModalDlg
{
public:
	TOptimizeDC_812Dlg( void );

private:
	BOOL CanClose( void );
	void Dlg_OnCommand( HWND, int, HWND, UINT );
	BOOL Dlg_OnInit( HWND, HWND, LPARAM );
	void LeaveDialog( void );
	TC_812 *Drive;
	DWORD old_vel, old_accel;
	WORD old_gain, old_dgain, old_torque;
	WORD old_poswidth;
	BOOL bCancel;
};

#endif 
// _M_MOTHW_H
// __LastLine__
