//******************************************************************************
//Datei     : TProtocolDiffractometryDlg.h
//Projekt   : XCTL
//Subsystem : Protokollbuch
//Autor     : Jens Klier <klier@informatik.hu-berlin.de>
//            Institut fuer Informatik,
//            Humboldt-Universitaet Berlin
//Inhalt    : Interface der Klasse TProtocolDiffractometryDlg
//******************************************************************************
//!neu klier Protokollbuch

#include "utils\u_utils.h" // fr TModalDlg

class TProtocolDiffractometryDlg : public TProtocolDlg, public TModalDlg
{
public:
#include "protocol\TProtocolDiffractometryParameter.h" // enthlt enum TDiffractometryParameter

	TProtocolDiffractometryDlg( LPSTR, int idDlg= -1 );

private:
	BOOL Dlg_OnInit( HWND, HWND, LPARAM );
	void Dlg_OnDestroy( HWND );
	void Dlg_OnCommand( HWND, int, HWND, UINT );
	BOOL Dlg_OnSysCommand( HWND, int, LPARAM );
	BOOL CanClose( void );
	void Dlg_OnLButtonUp( HWND, int, int, UINT );
	void Dlg_OnLButtonDown( HWND, UINT, int, int, UINT );
	void Dlg_OnMouseMove( HWND, int, int, UINT );
	void Dlg_OnRButtonDown( HWND, UINT, int, int, UINT );
	void Dlg_OnNotify( HWND, int, UINT, UINT );

	void ShowDialog( int, int );

	void InitializeDlgItems( HWND );
	void SaveDlgItems( HWND );

	int GetDlg( int );
	BOOL ManageDlg( HWND, int, TAction );
	BOOL TestPflichtDlg( HWND );
	void RefreshCombobox( void );
	void RefreshScanachse( int );
	void RefreshDetektor( void );

	/*
	  LPSTR GetMeasurementParameter( HWND, int, int, LPSTR );
	  void MeasurementParameterError( HWND, int, int, LPSTR );
	*/

	LPSTR GetDlgItemText_LfdNr( HWND, LPSTR );
	BOOL TestDlgItemText_LfdNr( HWND, LPSTR );
	void SetDlgItemText_LfdNr( HWND );
	void EnableDlgItem_LfdNr( BOOL );

	BOOL IsDlgItemModify( void );

	int GetStatusId( void );
	int GetDatumId( void );

	void EnableAreaScan( BOOL );
	void EnableOmega2Theta( BOOL );
	void EnableContinuous( BOOL );
	void EnablePSD( BOOL );

	BOOL PSD, Continuous, Omega2Theta, AreaScan;
	int Scanachse, ScanachseAnzahl;

	HWND hScanartList, hScanmethodeList, hScantypList, hScanachseList;
	HWND hAArtList, hDetektorList, hMonitorList;

	enum {ProbeSkizzeDlg= 1, MessungDlg, ScanDlg, BlendeAbsorberDlg,
		  DetektorDlg, BemerkungDlg};
};


// LastLine

