//******************************************************************************
//Datei     : TProtocolLanguage.cpp
//Projekt   : XCTL
//Subsystem : Protokollbuch
//Autor     : Jens Klier <klier@informatik.hu-berlin.de>
//            Institut fuer Informatik,
//            Humboldt-Universitaet Berlin
//Inhalt    : Interface der Klasse TProtocolLanguage
//******************************************************************************
//!neu klier Protokollbuch
#ifndef _TPROTOCOLLANGUAGE_H
#define _TPROTOCOLLANGUAGE_H

class TProtocolLanguage
{
public:
	enum TLanguage {german, english};

	TProtocolLanguage( void );
	void InitializeDlgLanguage( HWND );
	void SetTopographyDlgLanguage( HWND );
	void SetTopographyDlgLanguage( HWND, int );
	void SetTopographyManagePrintDlgLanguage( HWND );
	void SetDiffractometryDlgLanguage( HWND );
	void SetDiffractometryDlgLanguage( HWND, int );
	void SetDiffractometryManagePrintDlgLanguage( HWND );
	void SetParameterDlgLanguage( HWND );
	void SetPasswortDlgLanguage( HWND );
	void SetLanguage( TLanguage );
	LPCSTR GetFailure( void );
	LPCSTR GetWarning( void );
	LPCSTR GetQuestion( void );
	LPCSTR GetMessage( int= 0);
	LPCSTR TranslateParameter( LPCSTR );

private:
	HMENU hProtocolSystemMenu;

	void TranslateParameter( HWND, int );
	void SetDlgLanguage( int );
	void SetProtocolDlgLanguage( HWND );
	void SetProtocolManagePrintDlgLanguage( HWND );
	void SetProtocolLanguageDlgMenu(void);

	void TabCtrl_SetItemText( HWND, int, LPCSTR);
	void ListView_SetColumnText( HWND, int, LPCSTR);

	TLanguage ProtocolLanguage;
	char *strFailure, *strWarning, *strQuestion;
	char *strMessage[70];

	char lParameter[MaxString];
};

#endif //ndef _TPROTOCOLLANGUAGE_H

// LastLine

