//******************************************************************************
//Datei     : TProtocolTopographyDlg.h
//Projekt   : XCTL
//Subsystem : Protokollbuch
//Autor     : Jens Klier <klier@informatik.hu-berlin.de>
//            Institut fuer Informatik,
//            Humboldt-Universitaet Berlin
//Inhalt    : Interface der Klasse TProtocolTopographyDlg
//******************************************************************************
//!neu klier Protokollbuch

#include "utils\u_utils.h" // fr TModalDlg

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

class TProtocolTopographyDlg : public TProtocolDlg, public TModalDlg
{
public:
#include "protocol\TProtocolTopographyParameter.h" // enthlt enum TTopographyParameter

	TProtocolTopographyDlg( LPSTR, int idDlg= -1 );

private:
	BOOL Dlg_OnInit( HWND, HWND, LPARAM );
	void Dlg_OnDestroy( HWND );
	void Dlg_OnCommand( HWND, int, HWND, UINT );
	BOOL Dlg_OnSysCommand( HWND, int, LPARAM );
	BOOL CanClose( void );
	void Dlg_OnLButtonUp( HWND, int, int, UINT );
	void Dlg_OnLButtonDown( HWND, UINT, int, int, UINT );
	void Dlg_OnMouseMove( HWND, int, int, UINT );
	void Dlg_OnRButtonDown( HWND, UINT, int, int, UINT );
	void Dlg_OnNotify(HWND, int, UINT, UINT);

	void ShowDialog( int, int );

	void InitializeDlgItems( HWND );
	void SaveDlgItems( HWND );

	int GetDlg( int );
	BOOL ManageDlg( HWND, int, TAction );
	BOOL TestPflichtDlg( HWND );

	LPSTR GetDlgItemText_LfdNr( HWND, LPSTR );
	BOOL TestDlgItemText_LfdNr( HWND, LPSTR );
	void SetDlgItemText_LfdNr( HWND );
	void EnableDlgItem_LfdNr( BOOL );

	BOOL IsDlgItemModify( void );

	int GetStatusId( void );
	int GetDatumId( void );

	HWND hLfdNrBereich, hRTKNr;
	HWND hLieferantList, hKMaterialList, hRMaterialList;

	enum {ProbeSkizzeDlg= 1, KollimatorRoehreDlg, MessungFilmeDlg, BeginnMessungDlg,
		  EndeMessungDlg};
};


// LastLine

