//#############################################################################
//                                                                           //
// M_DLG.H                                                                   //
//                                                                           //
// Subsystem : Develop; GUI-Oberflchenfenster                               //
// Benutung durch andere Subsysteme erforderlich: NEIN                       //
// Implementation: M_DLG.CPP, M_DEVICE.CPP                                   //
//---------------------------------------------------------------------------//
// letzte Bearbeitung: Thomas Kullmann, Gnther Reinecker                    //
// Stand:   27.07.2002                                                       //
//                                                                           //
//#############################################################################

#ifndef __M_DLG_H
#define __M_DLG_H

#include "utils\u_utils.h"

#include "detecuse\detecuse.h" //! neu Kullmann+Reinecker: fr TDetector
#include "difrkmty\d_intern.h" // fr EScale

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

//#############################################################################
// TExecuteCmdDlg
//#############################################################################

class TExecuteCmdDlg : public TModalDlg
{ //********* Direkte Eingabe von Kommandos *******************
public:
	TExecuteCmdDlg();
	BOOL Dlg_OnInit( HWND, HWND, LPARAM );
	void Dlg_OnCommand( HWND, int, HWND, UINT );
	int ExecutionId;
	int nMotor;
};

//#############################################################################
// TGetDataDlg
//#############################################################################

class TGetDataDlg : public TModalDlg
{
public:
	TGetDataDlg( LPSTR, int* );
private:
	BOOL Dlg_OnInit( HWND, HWND, LPARAM );
	BOOL CanClose( void );
	int *dataref;
	char datatext[40];
};

//#############################################################################
// TCounterWindow
//#############################################################################

class TCounterWindow : public TMDIWindow
{
	friend class TCounterShowParamDlg;
public:
	TCounterWindow( HINSTANCE, TDetector* = 0 );
	virtual  ~TCounterWindow( );

	static TCounterWindow *GetWindow() {
		return s_Singleton;
	}

protected:
	virtual HCURSOR GetCursor( void )
	{
		return (HCURSOR)LoadImage( NULL, IDC_ARROW, IMAGE_CURSOR, 0, 0, LR_DEFAULTCOLOR );
	};
	LPCSTR ClassName()
	{
		return "MDetector";
	};
	LPCSTR GetCharacteristic( void )
	{
		return "Detector";
	};

	virtual void OnCreate();
	virtual BOOL SetTitle( void );
	virtual LRESULT OnCommand ( WPARAM, LPARAM );
	virtual void OnSize( WPARAM, LPARAM );
	virtual void OnPopupMenuInit ( WPARAM, LPARAM );
	virtual void OnFocus( void );
	virtual BOOL CanOpen( void );
	virtual void OnLButtonDown( WPARAM, LPARAM );
	virtual void DoPaint( HDC, PAINTSTRUCT* );
	virtual void CounterSetRequest( LPARAM );

public:
	void SetupLogging( void );	
	void ShowCounterSetRequest(float);

//ATTRIBUT(E)
private:
	BOOL bShowAsDigital;
	char FontName[MaxString];
	RECT ClientRect, WndRect;
	BOOL bWriteLogFile;
	EScale eScaleType;
	float fMaxIntensity;
	TDetector *Sensor;
	
	BOOL bQuiteOpen;


	/* 31.04.2004 MEMCORRECT (verwende IField) HGLOBAL hMemG; 
#if defined( __FLAT__ )

	float *IField;
#else

	float _huge *IField;
#endif*/
	TFloatList IField;


	float fData;
	int nIdx;
	int nBarCount;
	HPEN hPen;
	HBRUSH hBrushWhite, hBrushBlack, hBrushRed, hBrushOC;
	float fThickness, fHight;
	BOOL bAnalogSwitchOn;
	BOOL bWindowWillBeOpen;

	static TCounterWindow *s_Singleton;
};

//#############################################################################
// TCounterShowParamDlg
//#############################################################################

class TCounterShowParamDlg : public TModalDlg
{
public:
	TCounterShowParamDlg( TCounterWindow* );
private:
	TCounterWindow *CounterWnd;
	BOOL CanClose( void );
	BOOL Dlg_OnInit( HWND, HWND, LPARAM );
};

#endif // __M_DLG_H

//#############################################################################
// LASTLINE
//#############################################################################
