#ifndef _TOPOGRFY_H
#define _TOPOGRFY_H

//! neu Kullmann+Reinecker: wo waren vorher die includes??
#include "detecuse\detecuse.h"

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

class TTopographyExecuteDlg : public TModalDlg
{
public:
	TTopographyExecuteDlg( void );
	BOOL Dlg_OnInit( HWND, HWND, LPARAM );
	void Dlg_OnCommand( HWND, int, HWND, UINT );
	void Dlg_OnTimer( HWND, UINT );
	void LeaveDialog( void );
private:
	BOOL bControlActive;
	BOOL bSetupOk;
	BOOL bStartPointOk;
	int RestShots;
	BOOL bStarted;
	BOOL bTimeFinish;
	BOOL bAdditionalTime;
	BOOL bExeptionOccured;
	BOOL bTimeRunning;
	DWORD CurrentTime, StartTime;
	TDetector *Detector;
	int nMotor;
};

class TTopographySetParamDlg : public TModalDlg
{
public:
	TTopographySetParamDlg( int );
	char SensorList[7][30];
	BOOL CanClose( void );
	void Dlg_OnCommand( HWND, int, HWND, UINT );
	BOOL Dlg_OnInit( HWND, HWND, LPARAM );
	void LeaveDialog( void );
private:
	int nRestrictions;
	HWND hDetectorList, hMotorList;
	int nMotor;
	//JP 12.08.2002 int      nOldMotor;
	TDetector *Detector;  //## Detektor
	TDetector *Monitor;
};


class TTopographyOld
{
	friend TTopographyExecuteDlg;
	friend TTopographySetParamDlg;
public:
	TTopographyOld( void );
	void Initialize( void );
protected:
	BOOL bSmallAngleSide;
	// Klein-Winkel= TRUE
	WORD nNumberCycle;       // Anzahl der Mess-Zyklen
	float fWorkPoint;         // Arbeitspunkt
	float fControlRange;      // Regel-Bereich nach Intensitaet
	float fControlStep;       // Regel-Schrittweite
	float fMoveStep;          // Schrittweite zum Anfahren des Arbeitspunktes
	float fMaxAngleEscape;    // Bei Weglaufen der Regelung
	long lMeasurementTime;   // Mess-Zeit in Sekunden je Zyklus
	int nMotor;             // Regelmotor
	TDetector *Sensor;             // Messgeraet
	float fFailure;           // Zur Konfiguration des Zaehlers
	float fMaxTime;           // Maximale Messzeit
	DWORD dwMaxCounts;        // Maximale Anzahl Impulse
	BOOL bMonitorUsed;       // Flag fuer Monitor
	TDetector *Monitor;            // Zweiter Zaehler fuer Monitor-Signal
	BOOL bMultibleShot;      // Mehrfach-Belichtungen
	double dStartAngle;        // Startwinkel relativ zum Peak
	float fAngleBetweenShots; // Abstand bei Mehrfachbelichtung
};

//*****************************************************************************
#endif 
// _TOPOGRFY_H
// __LastLine__
