//##############################################################################
//                                                                            //
// TP_GUI.H                                                                   //
//                                                                            //
// Subsystem : Topographie / Oberflche                                       //
// Benutzung durch andere Subsysteme erforderlich: NEIN                       //
//----------------------------------------------------------------------------//
// Autoren:  Thomas Kullmann, Gnther Reinecker (2002)                        //
//                                                                            //
// Stand  : 20.01.2003                                                        //
// letzter vollstndiger Test: 11.01.2003                                     //
//                                                                            //
//##############################################################################

#ifndef _TP_GUI_H
#define _TP_GUI_H

#include "topogrfy\tp_funk.h"

#include "swintrac\m_dlg.h"

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

//#############################################################################
// TTopographyExecDlg
//#############################################################################

class TTopographyExecDlg : public TModalDlg, public ITimer
{
	//-----------------------------------------------------------------------------
	// Konstruktor
public:
	TTopographyExecDlg( void );
	//-----------------------------------------------------------------------------
	// berschriebene Methoden der Basisklasse
public:
	virtual BOOL Dlg_OnInit( HWND, HWND, LPARAM );

	// hier kommen die Windows-Botschaften an
	virtual void Dlg_OnCommand( HWND, int, HWND, UINT );

	// Behandlung von Timer-Ereignissen
	virtual void OnTimer( TBasicTimer *const );

	virtual void LeaveDialog( void );
	//-----------------------------------------------------------------------------
	// Methoden zur Ereignissbehandlung
private:
	// Zeitueberpruefung waehrend der Mehrfachbelichtung
	void Dlg_OnMultipleExpose( void );

	// Aenderung des Messzustandes (Messung laeuft <-> keine Messung)
	void Dlg_OnSwitchControl( void );

	// Initalisierung
	void Dlg_OnInitialize( void );

	// Button "Startposition einstellen" wurde ausgewaehlt
	void Dlg_OnGotoWorkPoint( void );

	// Arbeitspunkt wurde eingestellt
	void Dlg_OnSetupPosition( void );

	// Steering hat Aktion beendet
	void Dlg_OnSteeringReady( void );

	// es liegen neue Zaehlerwerte vor
	void Dlg_OnCounterSet( void );

	// Der Nutzer hat mit Return eine neue Mezeit eingegeben
	void Dlg_OnExposureTime( void );

	// Button "Einstellungen" wurde betaetigt
	void Dlg_OnTopographyParam( void );

	// Anzeigen im Topographie Ausfuehren Fenster aktualisieren
	void Dlg_OnParamSet( void );

	// es ist moeglicherweise ein Abbruchfall eingetreten
	void Dlg_OnInquireException( void );

	//-----------------------------------------------------------------------------
	// Attribute
private:
	TTopography *m_lnkTopography; // die Funktionalitt
	TInterfaceTimer *m_lnkTimerMeasuring; // POLLING-Timer
	TInterfaceTimer *m_lnkTimerMultiExpose; // POLLING-Timer
};

//#############################################################################
// TTopographyAdjustDlg
//#############################################################################

class TTopographyAdjustDlg : public TModalDlg
{
	//-----------------------------------------------------------------------------
	// Konstruktor
public:
	TTopographyAdjustDlg( int );
	//-----------------------------------------------------------------------------
	// Methoden der Basisklasse
public:
	virtual BOOL Dlg_OnInit( HWND, HWND, LPARAM );
	virtual void Dlg_OnCommand( HWND, int, HWND, UINT );
	virtual BOOL CanClose( void );
	virtual void LeaveDialog( void );
	//-----------------------------------------------------------------------------
	// Methoden zur Ereignisbehandlung
private:
	// aktualisieren der Anzeige/Eingabefelder
	void Dlg_OnParamSet( void );

	// Motor Auswahlbox wurde angewaehlt
	void Dlg_OnChooseMotor( UINT );

	// Detektor Auswahlbox wurde angewaehlt
	void Dlg_OnChooseDetector( UINT );

	// Aktivieren bzw. Deaktivieren der Mehrfachbelichtungs-Checkbox
	void Dlg_OnMultipleShot( void );
	//-----------------------------------------------------------------------------
	// Attribute
private:
	TTopography *m_lnkTopography; // die Funktionalitt
	BOOL m_bCtrlStatus; // Flag von wo aus der Dialog geoeffnet wurde
};

#endif 
// ----------------------------------------------------------------------------
// __LastLine__
