//******************************************************************************
//Datei     : TManageComboboxProtocolDlg.cpp
//Projekt   : XCTL
//Subsystem : Protokollbuch
//Autor     : Jens Klier <klier@informatik.hu-berlin.de>
//            Institut fuer Informatik,
//            Humboldt-Universitaet Berlin
//Inhalt    : Implementation der Klasse TManageComboboxProtocolDlg
//******************************************************************************
//!neu klier Protokollbuch

#include "internls\evrythng.h"
#include "protocol\TProtocol.h"
#include "protocol\TManageComboboxProtocolDlg.h"

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

void TManageComboboxProtocolDlg::InitializeManageComboboxProtocolDlg(TProtocol *Proto)
{
	Protocol= Proto;
};

// Initialisiert eine Combobox mit Werten aus einer ini-Datei/Parameterliste
void TManageComboboxProtocolDlg::InitializeCombobox(HWND hwnd, HWND &hCBoxList, int id, int Nr, LPCSTR Name)
{
	char buf[MaxString], CName[MaxString], *token;
	int i;

	hCBoxList= GetDlgItem( hwnd, id );
	ComboBox_ResetContent(hCBoxList);

	if ( strstr(Name, ",") == NULL )
	{
		ComboBox_AddString( hCBoxList, "-" );
		strcpy( CName, Name );
		strcat( CName, itoa(i= 0, buf, 10) );
		if ( (strstr(Name, "Motor") == NULL) && (strstr(Name, "Device") == NULL) )
			GetPrivateProfileString(Protocol->GetProtocolSection(), CName, "", buf, MaxString, GetCFile());
		else
			GetPrivateProfileString(CName, "Name", "", buf, MaxString, GetHWFile());
		while ( strlen(buf) != 0 )
		{
			if (ComboBox_FindString(hCBoxList, -1, buf) == CB_ERR)
				ComboBox_AddString( hCBoxList, buf );
			strcpy( CName, Name );
			strcat( CName, itoa(++i, buf, 10) );
			if ( (strstr(Name, "Motor") == NULL) && (strstr(Name, "Device") == NULL) )
				GetPrivateProfileString(Protocol->GetProtocolSection(), CName, "", buf, MaxString, GetCFile());
			else
				GetPrivateProfileString(CName, "Name", "", buf, MaxString, GetHWFile());
		}
	}
	else
	{
		strcpy(buf, Name);
		token= strtok(buf, ",");
		do
		{
			if (ComboBox_FindString(hCBoxList, -1, token) == CB_ERR)
				ComboBox_AddString( hCBoxList, token );
		} while ( (token= strtok(NULL, ",")) != NULL);
		ComboBox_SetCurSel( hCBoxList, 0);
	}
	Edit_LimitText(GetWindow(hCBoxList, GW_CHILD), Protocol->GetParameterMaxLen(Nr));
};

// Fgt einen Wert in eine Combobox ein
void TManageComboboxProtocolDlg::AddComboboxItem(HWND hCBoxList, LPCSTR Item)
{
	int iSel;

	iSel= ComboBox_GetCurSel(hCBoxList);
	if (ComboBox_FindString(hCBoxList, -1, Item) != CB_ERR)
		return;
	ComboBox_AddString( hCBoxList, Item );
	if (iSel == CB_ERR)
		ComboBox_SetCurSel(hCBoxList, 0);
	else
		ComboBox_SetCurSel(hCBoxList, iSel);
};

// Fgt einen Wert in eine Combobox ein und whlt ihn aus
void TManageComboboxProtocolDlg::AddAndSelectComboboxItem(HWND hCBoxList, LPCSTR Item)
{
	if (strlen(Item) > 0)
		if ( ComboBox_FindString(hCBoxList, -1, Item) == CB_ERR )
			ComboBox_AddString(hCBoxList, Item);
	ComboBox_SetCurSel(hCBoxList, -1);
	ComboBox_SelectString(hCBoxList, -1, Item);
};

// lscht einen Wert aus einer Combobox
void TManageComboboxProtocolDlg::DeleteComboboxItem(HWND hCBoxList, LPCSTR Item)
{
	int iSel, iFind;

	iSel= ComboBox_GetCurSel(hCBoxList);
	if ((iFind= ComboBox_FindString(hCBoxList, -1, Item)) == CB_ERR)
		return;
	ComboBox_DeleteString(hCBoxList, iFind);
	if (iSel == CB_ERR)
		ComboBox_SetCurSel(hCBoxList, 0);
	else
		if (ComboBox_SetCurSel(hCBoxList, iSel) == CB_ERR)
			ComboBox_SetCurSel(hCBoxList, iSel - 1);
};

// Speichert die Werte einer Combobox in der Programm-ini-datei
void TManageComboboxProtocolDlg::SaveCombobox(HWND hwnd, int id, LPCSTR Name)
{
	char buf[MaxString], buf2[MaxString], CName[MaxString];
	int i;
	BOOL bFind;

	GetDlgItemText(hwnd, id, buf, MaxString);
	if (strlen(buf) > 0)
	{
		bFind= FALSE;
		strcpy( CName, Name );
		strcat( CName, itoa(i= 0, buf2, 10) );
		GetPrivateProfileString(Protocol->GetProtocolSection(), CName, "", buf2, MaxString, GetCFile());
		while ( strlen(buf2) != 0 )
		{
			if (strcmp(buf, buf2) == 0)
				bFind= TRUE;
			strcpy( CName, Name );
			strcat( CName, itoa(++i, buf2, 10) );
			GetPrivateProfileString(Protocol->GetProtocolSection(), CName, "", buf2, MaxString, GetCFile());
		}
		if ( !bFind )
			WritePrivateProfileString(Protocol->GetProtocolSection(), CName, buf, GetCFile());
	}
};


// LastLine

