//******************************************************************************
//Datei     : TProtocolDiffractometry.cpp
//Projekt   : XCTL
//Subsystem : Protokollbuch
//Autor     : Jens Klier <klier@informatik.hu-berlin.de>
//            Institut fuer Informatik,
//            Humboldt-Universitaet Berlin
//Inhalt    : Implementation der Klasse TProtocolDiffractometry <-- TProtocol
//******************************************************************************
//!neu klier Protokollbuch

#include "internls\evrythng.h"
#include <ctype.h>

//! neu: klier Allgemeine Einstellungen
#include "mespara\mespara.h"

#include "protocol\TProtocolLanguage.h"
#include "protocol\TProtocol.h"
#include "protocol\TProtocolDiffractometry.h"

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

//!neu klier Allgemeine Einstellungen
extern TMeasurementParameter *MeasurementParameter;


TProtocolDiffractometry::TProtocolDiffractometry() : TProtocol(Feldelemente)
{
	int i= 0;

	if ( Parameter != NULL )
	{
		strcpy(Parameter[i].Name, "Lfd.-Nr.");
		Parameter[i++].MaxLen= 8;
		strcpy(Parameter[i].Name, "Datum");
		Parameter[i++].MaxLen= 10;
		strcpy(Parameter[i].Name, "Nutzer");
		Parameter[i++].MaxLen= 15;
		strcpy(Parameter[i].Name, "Probennummer");
		Parameter[i++].MaxLen= 25;
		strcpy(Parameter[i].Name, "Material");
		Parameter[i++].MaxLen= 20;
		strcpy(Parameter[i].Name, "Orientierung");
		Parameter[i++].MaxLen= 6;
		strcpy(Parameter[i].Name, "Untersuchter Reflex");
		Parameter[i++].MaxLen= 6;
		strcpy(Parameter[i].Name, "Fehlschnitt Winkel");
		Parameter[i++].MaxLen= 6;
		strcpy(Parameter[i].Name, "Fehlschnitt Richtung");
		Parameter[i++].MaxLen= 6;
		strcpy(Parameter[i].Name, "Scanart");
		Parameter[i++].MaxLen= 10;
		strcpy(Parameter[i].Name, "Scanmethode");
		Parameter[i++].MaxLen= 15;
		strcpy(Parameter[i].Name, "Strom");
		Parameter[i++].MaxLen= 3;
		strcpy(Parameter[i].Name, "Spannung");
		Parameter[i++].MaxLen= 3;
		strcpy(Parameter[i].Name, "Wellenlnge");
		Parameter[i++].MaxLen= 8;
		strcpy(Parameter[i].Name, "Messdateiname");
		Parameter[i++].MaxLen= 32;
		strcpy(Parameter[i].Name, "Scantyp");
		Parameter[i++].MaxLen= 15;
		strcpy(Parameter[i].Name, "Scanachse1");
		Parameter[i++].MaxLen= 15;
		strcpy(Parameter[i].Name, "Offset1");
		Parameter[i++].MaxLen= 8;
		strcpy(Parameter[i].Name, "Minnimum1/Start1");
		Parameter[i++].MaxLen= 8;
		strcpy(Parameter[i].Name, "Maximum1/Ende1");
		Parameter[i++].MaxLen= 8;
		strcpy(Parameter[i].Name, "Schrittweite1/Bereichsgre1");
		Parameter[i++].MaxLen= 8;
		strcpy(Parameter[i].Name, "Geschwindigkeit1");
		Parameter[i++].MaxLen= 8;
		strcpy(Parameter[i].Name, "Scanachse2");
		Parameter[i++].MaxLen= 10;
		strcpy(Parameter[i].Name, "Offset2");
		Parameter[i++].MaxLen= 10;
		strcpy(Parameter[i].Name, "Minnimum2/Start2");
		Parameter[i++].MaxLen= 10;
		strcpy(Parameter[i].Name, "Maximum2/Ende2");
		Parameter[i++].MaxLen= 10;
		strcpy(Parameter[i].Name, "Schrittweite2/Bereichsgre2");
		Parameter[i++].MaxLen= 10;
		strcpy(Parameter[i].Name, "Geschwindigkeit2");
		Parameter[i++].MaxLen= 10;
		strcpy(Parameter[i].Name, "Primrstrahlblende horizontal");
		Parameter[i++].MaxLen= 4;
		strcpy(Parameter[i].Name, "Primrstrahlblende vertikal");
		Parameter[i++].MaxLen= 4;
		strcpy(Parameter[i].Name, "Detektorblende horizontal");
		Parameter[i++].MaxLen= 4;
		strcpy(Parameter[i].Name, "Detektorblende vertikal");
		Parameter[i++].MaxLen= 4;
		strcpy(Parameter[i].Name, "Absorber Art");
		Parameter[i++].MaxLen= 6;
		strcpy(Parameter[i].Name, "Absorber Faktor");
		Parameter[i++].MaxLen= 10;
		strcpy(Parameter[i].Name, "Detektor");
		Parameter[i++].MaxLen= 10;
		strcpy(Parameter[i].Name, "Messzeit");
		Parameter[i++].MaxLen= 6;
		strcpy(Parameter[i].Name, "Impulse");
		Parameter[i++].MaxLen= 10;
		strcpy(Parameter[i].Name, "Distanz/PSD Winkelbereich");
		Parameter[i++].MaxLen= 8;
		strcpy(Parameter[i].Name, "PSD Kanalabstand");
		Parameter[i++].MaxLen= 8;
		strcpy(Parameter[i].Name, "PSD Kanalnummer");
		Parameter[i++].MaxLen= 8;
		strcpy(Parameter[i].Name, "PSD Addiere");
		Parameter[i++].MaxLen= 6;
		strcpy(Parameter[i].Name, "Monitordetektor");
		Parameter[i++].MaxLen= 10;
		strcpy(Parameter[i].Name, "Bemerkung");
		Parameter[i++].MaxLen= 161;
		strcpy(Parameter[i].Name, "Status");
		Parameter[i++].MaxLen= 1;
	}
	strcpy(szProtocolSection, "ProtocolDiffractometry");
};

void TProtocolDiffractometry::InitializeDefaultParameter( void )
{
	if ( bDebug )
		MessageBox(GetFocus(), "InitializeDefaultParameter!", "Debug Info", MBINFO);
	if (IsProtocolOn() && IsProtocolOnBegin())
	{
		GetProtocolValue(Scanart, DefaultScanart);
		GetProtocolValue(Scanmethode, DefaultScanmethode);
		GetProtocolValue(Messdatei, DefaultMessdatei);
		GetProtocolValue(Scantyp, DefaultScantyp);
		GetProtocolValue(Scanachse1, DefaultScanachse1);
		GetProtocolValue(SOffset1, DefaultSOffset1);
		GetProtocolValue(Minimum1, DefaultMinimum1);
		GetProtocolValue(Maximum1, DefaultMaximum1);
		GetProtocolValue(Schrittweite1, DefaultSchrittweite1);
		GetProtocolValue(Geschwindigkeit1, DefaultGeschwindigkeit1);
		GetProtocolValue(Scanachse2, DefaultScanachse2);
		GetProtocolValue(SOffset2, DefaultSOffset2);
		GetProtocolValue(Minimum2, DefaultMinimum2);
		GetProtocolValue(Maximum2, DefaultMaximum2);
		GetProtocolValue(Schrittweite2, DefaultSchrittweite2);
		GetProtocolValue(Geschwindigkeit2, DefaultGeschwindigkeit2);
		GetProtocolValue(Detektor, DefaultDetektor);
		GetProtocolValue(Monitor, DefaultMonitor);
		GetProtocolValue(Messzeit, DefaultMesszeit);
		GetProtocolValue(Impulse, DefaultImpulse);
		GetProtocolValue(Winkelbereich, DefaultWinkelbereich);
		GetProtocolValue(Kanalabstand, DefaultKanalabstand);
		GetProtocolValue(Messkanal, DefaultMesskanal);
		GetProtocolValue(Addiere, DefaultAddiere);
	}
	else
	{
		strcpy(DefaultScanart, "-");
		strcpy(DefaultScanmethode, "-");
		strcpy(DefaultMessdatei, "");
		strcpy(DefaultScantyp, "-");
		strcpy(DefaultScanachse1, "-");
		strcpy(DefaultSOffset1, "");
		strcpy(DefaultMinimum1, "");
		strcpy(DefaultMaximum1, "");
		strcpy(DefaultSchrittweite1, "");
		strcpy(DefaultGeschwindigkeit1, "");
		strcpy(DefaultScanachse2, "");
		strcpy(DefaultSOffset2, "");
		strcpy(DefaultMinimum2, "");
		strcpy(DefaultMaximum2, "");
		strcpy(DefaultSchrittweite2, "");
		strcpy(DefaultGeschwindigkeit2, "");
		strcpy(DefaultDetektor, "-");
		strcpy(DefaultMonitor, "-");
		strcpy(DefaultMesszeit, "");
		strcpy(DefaultImpulse, "");
		strcpy(DefaultWinkelbereich, "");
		strcpy(DefaultKanalabstand, "");
		strcpy(DefaultMesskanal, "");
		strcpy(DefaultAddiere, "");
	}
};

void TProtocolDiffractometry::SetDefaultParameter( void )
{
	char buf[MaxString];

	if ( bDebug )
		MessageBox(GetFocus(), "SetDefaultParameter!", "Debug Info", MBINFO);
	SetProtocolValue(Scanart, DefaultScanart);
	SetProtocolValue(Scanmethode, DefaultScanmethode);
	SetProtocolValue(Messdatei, DefaultMessdatei);
	SetProtocolValue(Scantyp, DefaultScantyp);
	SetProtocolValue(Scanachse1, DefaultScanachse1);
	SetProtocolValue(SOffset1, DefaultSOffset1);
	SetProtocolValue(Minimum1, DefaultMinimum1);
	SetProtocolValue(Maximum1, DefaultMaximum1);
	SetProtocolValue(Schrittweite1, DefaultSchrittweite1);
	SetProtocolValue(Geschwindigkeit1, DefaultGeschwindigkeit1);
	SetProtocolValue(Scanachse2, DefaultScanachse2);
	SetProtocolValue(SOffset2, DefaultSOffset2);
	SetProtocolValue(Minimum2, DefaultMinimum2);
	SetProtocolValue(Maximum2, DefaultMaximum2);
	SetProtocolValue(Schrittweite2, DefaultSchrittweite2);
	SetProtocolValue(Geschwindigkeit2, DefaultGeschwindigkeit2);
	SetProtocolValue(Detektor, DefaultDetektor);
	SetProtocolValue(Monitor, DefaultMonitor);
	SetProtocolValue(Messzeit, DefaultMesszeit);
	SetProtocolValue(Impulse, DefaultImpulse);
	SetProtocolValue(Winkelbereich, DefaultWinkelbereich);
	SetProtocolValue(Kanalabstand, DefaultKanalabstand);
	SetProtocolValue(Messkanal, DefaultMesskanal);
	SetProtocolValue(Addiere, DefaultAddiere);

	SetProtocolValue(Nutzer, MeasurementParameter->GetUser());
	SetProtocolValue(UReflex, MeasurementParameter->GetReflection(buf));
	SetProtocolValue(Orientierung, MeasurementParameter->GetOrientation(buf));
	SetProtocolValue(Wellenlaenge, MeasurementParameter->GetWaveLength(buf));
	SetProtocolValue(Strom, MeasurementParameter->GetCurrent(buf));
	SetProtocolValue(Spannung, MeasurementParameter->GetVoltage(buf));
	SetProtocolValue(Bemerkung, MeasurementParameter->GetComment());
};

void TProtocolDiffractometry::SetOnDefaultParameterReadOnly( void )
{
	SetAllParameterReadWrite();
	SetParameterReadOnly(Nutzer);
	SetParameterReadOnly(Orientierung);
	SetParameterReadOnly(UReflex);
	SetParameterReadOnly(Strom);
	SetParameterReadOnly(Spannung);
	SetParameterReadOnly(Wellenlaenge);
	SetParameterReadOnly(Messdatei);
	SetParameterReadOnly(Scanart);
	SetParameterReadOnly(Scantyp);
	SetParameterReadOnly(Scanmethode);
	SetParameterReadOnly(Scanachse1);
	SetParameterReadOnly(Minimum1);
	SetParameterReadOnly(Maximum1);
	SetParameterReadOnly(Schrittweite1);
	SetParameterReadOnly(Geschwindigkeit1);
	SetParameterReadOnly(SOffset1);
	SetParameterReadOnly(Scanachse2);
	SetParameterReadOnly(Minimum2);
	SetParameterReadOnly(Maximum2);
	SetParameterReadOnly(Schrittweite2);
	SetParameterReadOnly(Geschwindigkeit2);
	SetParameterReadOnly(SOffset2);
	SetParameterReadOnly(Detektor);
	SetParameterReadOnly(Monitor);
	SetParameterReadOnly(Messzeit);
	SetParameterReadOnly(Impulse);
	SetParameterReadOnly(Kanalabstand);
	SetParameterReadOnly(Messkanal);
	SetParameterReadOnly(Addiere);
};

void TProtocolDiffractometry::SetDefaultParameterReadOnly( void )
{
	SetOnDefaultParameterReadOnly();
};

void TProtocolDiffractometry::ClearOldParameter( void )
{
	SetProtocolValue(LfdNr, "");
	ClearProtocolString(Messdatei, Geschwindigkeit2);
	ClearProtocolString(AArt, Status);
};

BOOL TProtocolDiffractometry::TestLfdNr( LPCSTR Value )
{
	int i, iStrLen;

	iStrLen= strlen(Value);
	if (iStrLen != GetParameterMaxLen(LfdNr))
		return FALSE;
	for (i= 0; i < iStrLen; i++)
		if ( !isdigit(Value[i]) )
			return FALSE;
	return TRUE;
};

BOOL TProtocolDiffractometry::SearchProtocolString( LPCSTR lLfdNr )
{
	return TProtocol::SearchProtocolString( lLfdNr );
};

BOOL TProtocolDiffractometry::SearchProtocolString( LPCSTR lLfdNr,
		LPCSTR lDatum1, LPCSTR lDatum2, LPCSTR lProbenNr,
		LPCSTR lMaterial )
{
	char Date1[MaxDate], Date2[MaxDate];

	while ( currentINDEX != NULL )
	{
		if (iSearch++ > 0)
			currentINDEX= currentINDEX->next;
		if (currentINDEX == NULL)
			return FALSE;
		if ( strlen(lLfdNr) == 0 || strncmp(currentINDEX->LfdNr, lLfdNr, strlen(lLfdNr)) == 0 )
		{
			MakeDateString(lDatum1, Date1);
			MakeDateString(lDatum2, Date2);
			if ( strlen(lDatum1) == 0 || strcmp(currentINDEX->Date, Date1) >= 0 )
				if ( strlen(lDatum2) == 0 || strcmp(currentINDEX->Date, Date2) <= 0 )
				{
					if ( !LoadProtocolString( currentINDEX->Pos) )
						return FALSE;
					if ( strlen(lProbenNr) == 0 || strncmp(Parameter[ProbenNr].Wert, lProbenNr, strlen(lProbenNr)) == 0 )
						if ( strlen(lMaterial) == 0 || strncmp(Parameter[Material].Wert, lMaterial, strlen(lMaterial)) == 0 )
							return TRUE;
				}
		}
	}
	return FALSE;
};

void TProtocolDiffractometry::SaveLfdNr( LPCSTR Value)
{
	strcpy(CurrentLfdNr, Value);
	strcpy(Parameter[LfdNr].Wert, Value);
};

LPSTR TProtocolDiffractometry::GetParameterLfdNr( LPSTR lLfdNr)
{
	strcpy(lLfdNr, Parameter[LfdNr].Wert);
	return lLfdNr;
};

LPSTR TProtocolDiffractometry::GetParameterDate( LPSTR lDate)
{
	strcpy(lDate, Parameter[Datum].Wert);
	return lDate;
};

void TProtocolDiffractometry::SetParameterDate( LPCSTR lDate)
{
	strcpy(Parameter[Datum].Wert, lDate);
};

LPSTR TProtocolDiffractometry::GetNewLfdNr( LPSTR lLfdNr )
{
	char buf[MaxLfdNr];

	strcpy(lLfdNr, "00000000");
	if (lastINDEX != NULL)
	{
		strcpy(buf, lastINDEX->LfdNr);
		do
		{
			sprintf(lLfdNr, "%ld", atol(buf) + 1);
			strcpy(buf, lLfdNr);
			strrev(lLfdNr);
			while (strlen(lLfdNr) < (GetParameterMaxLen(LfdNr)))
				strcat(lLfdNr, "0");
			strrev(lLfdNr);
		} while (SearchProtocolString(lLfdNr) && (atol(buf) < 99999999));
	}
	return lLfdNr;
};

BOOL TProtocolDiffractometry::IsMaxLfdNr( void )
{
	char buf[MaxLfdNr], lLfdNr[MaxLfdNr];

	if (lastINDEX == NULL)
		return FALSE;
	strcpy(buf, lastINDEX->LfdNr);
	if (atol(buf) == 99999999)
		return TRUE;
	do
	{
		sprintf(lLfdNr, "%ld", atol(buf) + 1);
		strcpy(buf, lLfdNr);
		strrev(lLfdNr);
		while (strlen(lLfdNr) < (GetParameterMaxLen(LfdNr)))
			strcat(lLfdNr, "0");
		strrev(lLfdNr);
	} while (SearchProtocolString(lLfdNr) && (atol(buf) <= 99999999));
	SearchProtocolString(GetLfdNr(lLfdNr));
	if (atol(buf) > 99999999)
		return TRUE;
	return FALSE;
};

LPCSTR TProtocolDiffractometry::GetPName( )
{
	return GetPDiffName();
};

LPCSTR TProtocolDiffractometry::GetPDirectory( )
{
	return GetPDiffDirectory();
};

LPCSTR TProtocolDiffractometry::GetPBackupDirectory( )
{
	return GetPDiffBackupDirectory();
};

BOOL TProtocolDiffractometry::SetPBackupDirectory( LPCSTR lDir )
{
	return SetPDiffBackupDirectory(lDir);
};

LPCSTR TProtocolDiffractometry::GetPFile( )
{
	return GetPDiffFile();
};

BOOL TProtocolDiffractometry::SetPFile( LPCSTR FileName )
{
	if (!SetPDiffFile( FileName ))
		return FALSE;
	WritePrivateProfileString(szProtocolSection, "ProtocolFile", GetPDiffFile(), GetCFile());
	return TRUE;
};

// LastLine
