//******************************************************************************
//Datei     : TProtocolLanguage.cpp
//Projekt   : XCTL
//Subsystem : Protokollbuch
//Autor     : Jens Klier <klier@informatik.hu-berlin.de>
//            Institut fuer Informatik,
//            Humboldt-Universitaet Berlin
//Inhalt    : Implementation der Klasse TProtocolLanguage
//******************************************************************************
//!neu klier Protokollbuch

#include "internls\evrythng.h" // GermanVersion
#include "winresrc\rc_prtow.h" // Ressourcen-IDs
#include <commdlg.h>
#include <commctrl.h>

#include "protocol\TProtocolLanguage.h"

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

TProtocolLanguage::TProtocolLanguage()
{
#ifdef GermanVersion
	SetLanguage(german);
#else

	SetLanguage(english);
#endif //GermanVersion
};

void TProtocolLanguage::SetLanguage(TLanguage Language)
{
	ProtocolLanguage= Language;
	switch (Language)
	{
		case german:
			strFailure= "Protokollbuch - Fehler";
			strWarning= "Protokollbuch - Warnung";
			strQuestion= "Protokollbuch - Frage";
			strMessage[0]= "Protokollbuch - Meldung";
			//Meldungen TProtocol.cpp
			strMessage[1]= "Speicherfehler: Kein Speicher mehr fr new Parameter!";
			strMessage[2]= "Die Protokollbuchdatei %s existiert nicht! Soll die Datei neu erstellt werden? (Wenn nicht knnen Sie nach ihr suchen.)";
			strMessage[3]= "Protokolldatei konnte nicht erstellt werden!\nberprfen Sie ob das Verzeichnis %s existiert!";
			strMessage[4]= "Fehler beim initialisieren des Protokollbuches!\nDie Protokollbuchfunktion kann nicht verwendet werden!";
			strMessage[5]= "Speicherfehler: Kein Speicher mehr fr new INDEX!";
			strMessage[6]= "Speicherfehler: Kein Speicher mehr fr new POINT!";
			strMessage[7]= "Datei konnte nicht importiert werden!";
			strMessage[8]= "Importstatistik:\n\nImportierte Messungen: ";
			strMessage[9]= "Importierte Skizzen: ";
			strMessage[10]= "Nicht importierte doppelte LfdNr: ";
			strMessage[11]= "Nicht importierte fehlerhafte Messungen: ";
			strMessage[12]= "Nicht importierte gelschte Messungen: ";
			strMessage[13]= "Nicht importierte vorhandene Skizzen: ";
			strMessage[14]= "Nicht importierte nicht vorhandene Skizzen: ";
			strMessage[15]= "Die Protokolldatei ist fehlerhaft!!!\nDer Parameter %s: %s ist ungltig!";
			strMessage[16]= "Die Protokolldatei ist fehlerhaft!!!\nDer Parameter Lfd.-Nr.: %s und/oder Datum: %s sind ungltig!";
			//Fenster - Datei ffnen
			strMessage[17]= "Protokollbuch - Datei ffnen";
			//Meldungen TProtocolDlg.cpp
			strMessage[18]= "Ein Wert wurde verndert!\nSollen die Parameter gespeichert werden?";
			strMessage[19]= "Der Wert %s mu eingetragen werden!";
			strMessage[20]= "Der Wert %s wurde von \"%s\" auf \"%s\" gendert!";
			strMessage[21]= "Der Wert %s: %s : darf maximal %d Zeichen lang sein!";
			strMessage[22]= "Soll das Aufzeichnen der Messung ins Protokollbuch beendet werden?";
			strMessage[23]= "Fehler in PicFile!";
			strMessage[24]= "Passwort falsch!";
			strMessage[25]= "Skizze lschen?";
			strMessage[26]= "Wenn Sie diese Messung mit einem Passwortschutz versehen, ist eine automatische Parameterbernahme in diese Messung nicht mehr mglich!\nWollen Sie die Messung mit einem Passwort schtzen?";
			strMessage[27]= "Wenn Sie diese Messung mit einem Passwortschutz versehen, knnen Sie evtl. einige Parameter nicht mehr ndern!\nWollen Sie die Messung mit einem Passwort schtzen?";
			strMessage[62]= "Parameter gespeichert!";
			strMessage[63]= "Neue Messung!";
			strMessage[64]= "LfdNr. eingeben";
			strMessage[65]= "Freihand zeichen.";
			strMessage[66]= "Linien zeichnen.";
			strMessage[67]= "Der Skizze wird erst nach dem abschlieenden \"Ok\" gespeichert!";
			strMessage[68]= "Skizze zeichnen!";
			strMessage[69]= "Die Skizze wurde gendert!";
			//Meldungen TProtocolDiffractometryDlg.cpp
			strMessage[28]= "Eingabe %s ist fehlerhaft! Bitte korrigieren! (Pflichtfeld!)";
			//Meldungen TProtocolManagePrintDlg.cpp
			strMessage[29]= "Nicht genug Speicher vorhanden!";
			strMessage[30]= "Es ist keine Messung markiert!\nSollen alle ";
			strMessage[31]= " Messungen gedruckt werden( ";
			strMessage[32]= " Messung gedruckt werden( ";
			strMessage[33]= " Druckseiten A4)?";
			strMessage[34]= "Es ist keine Messung markiert!";
			strMessage[35]= "Printer cannot display bitmaps.";
			strMessage[36]= "Druckfehler!\nGetDeviceCaps()";
			strMessage[37]= "Druckfehler!\nStartDoc()";
			strMessage[38]= "Druckfehler!\nEndPage()";
			strMessage[39]= "Druckfehler!\nStartPage()";
			strMessage[40]= "Druckfehler!\nEndDoc()";
			strMessage[41]= "Druckfehler!\nLoadProtocolString()";
			strMessage[42]= " Messungen markiert -> ";
			strMessage[43]= " Messung markiert -> ";
			strMessage[44]= " Druckseiten A4";
			strMessage[45]= "Markieren Sie eine Messung!";
			strMessage[46]= "Bitte warten....";
			strMessage[47]= "Import beendet!";
			strMessage[48]= "Import fehlgeschlagen!";
			strMessage[49]= "Wiederherstellen";
			strMessage[50]= "Lschen";
			strMessage[51]= " Messungen gelscht!";
			strMessage[52]= " Messung gelscht!";
			strMessage[53]= " Messungen wiederhergestellt!";
			strMessage[54]= " Messung wiederhergestellt!";
			strMessage[55]= "Drucke Seite ";
			strMessage[56]= " von ";
			strMessage[57]= " Seiten.";
			//Meldungen TProtocolTopographyManagePrintDlg.cpp, TProtocolDiffractometryManagePrintDlg.cpp
			strMessage[58]= "Eingabe Datum korrigieren";
			strMessage[59]= " Messungen wurden gefunden";
			strMessage[60]= " Messung wurde gefunden";
			strMessage[61]= "keine Messung gefunden";
			break;

		case english:
			strFailure= "protocol - Error";
			strWarning= "protocol - Warning";
			strQuestion= "protocol - Question";
			strMessage[0]= "protocol - Message";
			//message TProtocol.cpp
			strMessage[1]= "out of memory! cannot allocate storage for new parameter!";
			strMessage[2]= "protocolfile %s not found! create it?";
			strMessage[3]= "couldn't create protocolfile. check wether directory %s exists!";
			strMessage[4]= "Errors with initialize the protocol book!\nThe protocol book function cannot be used!";
			strMessage[5]= "out of memory! cannot allocate storage for new pindex!";
			strMessage[6]= "out of memory! cannot allocate storage for new point!";
			strMessage[7]= "could not import file!";
			strMessage[8]= "statistics:\n\nimportet results: ";
			strMessage[9]= "importet drafts: ";
			strMessage[10]= "not imported No: ";
			strMessage[11]= "errors in result(not imported): ";
			strMessage[12]= "result deleted(not imported): ";
			strMessage[13]= "drafts existing but not imported: ";
			strMessage[14]= "drafts not existing and not imported: ";
			strMessage[15]= "protocolfile is wrong!!!\nparameter %s is wrong!";
			strMessage[16]= "protocolfile is wrong!!!\nparameter lfd.-nr.: %s and/or date: %s are wrong!";
			//Fenster - Datei ffnen
			strMessage[17]= "protocol - open file";
			//message TProtocolDlg.cpp
			strMessage[18]= "a value was changed!\nsave parameters?";
			strMessage[19]= "value %s missing!";
			strMessage[20]= "value %s changed from \"%s\" to \"%s\" !";
			strMessage[21]= "value %s: %s : cannot be longer than %d digits!";
			strMessage[22]= "stop writing to protocolfile?";
			strMessage[23]= "errors in PicFile!";
			strMessage[24]= "password not recognized!";
			strMessage[25]= "delete draft?";
			strMessage[26]= "If you provide this measurement with a password protection, an automatic parameter transfer is no longer possible into this measurement!\nDo you want to protect the measurement with a password?";
			strMessage[27]= "If you provide this measurement with a password protection, you cannot change possibly some parameters any longer!\nDo you want to protect the measurement with a password?";
			strMessage[62]= "parameter saved!";
			strMessage[63]= "new measurement!";
			strMessage[64]= "enter No";
			strMessage[65]= "draw freely";
			strMessage[66]= "draw lines";
			strMessage[67]= "draft is stored first, after press \"Ok\"!";
			strMessage[68]= "draw drawing!";
			strMessage[69]= "draw was changed!";
			//message TProtocolDiffractometryDlg.cpp
			strMessage[28]= "value %s is wrong! please correct (value mandatory)";
			//message TProtocolManagePrintDlg.cpp
			strMessage[29]= "out of memory!";
			strMessage[30]= "no measurement selected!\nprint all ";
			strMessage[31]= " measurements( ";
			strMessage[32]= " measurements( ";
			strMessage[33]= " pages of print A4)?";
			strMessage[34]= "no measurement selected!";
			strMessage[35]= "Printer cannot display bitmaps.";
			strMessage[36]= "print error!\nGetDeviceCaps()";
			strMessage[37]= "print error!\nStartDoc()";
			strMessage[38]= "print error!\nEndPage()";
			strMessage[39]= "print error!\nStartPage()";
			strMessage[40]= "print error!\nEndDoc()";
			strMessage[41]= "print error!\nLoadProtocolString()";
			strMessage[42]= " selected measurements -> print ";
			strMessage[43]= " selected measurements -> print ";
			strMessage[44]= " pages A4";
			strMessage[45]= "select measurement!";
			strMessage[46]= "please wait....";
			strMessage[47]= "import done!";
			strMessage[48]= "import failed!";
			strMessage[49]= "undo";
			strMessage[50]= "delete";
			strMessage[51]= " measurement deleted!";
			strMessage[52]= " measurement deleted!";
			strMessage[53]= " measurement restored!";
			strMessage[54]= " measurement restored!";
			strMessage[55]= "print page ";
			strMessage[56]= " from ";
			strMessage[57]= " pages.";
			//message TProtocolTopographyManagePrintDlg.cpp, TProtocolDiffractometryManagePrintDlg.cpp
			strMessage[58]= "date to correct";
			strMessage[59]= " measurement found";
			strMessage[60]= " measurement found";
			strMessage[61]= "no measurement found";
			break;
	}
};

LPCSTR TProtocolLanguage::GetFailure()
{
	return strFailure;
};

LPCSTR TProtocolLanguage::GetWarning()
{
	return strWarning;
};

LPCSTR TProtocolLanguage::GetQuestion()
{
	return strQuestion;
};

LPCSTR TProtocolLanguage::GetMessage(int Nr)
{
	return strMessage[Nr];
};

void TProtocolLanguage::SetProtocolLanguageDlgMenu(void)
{
	switch (ProtocolLanguage)
	{
		case german:
			CheckMenuItem( hProtocolSystemMenu, cm_ProtcolDeutsch, MF_CHECKED );
			CheckMenuItem( hProtocolSystemMenu, cm_ProtcolEnglisch, MF_UNCHECKED );
			break;

		case english:
			CheckMenuItem( hProtocolSystemMenu, cm_ProtcolDeutsch, MF_UNCHECKED );
			CheckMenuItem( hProtocolSystemMenu, cm_ProtcolEnglisch, MF_CHECKED );
			break;
	}
};

void TProtocolLanguage::InitializeDlgLanguage(HWND hwnd)
{
	char buf[MaxString];

#ifdef GermanVersion

	GetPrivateProfileString("Protocol", "Language", "deutsch", buf, MaxString, GetCFile());
#else

	GetPrivateProfileString("Protocol", "Language", "englisch", buf, MaxString, GetCFile());
#endif //GermanVersion

	if ( (strcmp(buf, "englisch") == 0) || (strcmp(buf, "english") == 0) )
		SetLanguage(english);
	else
		SetLanguage(german);

	hProtocolSystemMenu= GetSystemMenu(hwnd, FALSE);
	// Sprache im Systemmenue
	HMENU hmenu= CreatePopupMenu();
	AppendMenu(hmenu, MF_STRING, cm_ProtcolDeutsch, "&Deutsch");
	AppendMenu(hmenu, MF_STRING, cm_ProtcolEnglisch, "&Englisch");
	AppendMenu(hProtocolSystemMenu, MF_SEPARATOR, 0, NULL);
	AppendMenu(hProtocolSystemMenu, MF_POPUP, (WORD)hmenu, "Sprache");
	DrawMenuBar(hwnd);

	SetProtocolLanguageDlgMenu();
};

void TProtocolLanguage::SetDlgLanguage(int id)
{
	switch (id)
	{
		case cm_ProtcolDeutsch:
			SetLanguage(german);
			WritePrivateProfileString("Protocol", "Language", "deutsch", GetCFile());
			break;

		case cm_ProtcolEnglisch:
			SetLanguage(english);
			WritePrivateProfileString("Protocol", "Language", "englisch", GetCFile());
			break;
	}
	SetProtocolLanguageDlgMenu();
};

void TProtocolLanguage::SetTopographyDlgLanguage(HWND hwnd, int id)
{
	SetDlgLanguage(id);
	SetTopographyDlgLanguage(hwnd);
};

void TProtocolLanguage::SetProtocolDlgLanguage(HWND hwnd)
{
	switch (ProtocolLanguage)
	{
		case german:
			SetDlgItemText(hwnd, id_GruppeProbe, "Probe");
			SetDlgItemText(hwnd, id_GruppeSkizze, "Lageskizze");
			SetDlgItemText(hwnd, id_DatumText, "Datum:");
			SetDlgItemText(hwnd, id_NutzerText, "Nutzer:");
			SetDlgItemText(hwnd, id_ReadOnly, "Passwortschutz");
			SetDlgItemText(hwnd, id_ProbenNrText, "Probennummer:");
			SetDlgItemText(hwnd, id_LieferantText, "Lieferant:");
			SetDlgItemText(hwnd, id_MerkmalText, "Merkmal:");
			SetDlgItemText(hwnd, id_MaterialText, "Material:");

			SetDlgItemText(hwnd, IDOK, "&Ok");
			SetDlgItemText(hwnd, IDCANCEL, "&Abbruch");
			SetDlgItemText(hwnd, IDPRINT, "&Verwalten/Drucken");
			SetDlgItemText(hwnd, id_Help, "&Hilfe");
			break;

		case english:
			SetDlgItemText(hwnd, id_GruppeProbe, "specimen");
			SetDlgItemText(hwnd, id_GruppeSkizze, "sketch");
			SetDlgItemText(hwnd, id_DatumText, "date:");
			SetDlgItemText(hwnd, id_NutzerText, "user:");
			SetDlgItemText(hwnd, id_ReadOnly, "password on");
			SetDlgItemText(hwnd, id_ProbenNrText, "specimen number:");
			SetDlgItemText(hwnd, id_LieferantText, "provider:");
			SetDlgItemText(hwnd, id_MerkmalText, "characteristic:");
			SetDlgItemText(hwnd, id_MaterialText, "material:");

			SetDlgItemText(hwnd, IDOK, "&ok");
			SetDlgItemText(hwnd, IDCANCEL, "&cancel");
			SetDlgItemText(hwnd, IDPRINT, "&manage/print");
			SetDlgItemText(hwnd, id_Help, "&help");
			break;
	}
};

void TProtocolLanguage::SetTopographyDlgLanguage(HWND hwnd)
{
	int iTab=0;
	HWND hTab= GetDlgItem( hwnd, id_Tab );
	
	switch (ProtocolLanguage)
	{
		case german:
			SetWindowText(hwnd, "Protokollbuch Topographie  (deutsch)");
			SetProtocolDlgLanguage(hwnd);

			TabCtrl_SetItemText(hTab, iTab++, "Kollimator/Rhre");
			TabCtrl_SetItemText(hTab, iTab++, "Messung/Filme");
			TabCtrl_SetItemText(hTab, iTab++, "Beginn Messung");
			TabCtrl_SetItemText(hTab, iTab++, "Ende Messung");

			SetDlgItemText(hwnd, id_LfdNrText, "Lfd.-RTK-Nr.:");
			SetDlgItemText(hwnd, id_WinkelText, "Winkel:");
			SetDlgItemText(hwnd, id_WinkelEinheit, "Grad");
			SetDlgItemText(hwnd, id_GroesseText, "Gre:");
			SetDlgItemText(hwnd, id_ReflexText, "Reflex:");
			SetDlgItemText(hwnd, id_EinfallswinkelText, "Einfallswinkel:");
			SetDlgItemText(hwnd, id_EinfallswinkelEinheit, "Grad");
			SetDlgItemText(hwnd, id_BeugungswinkelText, "Beugungswinkel:");
			SetDlgItemText(hwnd, id_BeugungswinkelEinheit, "Grad");

			SetDlgItemText(hwnd, id_GruppeKollimator, "Kollimator");
			SetDlgItemText(hwnd, id_KReflexText, "Reflex:");
			SetDlgItemText(hwnd, id_KNrText, "Nr.:");
			SetDlgItemText(hwnd, id_KKruemmungText, "Krmmung:");
			SetDlgItemText(hwnd, id_KMaterialText, "Material:");
			SetDlgItemText(hwnd, id_GruppeRoehre, "Rhre");
			SetDlgItemText(hwnd, id_RMaterialText, "Material:");
			SetDlgItemText(hwnd, id_RSpannungText, "Spannung:");
			SetDlgItemText(hwnd, id_RStromText, "Strom:");
			SetDlgItemText(hwnd, id_RImpMaxText, "Impuls/s Max.:");

			SetDlgItemText(hwnd, id_GruppeMessung, "Messung");
			SetDlgItemText(hwnd, id_MImpMaxText, "Impuls/s Max.:");
			SetDlgItemText(hwnd, id_MSpannungText, "Spannung:");
			SetDlgItemText(hwnd, id_MStromText, "Strom:");
			SetDlgItemText(hwnd, id_HWBText, "HWB:");
			SetDlgItemText(hwnd, id_GruppeFilme, "Filme");
			SetDlgItemText(hwnd, id_FAnzahlText, "Anzahl:");
			SetDlgItemText(hwnd, id_PGroesseXText, "Plattengre:");
			SetDlgItemText(hwnd, id_FMaterialText, "Aufnahmematerial:");
			SetDlgItemText(hwnd, id_FAbstandText, "Abstand:");

			SetDlgItemText(hwnd, id_GruppeBeginnMessung, "Beginn Messung");
			SetDlgItemText(hwnd, id_STEText, "statistischer Fehler:");
			SetDlgItemText(hwnd, id_CRTText, "Zhlzeit:");
			SetDlgItemText(hwnd, id_INCDFText, "Schrittweite:");
			SetDlgItemText(hwnd, id_NBEXPOSText, "Anzahl Belichtungen:");
			SetDlgItemText(hwnd, id_ABEText, "Winkel zw. Belichtungen:");
			SetDlgItemText(hwnd, id_RSAText, "kleinster Startwinkel:");
			SetDlgItemText(hwnd, id_CONLIMITText, "proz. Abweichung:");
			SetDlgItemText(hwnd, id_CONPOINTText, "Arbeitspunkt:");
			SetDlgItemText(hwnd, id_EXPTText, "Belichtungszeit:");

			SetDlgItemText(hwnd, id_GruppeEndeMessung, "Ende der Messung");
			SetDlgItemText(hwnd, id_GruppeRegelung, "Regelung");
			SetDlgItemText(hwnd, id_ImpsvorText, "Impuls/s vor Messung:");
			SetDlgItemText(hwnd, id_ImpsnachText, "Impuls/s nach Messung:");
			SetDlgItemText(hwnd, id_DFvorText, "DF vor Messung:");
			SetDlgItemText(hwnd, id_DFnachText, "DF nach Messung:");
			SetDlgItemText(hwnd, id_BemerkungText, "Bemerkung:");
			break;

		case english:
			SetWindowText(hwnd, "protocol topography  (english)");
			SetProtocolDlgLanguage(hwnd);

			TabCtrl_SetItemText(hTab, iTab++, "collimator/conduit");
			TabCtrl_SetItemText(hTab, iTab++, "measurement/film");
			TabCtrl_SetItemText(hTab, iTab++, "measurement begin");
			TabCtrl_SetItemText(hTab, iTab++, "measurement end");

			SetDlgItemText(hwnd, id_LfdNrText, "lfd.-rtk-nr.:");
			SetDlgItemText(hwnd, id_WinkelText, "angle:");
			SetDlgItemText(hwnd, id_WinkelEinheit, "degree");
			SetDlgItemText(hwnd, id_GroesseText, "volume:");
			SetDlgItemText(hwnd, id_ReflexText, "reflex:");
			SetDlgItemText(hwnd, id_EinfallswinkelText, "a. of incidence:"); //angles of incidence
			SetDlgItemText(hwnd, id_EinfallswinkelEinheit, "degree");
			SetDlgItemText(hwnd, id_BeugungswinkelText, "a. of flection:");  //angles of flection:
			SetDlgItemText(hwnd, id_BeugungswinkelEinheit, "degree");

			SetDlgItemText(hwnd, id_GruppeKollimator, "collimator");
			SetDlgItemText(hwnd, id_KReflexText, "reflex:");
			SetDlgItemText(hwnd, id_KNrText, "Nr.:");
			SetDlgItemText(hwnd, id_KKruemmungText, "curve:");
			SetDlgItemText(hwnd, id_KMaterialText, "material:");
			SetDlgItemText(hwnd, id_GruppeRoehre, "conduit");
			SetDlgItemText(hwnd, id_RMaterialText, "material:");
			SetDlgItemText(hwnd, id_RSpannungText, "voltage:");
			SetDlgItemText(hwnd, id_RStromText, "power:");
			SetDlgItemText(hwnd, id_RImpMaxText, "impulse/s max.:");

			SetDlgItemText(hwnd, id_GruppeMessung, "measurement");
			SetDlgItemText(hwnd, id_MImpMaxText, "impulse/s max.:");
			SetDlgItemText(hwnd, id_MSpannungText, "voltage:");
			SetDlgItemText(hwnd, id_MStromText, "power:");
			SetDlgItemText(hwnd, id_HWBText, "HWB:");
			SetDlgItemText(hwnd, id_GruppeFilme, "film");
			SetDlgItemText(hwnd, id_FAnzahlText, "number:");
			SetDlgItemText(hwnd, id_PGroesseXText, "disk size:");
			SetDlgItemText(hwnd, id_FMaterialText, "copy material:");
			SetDlgItemText(hwnd, id_FAbstandText, "space:");

			SetDlgItemText(hwnd, id_GruppeBeginnMessung, "measurement begin");
			SetDlgItemText(hwnd, id_STEText, "statistical error:");
			SetDlgItemText(hwnd, id_CRTText, "counter time:");
			SetDlgItemText(hwnd, id_INCDFText, "inc. DF:");
			SetDlgItemText(hwnd, id_NBEXPOSText, "number exposure:");
			SetDlgItemText(hwnd, id_ABEText, "angle between exposure:");
			SetDlgItemText(hwnd, id_RSAText, "smallest angle:");
			SetDlgItemText(hwnd, id_CONLIMITText, "con. limit:");
			SetDlgItemText(hwnd, id_CONPOINTText, "con. point:");
			SetDlgItemText(hwnd, id_EXPTText, "exposure time:");

			SetDlgItemText(hwnd, id_GruppeEndeMessung, "measurement end");
			SetDlgItemText(hwnd, id_GruppeRegelung, "regulation");
			SetDlgItemText(hwnd, id_ImpsvorText, "impulse/s before measurement:");
			SetDlgItemText(hwnd, id_ImpsnachText, "impulse/s after measurement:");
			SetDlgItemText(hwnd, id_DFvorText, "DF before measurement:");
			SetDlgItemText(hwnd, id_DFnachText, "DF after measurement:");
			SetDlgItemText(hwnd, id_BemerkungText, "comment:");
			break;
	}
};

void TProtocolLanguage::SetDiffractometryDlgLanguage(HWND hwnd, int id)
{
	SetDlgLanguage(id);
	SetDiffractometryDlgLanguage(hwnd);
};

void TProtocolLanguage::SetDiffractometryDlgLanguage(HWND hwnd)
{
	int iTab=0;
	HWND hTab= GetDlgItem( hwnd, id_Tab );
	
	switch (ProtocolLanguage)
	{
		case german:
			SetWindowText(hwnd, "Protokollbuch Diffraktometrie/Reflektometrie  (deutsch)");
			SetProtocolDlgLanguage(hwnd);

			TabCtrl_SetItemText(hTab, iTab++, "Messung");
			TabCtrl_SetItemText(hTab, iTab++, "Scan");
			TabCtrl_SetItemText(hTab, iTab++, "Blende/Absorber");
			TabCtrl_SetItemText(hTab, iTab++, "Detektoren");
			TabCtrl_SetItemText(hTab, iTab++, "Bemerkung");

			SetDlgItemText(hwnd, id_LfdNrText, "Lfd.-Nr.:");
			SetDlgItemText(hwnd, id_OrientierungText, "Orientierung:");
			SetDlgItemText(hwnd, id_UReflexText, "Untersuchter Reflex:");
			SetDlgItemText(hwnd, id_FehlWinkelText, "Winkel:");
			SetDlgItemText(hwnd, id_FehlWinkelEinheit, "Grad");
			SetDlgItemText(hwnd, id_FehlRichtungText, "Richtung:");
			SetDlgItemText(hwnd, id_GruppeScanart, "Scan");
			SetDlgItemText(hwnd, id_GruppeFehlschnitt, "Fehlschnitt");
			SetDlgItemText(hwnd, id_ScanartText, "Scanart:");
			SetDlgItemText(hwnd, id_ScanmethodeText, "Scanmethode:");

			SetDlgItemText(hwnd, id_GruppeMessungParameter, "Messung");
			SetDlgItemText(hwnd, id_SpannungText, "Spannung:");
			SetDlgItemText(hwnd, id_StromText, "Strom:");
			SetDlgItemText(hwnd, id_WellenlaengeText, "Wellenlnge:");
			SetDlgItemText(hwnd, id_MessdateiText, "Messdateiname:");

			SetDlgItemText(hwnd, id_GruppeScan, "Scan");
			SetDlgItemText(hwnd, id_ScantypText, "Scantyp:");
			SetDlgItemText(hwnd, id_ScanachseText, "Scanachse:");
			SetDlgItemText(hwnd, id_SOffsetText, "Offset:");
			SetDlgItemText(hwnd, id_GeschwindigkeitText, "Geschwindigkeit:");
			SetDlgItemText(hwnd, id_Scanachse1, "Omega-Achse");
			SetDlgItemText(hwnd, id_Scanachse2, "Theta-Achse");

			SetDlgItemText(hwnd, id_GruppeBlende, "Blende");
			SetDlgItemText(hwnd, id_GruppeAbsorber, "Absorber");
			SetDlgItemText(hwnd, id_BPSText, "Primrstrahl:");
			SetDlgItemText(hwnd, id_BhorizontalText, "horizontal:");
			SetDlgItemText(hwnd, id_BvertikalText, "vertikal:");
			SetDlgItemText(hwnd, id_BDText, "Detektor:");
			SetDlgItemText(hwnd, id_AFaktorText, "Faktor:");
			SetDlgItemText(hwnd, id_AArtText, "Art:");

			SetDlgItemText(hwnd, id_GruppeDetektor, "Detektoren");
			SetDlgItemText(hwnd, id_GruppePSD, "PSD");
			SetDlgItemText(hwnd, id_DetektorText, "Detektor:");
			SetDlgItemText(hwnd, id_MesszeitText, "Mezeit:");
			SetDlgItemText(hwnd, id_ImpulseText, "Impulse:");
			SetDlgItemText(hwnd, id_DistanzText, "Distanz:");
			SetDlgItemText(hwnd, id_MesskanalText, "Mekanalnr.:");
			SetDlgItemText(hwnd, id_WinkelbereichText, "Winkelbereich:");
			SetDlgItemText(hwnd, id_WinkelbereichEinheit, "Grad");
			SetDlgItemText(hwnd, id_KanalabstandText, "Kanalabstand:");
			SetDlgItemText(hwnd, id_KanalabstandEinheit, "Grad");
			SetDlgItemText(hwnd, id_AddiereText, "Addiere:");
			SetDlgItemText(hwnd, id_AddiereEinheit, "Kanle");
			SetDlgItemText(hwnd, id_MonitorText, "Monitordetektor:");

			SetDlgItemText(hwnd, id_GruppeBemerkung, "Bemerkung");
			break;

		case english:
			SetWindowText(hwnd, "protocol diffractometry/reflectometry  (english)");
			SetProtocolDlgLanguage(hwnd);

			TabCtrl_SetItemText(hTab, iTab++, "measurement");
			TabCtrl_SetItemText(hTab, iTab++, "scan");
			TabCtrl_SetItemText(hTab, iTab++, "aperture/absorber");
			TabCtrl_SetItemText(hTab, iTab++, "detector");
			TabCtrl_SetItemText(hTab, iTab++, "comment");

			SetDlgItemText(hwnd, id_LfdNrText, "lfd.-nr.:");
			SetDlgItemText(hwnd, id_OrientierungText, "orientation:");
			SetDlgItemText(hwnd, id_UReflexText, "inspected reflex:");
			SetDlgItemText(hwnd, id_FehlWinkelText, "angle:");
			SetDlgItemText(hwnd, id_FehlWinkelEinheit, "degree");
			SetDlgItemText(hwnd, id_FehlRichtungText, "direction:");
			SetDlgItemText(hwnd, id_GruppeScanart, "scan");
			SetDlgItemText(hwnd, id_GruppeFehlschnitt, "false cut");
			SetDlgItemText(hwnd, id_ScanartText, "class:");  // scan class:
			SetDlgItemText(hwnd, id_ScanmethodeText, "methode:");  //scan methode:

			SetDlgItemText(hwnd, id_GruppeMessungParameter, "measurement");
			SetDlgItemText(hwnd, id_SpannungText, "voltage:");
			SetDlgItemText(hwnd, id_StromText, "power:");
			SetDlgItemText(hwnd, id_WellenlaengeText, "wavelength:");
			SetDlgItemText(hwnd, id_MessdateiText, "file name:");

			SetDlgItemText(hwnd, id_GruppeScan, "scan");
			SetDlgItemText(hwnd, id_ScantypText, "scan typ:");
			SetDlgItemText(hwnd, id_ScanachseText, "scan axis:");
			SetDlgItemText(hwnd, id_SOffsetText, "offset:");
			SetDlgItemText(hwnd, id_MinimumText, "minimum:");
			SetDlgItemText(hwnd, id_MaximumText, "maximum:");
			SetDlgItemText(hwnd, id_SchrittweiteText, "step wide:");
			SetDlgItemText(hwnd, id_GeschwindigkeitText, "velocity:");
			SetDlgItemText(hwnd, id_Scanachse1, "omega-axis");
			SetDlgItemText(hwnd, id_Scanachse2, "theta-axis");

			SetDlgItemText(hwnd, id_GruppeBlende, "aperture");
			SetDlgItemText(hwnd, id_GruppeAbsorber, "absorber");
			SetDlgItemText(hwnd, id_BPSText, "primary ray:");
			SetDlgItemText(hwnd, id_BhorizontalText, "horizontal:");
			SetDlgItemText(hwnd, id_BvertikalText, "vertical:");
			SetDlgItemText(hwnd, id_BDText, "detector:");
			SetDlgItemText(hwnd, id_AFaktorText, "factor:");
			SetDlgItemText(hwnd, id_AArtText, "class:");

			SetDlgItemText(hwnd, id_GruppeDetektor, "detector");
			SetDlgItemText(hwnd, id_GruppePSD, "PSD");
			SetDlgItemText(hwnd, id_DetektorText, "detector:");
			SetDlgItemText(hwnd, id_MesszeitText, "time:");  //measurement time:
			SetDlgItemText(hwnd, id_ImpulseText, "impuls:");
			SetDlgItemText(hwnd, id_DistanzText, "distance:");
			SetDlgItemText(hwnd, id_MesskanalText, "channel nr.:");
			SetDlgItemText(hwnd, id_WinkelbereichText, "angle range:");
			SetDlgItemText(hwnd, id_WinkelbereichEinheit, "degree");
			SetDlgItemText(hwnd, id_KanalabstandText, "channel space:");
			SetDlgItemText(hwnd, id_KanalabstandEinheit, "degree");
			SetDlgItemText(hwnd, id_AddiereText, "add:");
			SetDlgItemText(hwnd, id_AddiereEinheit, "channel");
			SetDlgItemText(hwnd, id_MonitorText, "monitor:");

			SetDlgItemText(hwnd, id_GruppeBemerkung, "comment");
			break;
	}
	TranslateParameter(hwnd, id_MinimumText);       // Minimum:
	TranslateParameter(hwnd, id_MaximumText);       // Maximum:
	TranslateParameter(hwnd, id_SchrittweiteText);  // Schrittweite:
};

void TProtocolLanguage::SetProtocolManagePrintDlgLanguage(HWND hwnd)
{
	switch (ProtocolLanguage)
	{
		case german:
			SetDlgItemText(hwnd, id_GruppeSuchkriterien, "Suchkriterien");
			SetDlgItemText(hwnd, id_GruppeSuchergebnis, "Suchergebnis:");
			SetDlgItemText(hwnd, id_GruppeProtocolFile, "Protokolldatei");
			SetDlgItemText(hwnd, id_PrnDatumText, "Datum von-bis:");
			SetDlgItemText(hwnd, id_PrnProbenNrText, "Probennummer:");
			SetDlgItemText(hwnd, id_PrnMaterialText, "Material:");
			SetDlgItemText(hwnd, id_Delete, "Gelschte Messungen anzeigen");
			SetDlgItemText(hwnd, IDPRINT, "&Drucken");
			SetDlgItemText(hwnd, IDVIEW, "&Anzeigen");
			SetDlgItemText(hwnd, IDDELETE, "&Lschen");
			SetDlgItemText(hwnd, IDIMPORT, "&Importieren");
			SetDlgItemText(hwnd, id_Parameter, "&Einstellungen");
			SetDlgItemText(hwnd, IDCANCEL, "S&chlieen");
			SetDlgItemText(hwnd, IDSEARCH, "&Suchen");
			SetDlgItemText(hwnd, id_SuchList, "Suchen");
			break;

		case english:
			SetDlgItemText(hwnd, id_GruppeSuchkriterien, "search criteria");
			SetDlgItemText(hwnd, id_GruppeSuchergebnis, "search result:");
			SetDlgItemText(hwnd, id_GruppeProtocolFile, "protocol file");
			SetDlgItemText(hwnd, id_PrnDatumText, "date from-untill:");
			SetDlgItemText(hwnd, id_PrnProbenNrText, "specimen number:");
			SetDlgItemText(hwnd, id_PrnMaterialText, "material:");
			SetDlgItemText(hwnd, id_Delete, "deleted measurement indicate");
			SetDlgItemText(hwnd, IDPRINT, "&print");
			SetDlgItemText(hwnd, IDVIEW, "&indicate");
			SetDlgItemText(hwnd, IDDELETE, "&delete");
			SetDlgItemText(hwnd, IDIMPORT, "&import");
			SetDlgItemText(hwnd, id_Parameter, "&parameter");
			SetDlgItemText(hwnd, IDCANCEL, "&close");
			SetDlgItemText(hwnd, IDSEARCH, "&search");
			SetDlgItemText(hwnd, id_SuchList, "search");
			break;
	}
};

void TProtocolLanguage::SetTopographyManagePrintDlgLanguage(HWND hwnd)
{
    int iCol=0;
	HWND hSuchList= GetDlgItem( hwnd, id_SuchList );

	switch (ProtocolLanguage)
	{
		case german:
			ListView_SetColumnText(hSuchList, iCol++, "Lfd.-Nr."); 
			ListView_SetColumnText(hSuchList, iCol++, "-"); 
		    ListView_SetColumnText(hSuchList, iCol++, "RTK-Nr."); 
	        ListView_SetColumnText(hSuchList, iCol++, "Datum"); 
			ListView_SetColumnText(hSuchList, iCol++, "Probennummer"); 
            ListView_SetColumnText(hSuchList, iCol++, "Lieferant");
		    ListView_SetColumnText(hSuchList, iCol++, "Material");
	
			SetWindowText(hwnd, "Protokollbuch Topographie - Verwalten/Drucken  (deutsch)");
			SetDlgItemText(hwnd, id_PrnLfdNrText, "Lfd.-RTK-Nr.:");
			SetDlgItemText(hwnd, id_PrnLieferantText, "Lieferant:");
			SetProtocolManagePrintDlgLanguage(hwnd);
			break;

		case english:
			ListView_SetColumnText(hSuchList, iCol++, "lfd.-nr."); 
			ListView_SetColumnText(hSuchList, iCol++, "-"); 
		    ListView_SetColumnText(hSuchList, iCol++, "rtk-nr."); 
	        ListView_SetColumnText(hSuchList, iCol++, "date"); 
			ListView_SetColumnText(hSuchList, iCol++, "specimen number"); 
            ListView_SetColumnText(hSuchList, iCol++, "provider");
		    ListView_SetColumnText(hSuchList, iCol++, "material");
	
			SetWindowText(hwnd, "protocol topography - manage/print  (english)");
			SetDlgItemText(hwnd, id_PrnLfdNrText, "lfd.-rtk-nr.:");
			SetDlgItemText(hwnd, id_PrnLieferantText, "provider:");
			SetProtocolManagePrintDlgLanguage(hwnd);
			break;
	}
};

void TProtocolLanguage::SetDiffractometryManagePrintDlgLanguage(HWND hwnd)
{
    int iCol=0;
	HWND hSuchList= GetDlgItem( hwnd, id_SuchList );

	switch (ProtocolLanguage)
	{
		case german:
			ListView_SetColumnText(hSuchList, iCol++, "Lfd.-Nr."); 
	        ListView_SetColumnText(hSuchList, iCol++, "Datum"); 
			ListView_SetColumnText(hSuchList, iCol++, "Probennummer"); 
		    ListView_SetColumnText(hSuchList, iCol++, "Material");

			SetWindowText(hwnd, "Protokollbuch Diffraktometrie/Reflektometrie - Verwalten/Drucken  (deutsch)");
			SetDlgItemText(hwnd, id_PrnLfdNrText, "Lfd.-Nr.:");
			SetProtocolManagePrintDlgLanguage(hwnd);
			break;

		case english:
			ListView_SetColumnText(hSuchList, iCol++, "lfd.-nr."); 
	        ListView_SetColumnText(hSuchList, iCol++, "date"); 
			ListView_SetColumnText(hSuchList, iCol++, "specimen number"); 
		    ListView_SetColumnText(hSuchList, iCol++, "material");
	
			SetWindowText(hwnd, "protocol diffractometry/reflectometry - manage/print  (english)");
			SetDlgItemText(hwnd, id_PrnLfdNrText, "lfd.-nr.:");
			SetProtocolManagePrintDlgLanguage(hwnd);
			break;
	}
};

void TProtocolLanguage::SetPasswortDlgLanguage(HWND hwnd)
{
	switch (ProtocolLanguage)
	{
		case german:
			SetWindowText(hwnd, "Bitte Passwort eingeben");
			SetDlgItemText(hwnd, IDOK, "&Ok");
			SetDlgItemText(hwnd, IDCANCEL, "&Abbruch");
			break;

		case english:
			SetWindowText(hwnd, "enter password");
			SetDlgItemText(hwnd, IDOK, "&ok");
			SetDlgItemText(hwnd, IDCANCEL, "&cancel");
			break;
	}
};

void TProtocolLanguage::SetParameterDlgLanguage(HWND hwnd)
{
	switch (ProtocolLanguage)
	{
		case german:
			SetWindowText(hwnd, "Protokollbuch Einstellungen");
			SetDlgItemText(hwnd, id_Warnung, "Diese Einstellungen sollten normalerweise NICHT gendert werden! Bitte lesen Sie dazu im Benutzerleitfaden den Abschnitt 'Protokollbuch Einstellungen'!");
			SetDlgItemText(hwnd, id_GruppeProtocolFile, "Protokolldatei");
			SetDlgItemText(hwnd, id_ProtoFileText, "Protokolldatei:");
			SetDlgItemText(hwnd, id_ProtoBackupPathText, "Backup-Verzeichnis:");
			SetDlgItemText(hwnd, id_GruppeSortParameter, "Sortierparameter");
			SetDlgItemText(hwnd, id_SortLfdNr, "Sortieren nach Lfd.-Nr.");
			SetDlgItemText(hwnd, id_SortDate, "Sortieren nach Datum");
			SetDlgItemText(hwnd, id_NoSortNew, "Neue Messungen NICHT sortieren");
			SetDlgItemText(hwnd, id_Durchsuchen, "Durchsuchen");
			SetDlgItemText(hwnd, IDOK, "&Ok");
			SetDlgItemText(hwnd, IDCANCEL, "&Abbruch");
			break;

		case english:
			SetWindowText(hwnd, "protocol parameter");
			SetDlgItemText(hwnd, id_Warnung, "These parameter should NOT be changed normally! Please you read the section 'Protokollbuch Einstellungen' in addition in the user manual!");
			SetDlgItemText(hwnd, id_GruppeProtocolFile, "protocol file");
			SetDlgItemText(hwnd, id_ProtoFileText, "protocol file");
			SetDlgItemText(hwnd, id_ProtoBackupPathText, "backup directory");
			SetDlgItemText(hwnd, id_GruppeSortParameter, "sort parameter");
			SetDlgItemText(hwnd, id_SortLfdNr, "sort according to lfd.-nr.");
			SetDlgItemText(hwnd, id_SortDate, "sort according to date");
			SetDlgItemText(hwnd, id_NoSortNew, "no sort new entry");
			SetDlgItemText(hwnd, id_Durchsuchen, "search");
			SetDlgItemText(hwnd, IDOK, "&ok");
			SetDlgItemText(hwnd, IDCANCEL, "&cancel");
			break;
	}
};

void TProtocolLanguage::TranslateParameter( HWND hwnd, int id )
{
	char buf[MaxString];

	GetDlgItemText(hwnd, id, buf, MaxString);
	SetDlgItemText(hwnd, id, TranslateParameter(buf));
};

LPCSTR TProtocolLanguage::TranslateParameter( LPCSTR Parameter )
{
	strcpy(lParameter, Parameter);
	switch (ProtocolLanguage)
	{
		case german:
			if (strcmp(lParameter, "start:") == 0)
				return strcpy(lParameter, "Start:");
			if (strcmp(lParameter, "end:") == 0)
				return strcpy(lParameter, "Ende:");
			if (strcmp(lParameter, "range:") == 0)
				return strcpy(lParameter, "Bereichsgre:");
			if (strcmp(lParameter, "minimum:") == 0)
				return strcpy(lParameter, "Minimum:");
			if (strcmp(lParameter, "maximum:") == 0)
				return strcpy(lParameter, "Maximum:");
			if (strcmp(lParameter, "step wide:") == 0)
				return strcpy(lParameter, "Schrittweite:");
			break;

		case english:
			if (strcmp(lParameter, "Start:") == 0)
				return strcpy(lParameter, "start:");
			if (strcmp(lParameter, "Ende:") == 0)
				return strcpy(lParameter, "end:");
			if (strcmp(lParameter, "Bereichsgre:") == 0)
				return strcpy(lParameter, "range:");
			if (strcmp(lParameter, "Minimum:") == 0)
				return strcpy(lParameter, "minimum:");
			if (strcmp(lParameter, "Maximum:") == 0)
				return strcpy(lParameter, "maximum:");
			if (strcmp(lParameter, "Schrittweite:") == 0)
				return strcpy(lParameter, "step wide:");
			break;

	}
	return Parameter;
};

void TProtocolLanguage::TabCtrl_SetItemText( HWND hTabCtrl, int iTab, LPCSTR TabText )
{
    TCITEM titem;
	char buf[MaxString];
	
	titem.mask= TCIF_TEXT;
	titem.pszText= buf;
    titem.cchTextMax= MaxString;
	titem.iImage= -1;

	strcpy(buf,TabText);
	TabCtrl_SetItem(hTabCtrl, iTab, &titem);
};

void TProtocolLanguage::ListView_SetColumnText( HWND hLVCtrl, int iCol, LPCSTR ColText )
{
    LV_COLUMN lvc;
	char buf[MaxString];

    // Initialize the LV_COLUMN structure. 
    lvc.mask= LVCF_TEXT | LVCF_FMT; 
    lvc.fmt= LVCFMT_LEFT; 
    lvc.pszText= buf; 

	lvc.iSubItem= iCol;
	strcpy(buf,ColText);
	ListView_SetColumn(hLVCtrl, iCol, &lvc);

	ListView_SetColumnWidth(hLVCtrl,iCol,LVSCW_AUTOSIZE_USEHEADER);
};


// LastLine
