//******************************************************************************
//Datei     : TProtocolPasswortDlg.cpp
//Projekt   : XCTL
//Subsystem : Protokollbuch
//Autor     : Jens Klier <klier@informatik.hu-berlin.de>
//            Institut fuer Informatik,
//            Humboldt-Universitaet Berlin
//Inhalt    : Implementation der Klasse TProtocolPasswortDlg
//******************************************************************************
//!neu klier Protokollbuch
#include "internls\evrythng.h"
#include "winresrc\rc_prtow.h" // Ressourcen-IDs
#include <commdlg.h>

#include "protocol\TProtocolLanguage.h"
#include "protocol\TProtocol.h"
#include "protocol\TProtocolDlg.h"
#include "protocol\TProtocolPasswortDlg.h"

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

extern TProtocolLanguage *ProtocolLanguage;
extern HINSTANCE hModuleInstance;

TProtocolPasswortDlg::TProtocolPasswortDlg(LPSTR Dlg, TProtocolDlg *ProtocolDlg) : \
		TModalDlg(Dlg,hModuleInstance), ProtocolDlg(ProtocolDlg)
{}
;


BOOL TProtocolPasswortDlg::Dlg_OnInit(HWND hwnd, HWND, LPARAM)
{
	strcpy(ProtocolDlg->Passwort, "");
	ProtocolLanguage->SetPasswortDlgLanguage(hwnd);
	return TRUE;
};

void TProtocolPasswortDlg::Dlg_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
	char buf[MaxString];

	switch (id)
	{
		case IDOK:
			GetDlgItemText(hwnd, id_Passwort, buf, MaxString);
			strcpy(ProtocolDlg->Passwort, buf);
			// Kullmann+Reinecker: Hier muss kein break hin, weiter bei TModalDlg::Dlg_OnCommand!

		default:
			TModalDlg::Dlg_OnCommand(hwnd, id, hwndCtl, codeNotify);
	}
};

// LastLine


