//******************************************************************************
//Datei     : TProtocolTopographyDlg.cpp
//Projekt   : XCTL
//Subsystem : Protokollbuch
//Autor     : Jens Klier <klier@informatik.hu-berlin.de>
//            Institut fuer Informatik,
//            Humboldt-Universitaet Berlin
//Inhalt    : Implementation der Klasse TProtocolTopographyDlg
//******************************************************************************
//!neu klier Protokollbuch
#include "internls\evrythng.h"
#include "winresrc\rc_prtow.h" // Ressourcen-IDs
#include <commdlg.h>
#include <commctrl.h>

#include "protocol\TProtocolLanguage.h"
#include "protocol\TProtocol.h"
#include "protocol\TProtocolTopography.h"
#include "protocol\TProtocolDlg.h"
#include "protocol\TProtocolTopographyDlg.h"
#include "protocol\TProtocolManagePrintDlg.h"
#include "protocol\TProtocolTopographyManagePrintDlg.h"

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

extern TProtocolLanguage *ProtocolLanguage;
extern TProtocolTopography *ProtocolTopography;
extern HINSTANCE hModuleInstance;

TModelessDlg *ProtoPrintDlg= 0; //! neu Kullmann+Reinecker: TheModeless ersetzt durch ProtoPrintDlg; extern entfernt

TProtocolTopographyDlg::TProtocolTopographyDlg(LPSTR Dlg, int idDlg) : TModalDlg(Dlg,hModuleInstance)
{
	Protocol= ProtocolTopography;
	ProtocolCombobox.InitializeManageComboboxProtocolDlg(Protocol);
	CurrentDlg= idDlg;
};


void TProtocolTopographyDlg::ShowDialog( int id , int idShow)
{
	int ButtonShow, TextShow;

	switch (idShow)
	{
		case SHOW:
			ButtonShow= HIDE;
			TextShow= SHOW;
			ShowDialog(CurrentDlg, HIDE);
			CurrentDlg= id;
			ProtocolTopography->SetCurrentDlg(id);
			RefreshDlg(hwndDlg, CurrentDlg);
			break;

		case HIDE:
			ButtonShow= SHOW;
			TextShow= HIDE;
			break;

		default:
			return;
	}

	switch (id)
	{
		case KollimatorRoehreDlg:
			if (idShow==SHOW) TabCtrl_SetCurSel(hTab, 0);
			ShowDlgItem( id_GruppeKollimator, idShow );
			ShowDlgItem( id_KMaterialText, idShow );
			ShowDlgItem( id_KReflexText, idShow );
			ShowDlgItem( id_KNrText, idShow );
			ShowDlgItem( id_KKruemmungText, idShow );
			ShowDlgItem( id_KMaterial, idShow );
			ShowDlgItem( id_KReflex, idShow );
			ShowDlgItem( id_KNr, idShow );
			ShowDlgItem( id_KKruemmung, idShow );
			ShowDlgItem( id_GruppeRoehre, idShow );
			ShowDlgItem( id_RMaterialText, idShow );
			ShowDlgItem( id_RStromText, idShow );
			ShowDlgItem( id_RSpannungText, idShow );
			ShowDlgItem( id_RMaterial, idShow );
			ShowDlgItem( id_RStrom, idShow );
			ShowDlgItem( id_RSpannung, idShow );
			ShowDlgItem( id_RStrom , idShow );
			ShowDlgItem( id_RImpMaxText, idShow );
			ShowDlgItem( id_RImpMax, idShow );
			ShowDlgItem( id_KKruemmungEinheit , idShow );
			ShowDlgItem( id_RStromEinheit, idShow );
			ShowDlgItem( id_RSpannungEinheit, idShow );
			break;

		case MessungFilmeDlg:
			if (idShow==SHOW) TabCtrl_SetCurSel(hTab, 1);
			ShowDlgItem( id_GruppeMessung, idShow );
			ShowDlgItem( id_GruppeFilme, idShow );
			ShowDlgItem( id_MImpMaxText, idShow );
			ShowDlgItem( id_MImpMax, idShow );
			ShowDlgItem( id_FAnzahlText, idShow );
			ShowDlgItem( id_MSpannungText, idShow );
			ShowDlgItem( id_MStromText, idShow );
			ShowDlgItem( id_HWBText, idShow );
			ShowDlgItem( id_PGroesseXText, idShow );
			ShowDlgItem( id_PGroesseYText, idShow );
			ShowDlgItem( id_FAnzahl, idShow );
			ShowDlgItem( id_MSpannung, idShow );
			ShowDlgItem( id_MStrom, idShow );
			ShowDlgItem( id_PGroesseX, idShow );
			ShowDlgItem( id_PGroesseY, idShow );
			ShowDlgItem( id_HWB, idShow );
			ShowDlgItem( id_FMaterialText, idShow );
			ShowDlgItem( id_FAbstandText, idShow );
			ShowDlgItem( id_FMaterial, idShow );
			ShowDlgItem( id_FAbstand, idShow );
			ShowDlgItem( id_FAbstandEinheit, idShow );
			ShowDlgItem( id_MStromEinheit, idShow );
			ShowDlgItem( id_MSpannungEinheit, idShow );
			ShowDlgItem( id_PGroesseEinheit, idShow );
			break;

		case BeginnMessungDlg:
			if (idShow==SHOW) TabCtrl_SetCurSel(hTab, 2);
			ShowDlgItem( id_GruppeBeginnMessung, idShow );
			ShowDlgItem( id_STEText, idShow );
			ShowDlgItem( id_STE, idShow );
			ShowDlgItem( id_CRTText, idShow );
			ShowDlgItem( id_CRT, idShow );
			ShowDlgItem( id_INCDFText, idShow );
			ShowDlgItem( id_INCDF, idShow );
			ShowDlgItem( id_NBEXPOSText, idShow );
			ShowDlgItem( id_NBEXPOS, idShow );
			ShowDlgItem( id_ABEText, idShow );
			ShowDlgItem( id_ABE, idShow );
			ShowDlgItem( id_RSAText, idShow );
			ShowDlgItem( id_RSA, idShow );
			ShowDlgItem( id_CONLIMITText, idShow );
			ShowDlgItem( id_CONLIMIT, idShow );
			ShowDlgItem( id_CONPOINTText, idShow );
			ShowDlgItem( id_CONPOINT, idShow );
			ShowDlgItem( id_EXPTText, idShow );
			ShowDlgItem( id_EXPT, idShow );
			ShowDlgItem( id_STEEinheit, idShow );
			ShowDlgItem( id_CRTEinheit, idShow );
			ShowDlgItem( id_ABEEinheit, idShow );
			ShowDlgItem( id_CONLIMITEinheit, idShow );
			ShowDlgItem( id_CONPOINTEinheit, idShow );
			ShowDlgItem( id_EXPTEinheit, idShow );
			ShowDlgItem( id_RSAEinheit, idShow );
			ShowDlgItem( id_INCDFEinheit, idShow );
			break;

		case EndeMessungDlg:
			if (idShow==SHOW) TabCtrl_SetCurSel(hTab, 3);
			ShowDlgItem( id_GruppeEndeMessung, idShow );
			ShowDlgItem( id_GruppeRegelung, idShow );
			ShowDlgItem( id_ImpsvorText, idShow );
			ShowDlgItem( id_Impsvor, idShow );
			ShowDlgItem( id_ImpsnachText, idShow );
			ShowDlgItem( id_Impsnach, idShow );
			ShowDlgItem( id_DFvorText, idShow );
			ShowDlgItem( id_DFvor, idShow );
			ShowDlgItem( id_DFnachText, idShow );
			ShowDlgItem( id_DFnach, idShow );
			ShowDlgItem( id_BemerkungText, idShow );
			ShowDlgItem( id_Bemerkung, idShow );
			break;
	}
};

void TProtocolTopographyDlg::InitializeDlgItems(HWND hwnd)
{
	hLfdNr= GetDlgItem( hwndDlg, id_LfdNr );
	hLfdNrBereich= GetDlgItem( hwndDlg, id_LfdNrBereich );
	hRTKNr= GetDlgItem( hwndDlg, id_RTKNr );

	ProtocolCombobox.InitializeCombobox(hwnd, hNutzerList, id_Nutzer, Nutzer, "Nutzer");
	ProtocolCombobox.InitializeCombobox(hwnd, hMaterialList, id_Material, Material, "Material");
	ProtocolCombobox.InitializeCombobox(hwnd, hLieferantList, id_Lieferant, Lieferant, "Lieferant");
	ProtocolCombobox.InitializeCombobox(hwnd, hKMaterialList, id_KMaterial, KMaterial, "KMaterial");
	ProtocolCombobox.InitializeCombobox(hwnd, hRMaterialList, id_RMaterial, RMaterial, "RMaterial");
};

void TProtocolTopographyDlg::SaveDlgItems(HWND hwnd)
{
	char buf[MaxString];

	GetDlgItemText(hwndDlg, id_LfdNrBereich, buf, MaxString);
	WritePrivateProfileString(Protocol->GetProtocolSection(), "LfdNrBereich", buf, GetCFile());
	GetDlgItemText(hwndDlg, id_RTKNr, buf, MaxString);
	WritePrivateProfileString(Protocol->GetProtocolSection(), "RTKNr", buf, GetCFile());

	ProtocolCombobox.SaveCombobox(hwnd, id_Nutzer, "Nutzer");
	ProtocolCombobox.SaveCombobox(hwnd, id_Lieferant, "Lieferant");
	ProtocolCombobox.SaveCombobox(hwnd, id_Material, "Material");
	ProtocolCombobox.SaveCombobox(hwnd, id_KMaterial, "KMaterial");
	ProtocolCombobox.SaveCombobox(hwnd, id_RMaterial, "RMaterial");
};

LPSTR TProtocolTopographyDlg::GetDlgItemText_LfdNr(HWND hwnd, LPSTR lLfdNr)
{
	char buf[MaxString], buf2[MaxString], buf3[MaxString];

	GetDlgItemText(hwnd, id_LfdNrBereich, buf, MaxString);
	GetDlgItemText(hwnd, id_LfdNr, buf2, MaxString);
	GetDlgItemText(hwnd, id_RTKNr, buf3, MaxString);
	sprintf(lLfdNr, "%s%s%s", buf, buf2, buf3);
	return lLfdNr;
};

BOOL TProtocolTopographyDlg::TestDlgItemText_LfdNr(HWND hwnd, LPSTR lLfdNr)
{
	char buf[MaxLfdNr], buf2[MaxLfdNr], buf3[MaxLfdNr];

	strcpy(lLfdNr, "");
	GetDlgItemText(hwnd, id_LfdNrBereich, buf, MaxLfdNr);
	GetDlgItemText(hwnd, id_LfdNr, buf2, MaxLfdNr);
	GetDlgItemText(hwnd, id_RTKNr, buf3, MaxLfdNr);
	if (ProtocolTopography->TestLfdNr(buf, buf2, buf3))
	{
		sprintf(lLfdNr, "%s%s%s", buf, buf2, buf3);
		return TRUE;
	}
	return FALSE;
};

void TProtocolTopographyDlg::EnableDlgItem_LfdNr(BOOL Status)
{
	EnableDlgItem(id_LfdNrBereich, Status);
	EnableDlgItem(id_LfdNr, Status);
	EnableDlgItem(id_RTKNr, Status);
};

BOOL TProtocolTopographyDlg::IsDlgItemModify(void)
{
	BOOL bEdit;

	bEdit= (Edit_GetModify(hLfdNrBereich) || Edit_GetModify(hLfdNr) || Edit_GetModify(hRTKNr));
	if (bEdit)
	{
		Edit_SetModify(hLfdNrBereich, 0);
		Edit_SetModify(hLfdNr, 0);
		Edit_SetModify(hRTKNr, 0);
	}
	return bEdit;
};

void TProtocolTopographyDlg::SetDlgItemText_LfdNr(HWND hwnd)
{
	char buf[MaxString];

	Edit_LimitText(hLfdNrBereich, 1);
	Edit_LimitText(hLfdNr, 5);
	Edit_LimitText(hRTKNr, 2);
	SetDlgItemText(hwnd, id_LfdNrBereich, ProtocolTopography->GetLfdNrBereich(buf));
	SetDlgItemText(hwnd, id_LfdNr, ProtocolTopography->GetLfdNrNummer(buf));
	SetDlgItemText(hwnd, id_RTKNr, ProtocolTopography->GetRTKNr(buf));
};

BOOL TProtocolTopographyDlg::Dlg_OnInit(HWND hwnd, HWND hwndCtl, LPARAM lParam)
{
    TCITEM titem;
	char buf[MaxString];
	int iTab=0;
	
	TProtocolDlg::Dlg_OnInit(hwnd, hwndCtl, lParam);

	titem.mask= TCIF_TEXT;
	titem.pszText= buf;
    titem.cchTextMax= MaxString;
	titem.iImage= -1;

    strcpy(buf,"Kollimator/Rhre");
	TabCtrl_InsertItem(hTab, iTab++, &titem);

    strcpy(buf,"Messung/Filme");
	TabCtrl_InsertItem(hTab, iTab++, &titem);

    strcpy(buf,"Beginn Messung");
	TabCtrl_InsertItem(hTab, iTab++, &titem);

    strcpy(buf,"Ende Messung");
	TabCtrl_InsertItem(hTab, iTab++, &titem);

	ProtocolLanguage->SetTopographyDlgLanguage(hwnd);

	return TRUE;
};

void TProtocolTopographyDlg::Dlg_OnDestroy( HWND hwnd )
{
	TProtocolDlg::Dlg_OnDestroy(hwnd);
};


BOOL TProtocolTopographyDlg::Dlg_OnSysCommand(HWND hwnd, int id, LPARAM lParam)
{
	RECT Rect;

	switch ( id )
	{
		case cm_ProtcolDeutsch:
		case cm_ProtcolEnglisch:
			ProtocolLanguage->SetTopographyDlgLanguage(hwnd, id);
			if ( ProtoPrintDlg )
			{
				_FREEOBJ(ProtoPrintDlg);
				GetClientRect( GetDlgItem(hwndDlg, id_Skizze), &Rect );
				ProtoPrintDlg= new TProtocolTopographyManagePrintDlg( "ProtocolTopographyManagePrintDlg", this, Rect.right, Rect.bottom, &ProtoPrintDlg );
				if ( ProtoPrintDlg )
					ProtoPrintDlg->Initialize( hModuleInstance, GetFrameHandle() );
				SetActiveWindow(hwnd);
			}
			return TRUE;
		
		default:
			return FALSE;
	}
};

void TProtocolTopographyDlg::Dlg_OnNotify(HWND hwnd, int message, UINT id, UINT wParam)
{
    int iTab;
	
    if ( message!=WM_NOTIFY || id!=id_Tab ) return;
	iTab=TabCtrl_GetCurFocus(hTab)+2;
	if (CurrentDlg!=iTab)
		switch ( iTab )
		{
			case KollimatorRoehreDlg:
			    SaveDlg( hwnd, CurrentDlg);
			    ShowDialog( KollimatorRoehreDlg, SHOW );
			    SetDlgItemText(hwnd, id_StatusLine, "Parameter Kollimator/Rhre");
				break;

			case MessungFilmeDlg:
			    SaveDlg( hwnd, CurrentDlg);
			    ShowDialog( MessungFilmeDlg, SHOW );
			    SetDlgItemText(hwnd, id_StatusLine, "Parameter Messung/Filme");
				break;

			case BeginnMessungDlg:
			    SaveDlg( hwnd, CurrentDlg);
			    ShowDialog( BeginnMessungDlg, SHOW );
			    SetDlgItemText(hwnd, id_StatusLine, "Parameter Beginn Messung");
				break;

			case EndeMessungDlg:
			    SaveDlg( hwnd, CurrentDlg);
			    ShowDialog( EndeMessungDlg, SHOW );
			    SetDlgItemText(hwnd, id_StatusLine, "Parameter Ende Messung");
				break;
		}
};

void TProtocolTopographyDlg::Dlg_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
	RECT Rect;

	if (TProtocolDlg::Dlg_OnCommand(hwnd, id, codeNotify))
		return;

	switch ( id )
	{
		case IDPRINT:
			if ( TestChangeDlg() )
				break;
			if ( !ProtoPrintDlg )
			{
				GetClientRect( GetDlgItem(hwndDlg, id_Skizze), &Rect );
				ProtoPrintDlg= new TProtocolTopographyManagePrintDlg( "ProtocolTopographyManagePrintDlg", this, Rect.right, Rect.bottom, &ProtoPrintDlg );
				if ( ProtoPrintDlg )
					ProtoPrintDlg->Initialize( hModuleInstance, GetFrameHandle() );
			}
			break;

		default:
			TModalDlg::Dlg_OnCommand(hwnd, id, hwndCtl, codeNotify);
	}
};

BOOL TProtocolTopographyDlg::TestPflichtDlg(HWND hwnd)
{
	if ( !ManageDlgItem(hwnd, id_Datum, Datum, DefaultTest) )
		return FALSE;
	if ( !ManageDlgItem(hwnd, id_ProbenNr, ProbenNr, DefaultTest) )
		return FALSE;
	if ( !ManageDlgItem(hwnd, id_Lieferant, Lieferant, DefaultTest) )
		return FALSE;
	if ( !ManageDlgItem(hwnd, id_Material, Material, DefaultTest) )
		return FALSE;
	if ( !ManageDlgItem(hwnd, id_Reflex, Reflex, DefaultTest) )
		return FALSE;
	if ( !ManageDlgItem(hwnd, id_Einfallswinkel, Einfallswinkel, DefaultTest) )
		return FALSE;
	return TRUE;
};

BOOL TProtocolTopographyDlg::ManageDlg(HWND hwnd, int id, TAction Action)
{
	switch (id)
	{
		case ProbeSkizzeDlg:
			if ( !ManageDlgItem(hwnd, id_Datum, Datum, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Nutzer, Nutzer, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_ProbenNr, ProbenNr, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Lieferant, Lieferant, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Merkmal, Merkmal, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Material, Material, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Winkel, Winkel, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_GroesseX, GroesseX, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_GroesseY, GroesseY, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Reflex, Reflex, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Einfallswinkel, Einfallswinkel, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Beugungswinkel, Beugungswinkel, Action) )
				return FALSE;
			break;

		case KollimatorRoehreDlg:
			if ( !ManageDlgItem(hwnd, id_KMaterial, KMaterial, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_KReflex, KReflex, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_KNr, KNr, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_KKruemmung, KKruemmung, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_RMaterial, RMaterial, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_RStrom, RStrom, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_RSpannung, RSpannung, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_RImpMax, ImpMax, Action) )
				return FALSE;
			break;

		case MessungFilmeDlg:
			if ( !ManageDlgItem(hwnd, id_MImpMax, MImpMax, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_MStrom, MStrom, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_MSpannung, MSpannung, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_HWB, HWB, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_FAnzahl, FAnzahl, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_FMaterial, FMaterial, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_PGroesseX, PGroesseX, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_PGroesseY, PGroesseY, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_FAbstand, FAbstand, Action) )
				return FALSE;
			break;

		case BeginnMessungDlg:
			if ( !ManageDlgItem(hwnd, id_STE, STE, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_CRT, CRT, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_INCDF, INCDF, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_NBEXPOS, NBEXPOS, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_ABE, ABE, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_RSA, RSA, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_CONLIMIT, CONLIMIT, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_CONPOINT, CONPOINT, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_EXPT, EXPT, Action) )
				return FALSE;
			break;

		case EndeMessungDlg:
			if ( !ManageDlgItem(hwnd, id_Impsvor, Impsvor, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Impsnach, Impsnach, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_DFvor, DFvor, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_DFnach, DFnach, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Bemerkung, Bemerkung, Action) )
				return FALSE;
			break;
	}
	SetFocus(GetDlgItem(hwnd, IDOK));
	return TRUE;
};

int TProtocolTopographyDlg::GetDlg(int id)
{
	switch (id)
	{
		case id_Datum:
		case id_Nutzer:
		case id_ProbenNr:
		case id_Lieferant:
		case id_Merkmal:
		case id_Material:
		case id_Winkel:
		case id_GroesseX:
		case id_GroesseY:
		case id_Reflex:
		case id_Einfallswinkel:
		case id_Beugungswinkel:
			return ProbeSkizzeDlg;

		case id_KMaterial:
		case id_KReflex:
		case id_KNr:
		case id_KKruemmung:
		case id_RMaterial:
		case id_RStrom:
		case id_RSpannung:
		case id_RImpMax:
			return KollimatorRoehreDlg;

		case id_MImpMax:
		case id_MStrom:
		case id_MSpannung:
		case id_HWB:
		case id_FAnzahl:
		case id_FMaterial:
		case id_PGroesseX:
		case id_PGroesseY:
		case id_FAbstand:
			return MessungFilmeDlg;

		case id_STE:
		case id_CRT:
		case id_INCDF:
		case id_NBEXPOS:
		case id_ABE:
		case id_RSA:
		case id_CONLIMIT:
		case id_CONPOINT:
		case id_EXPT:
			return BeginnMessungDlg;

		case id_Impsvor:
		case id_Impsnach:
		case id_DFvor:
		case id_DFnach:
		case id_Bemerkung:
			return EndeMessungDlg;
	}
	return -1;
};

int TProtocolTopographyDlg::GetStatusId( void )
{
	return Status;
};

int TProtocolTopographyDlg::GetDatumId( void )
{
	return Datum;
};

BOOL TProtocolTopographyDlg::CanClose(void)
{
	return TRUE;
};

void TProtocolTopographyDlg::Dlg_OnRButtonDown(HWND hwnd, UINT codeNotify1, int x, int y, UINT codeNotify2)
{
	TProtocolDlg::Dlg_OnRButtonDown(hwnd, codeNotify1, x, y, codeNotify2);
};

void TProtocolTopographyDlg::Dlg_OnLButtonDown(HWND hwnd, UINT codeNotify1, int x, int y, UINT codeNotify2)
{
	TProtocolDlg::Dlg_OnLButtonDown(hwnd, codeNotify1, x, y, codeNotify2);
};

void TProtocolTopographyDlg::Dlg_OnLButtonUp(HWND hwnd, int x, int y, UINT codeNotify)
{
	TProtocolDlg::Dlg_OnLButtonUp(hwnd, x, y, codeNotify);
};

void TProtocolTopographyDlg::Dlg_OnMouseMove(HWND hwnd, int x, int y, UINT codeNotify)
{
	TProtocolDlg::Dlg_OnMouseMove(hwnd, x, y, codeNotify);
};


// LastLine


