//******************************************************************************
//Datei     : TProtocolTopographyManagePrintDlg.cpp
//Projekt   : XCTL
//Subsystem : Protokollbuch
//Autor     : Jens Klier <klier@informatik.hu-berlin.de>
//            Institut fuer Informatik,
//            Humboldt-Universitaet Berlin
//Inhalt    : Implementation der Klasse TProtocolTopographyManagePrintDlg
//******************************************************************************
//!neu klier Protokollbuch
#include "internls\evrythng.h"
#include "winresrc\rc_prtow.h" // Ressourcen-IDs
#include <commdlg.h>
#include <commctrl.h>

#include "protocol\TProtocolLanguage.h"
#include "protocol\TProtocol.h"
#include "protocol\TProtocolDlg.h"
#include "protocol\TProtocolTopography.h"
#include "protocol\TProtocolTopographyDlg.h"
#include "protocol\TProtocolManagePrintDlg.h"
#include "protocol\TProtocolTopographyManagePrintDlg.h"

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

extern TProtocolLanguage *ProtocolLanguage;
extern TProtocolTopography *ProtocolTopography;
extern HINSTANCE hModuleInstance;

TProtocolTopographyManagePrintDlg::TProtocolTopographyManagePrintDlg(LPSTR Dlg, TProtocolTopographyDlg *ProtocolTopographyDlg, int x, int y, TModelessDlg **aRef) :
		TProtocolManagePrintDlg(Feldelemente, x, y), TModelessDlg(Dlg, aRef, hModuleInstance)
{
	Protocol= ProtocolTopography;
	ProtocolCombobox.InitializeManageComboboxProtocolDlg(Protocol);
	ProtocolDlg= ProtocolTopographyDlg;
};

BOOL TProtocolTopographyManagePrintDlg::Dlg_OnInit(HWND hwnd, HWND hwndCtl, LPARAM lParam)
{
    int iCol=0;
	char buf[MaxString];
 
	TProtocolManagePrintDlg::Dlg_OnInit(hwnd, hwndCtl, lParam);
	ProtocolCombobox.InitializeCombobox(hwnd, hLieferantList, id_PrnLieferant, Lieferant, "Lieferant");
	ProtocolCombobox.InitializeCombobox(hwnd, hMaterialList, id_PrnMaterial, Material, "Material");

    if (!PListView_InsertColumn(hSuchList, iCol++, ProtocolTopography->GetParameterNamen(LfdNr, buf))) 
            return FALSE; 
    if (!PListView_InsertColumn(hSuchList, iCol++, "-")) 
            return FALSE; 
    if (!PListView_InsertColumn(hSuchList, iCol++, ProtocolTopography->GetParameterNamen(RTKNr, buf))) 
            return FALSE; 
    if (!PListView_InsertColumn(hSuchList, iCol++, ProtocolTopography->GetParameterNamen(Datum, buf))) 
            return FALSE; 
    if (!PListView_InsertColumn(hSuchList, iCol++, ProtocolTopography->GetParameterNamen(ProbenNr, buf))) 
            return FALSE; 
    if (!PListView_InsertColumn(hSuchList, iCol++, ProtocolTopography->GetParameterNamen(Lieferant, buf))) 
            return FALSE; 
    if (!PListView_InsertColumn(hSuchList, iCol++, ProtocolTopography->GetParameterNamen(Material, buf))) 
            return FALSE; 

	ListView_SetExtendedListViewStyle(hSuchList, LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES );

	ProtocolLanguage->SetTopographyManagePrintDlgLanguage(hwnd);

	return TRUE;
};

void TProtocolTopographyManagePrintDlg::Dlg_OnNotify(HWND hwnd, int message, UINT id, UINT wParam)
{
    TProtocolManagePrintDlg::Dlg_OnNotify(hwnd, message, id, wParam);
};

void TProtocolTopographyManagePrintDlg::Dlg_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
	if (TProtocolManagePrintDlg::Dlg_OnCommand(hwnd, id, codeNotify))
		return;

	TModelessDlg::Dlg_OnCommand(hwnd, id, hwndCtl, codeNotify);
};

LPSTR TProtocolTopographyManagePrintDlg::GetDlgItemText_LfdNr( HWND hwnd, LPSTR lLfdNr )
{
	char buf[MaxString];

	GetDlgItemText(hwnd, id_PrnLfdNrBereich, lLfdNr, MaxString);
	GetDlgItemText(hwnd, id_PrnLfdNr, buf, MaxString);
	strcat(lLfdNr, buf);
	return lLfdNr;
};

void TProtocolTopographyManagePrintDlg::GetDlgItemText_SearchParameter( HWND hwnd, TSearchParameter SearchParameter )
{
	GetDlgItemText(hwnd, id_PrnRTKNr, SearchParameter[0], MaxString);
	GetDlgItemText(hwnd, id_PrnProbenNr, SearchParameter[1], MaxString);
	GetDlgItemText(hwnd, id_PrnLieferant, SearchParameter[2], MaxString);
	GetDlgItemText(hwnd, id_PrnMaterial, SearchParameter[3], MaxString);
};

BOOL TProtocolTopographyManagePrintDlg::SearchProtocolString( LPCSTR lLfdNr, const TSearchDate SearchDate, const TSearchParameter SearchParameter )
{
	return ProtocolTopography->SearchProtocolString(lLfdNr, SearchParameter[0], SearchDate[0], SearchDate[1],
			SearchParameter[1], SearchParameter[2], SearchParameter[3]);
};

void TProtocolTopographyManagePrintDlg::MakeListString( int iIndex )
{
	char buf[MaxString];
	int iCol=1;

	PListView_InsertItem(hSuchList, iIndex, ProtocolTopography->GetProtocolValue(LfdNr, buf));

	PListView_SetItemText(hSuchList, iIndex, iCol++, "-");
	PListView_SetItemText(hSuchList, iIndex, iCol++, ProtocolTopography->GetProtocolValue(RTKNr, buf));
	PListView_SetItemText(hSuchList, iIndex, iCol++, ProtocolTopography->GetProtocolValue(Datum, buf));
	PListView_SetItemText(hSuchList, iIndex, iCol++, ProtocolTopography->GetProtocolValue(ProbenNr, buf));
	PListView_SetItemText(hSuchList, iIndex, iCol++, ProtocolTopography->GetProtocolValue(Lieferant, buf));
	PListView_SetItemText(hSuchList, iIndex, iCol++, ProtocolTopography->GetProtocolValue(Material, buf));
};

int TProtocolTopographyManagePrintDlg::GetPages( int SelCount )
{
	int i;

	if (SelCount % 3 > 0)
		i= 1;
	else
		i= 0;
	return SelCount / 3 + i;
};

int TProtocolTopographyManagePrintDlg::GetColumn( void )
{
	return 4;
};

LPSTR TProtocolTopographyManagePrintDlg::GetSelLfdNr(LPSTR lLfdNr, int Index )
{
    char buf[MaxString];

    ListView_GetItemText(hSuchList,Index,0,buf,MaxString);
	strcpy(lLfdNr, buf);
    ListView_GetItemText(hSuchList,Index,2,buf,MaxString);
	strcat(lLfdNr, buf);
	return lLfdNr;
};

BOOL TProtocolTopographyManagePrintDlg::PrintSkizze(int i)
{
	if (i == Winkel)
		return TRUE;
	return FALSE;
};

BOOL TProtocolTopographyManagePrintDlg::PrintLine(int i)
{
	if ( (i == RTKNr) || (i == Nutzer) || (i == Material) || (i == Beugungswinkel) || \
			(i == KKruemmung) || (i == ImpMax) || (i == FAbstand) || (i == EXPT) || \
			(i == DFnach) || (i == HWB) )
		return TRUE;
	return FALSE;
};

void TProtocolTopographyManagePrintDlg::GetParameterName(int& i, LPSTR Parameter)
{
	ProtocolTopography->GetParameterNamen(i, Parameter);
	strcat(Parameter, ":");
};

BOOL TProtocolTopographyManagePrintDlg::GetParameter(int& i, LPSTR Parameter, LPCSTR lLfdNr)
{
	char ParameterValue[MaxParameterString];

	if ( strcmp(ProtocolTopography->GetLfdNr(ParameterValue), lLfdNr) != 0)
		if ( ProtocolTopography->LoadProtocolString(lLfdNr) != 0 )
			return FALSE;

	ProtocolTopography->GetProtocolValue( i, Parameter);
	if (strlen(Parameter) == 0)
		strcpy(Parameter, "-");

	if ( (i == GroesseX) || (i == PGroesseX) )
	{
		ProtocolTopography->GetProtocolValue( ++i, ParameterValue );
		if (strlen(ParameterValue) != 0)
		{
			strcat(Parameter, " x ");
			strcat(Parameter, ParameterValue);
		}
	}
	return TRUE;
};


// LastLine


